SystemOrganization addCategory: #'SqSquare-Core-Event'!
SystemOrganization addCategory: #'SqSquare-Core-Event-Concrete'!
SystemOrganization addCategory: #'SqSquare-Core-Board'!
SystemOrganization addCategory: #'SqSquare-Core-Serializer'!
SystemOrganization addCategory: #'SqSquare-Core-Exceptions'!
SystemOrganization addCategory: #'SqSquare-Core-Util'!
SystemOrganization addCategory: #'SqSquare-Core-Network-Connections'!
SystemOrganization addCategory: #'SqSquare-Core-Model'!
SystemOrganization addCategory: #'SqSquare-Core-Common'!
SystemOrganization addCategory: #'SqSquare-Core-Link'!
SystemOrganization addCategory: #'SqSquare-Core-Player'!
SystemOrganization addCategory: #'SqSquare-Core-Project'!
SystemOrganization addCategory: #'SqSquare-Core-Tests'!
SystemOrganization addCategory: #'SqSquare-Core-Widget'!

!ByteArray methodsFor: '*SqSquare-Core-converting' stamp: 'mu 3/2/2006 17:13'!
asPlayer
	^CObject fromCompactBytes: self! !

!ByteArray methodsFor: '*SqSquare-Core-converting' stamp: 'mu 3/13/2006 14:51'!
asRawBytes
	^SqUtil toByteArray: self! !

!ByteArray methodsFor: '*SqSquare-Core-converting' stamp: 'mu 3/7/2006 11:16'!
asSnappedPlayer
	^SqProjectSerializer deserialize: self! !

!ByteArray methodsFor: '*SqSquare-Core-converting' stamp: 'mu 5/9/2006 14:48'!
printHexAt: index to: aStream
	| map v |
	map := '0123456789ABCDEF'.
	v := self at: index.
	aStream nextPut: (map at: (v bitShift: -4) + 1). 
	aStream nextPut: (map at: (v bitAnd: 15) + 1).
! !

ByteArray variableByteSubclass: #SqAccessId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqAccessId class methodsFor: 'constants' stamp: 'mu 5/22/2006 18:13'!
defaultSize
	"imageId 6, boardId 6, userName 4..., total 16 bytes"
	^16! !

!SqAccessId class methodsFor: 'instance creation' stamp: 'mu 5/21/2006 22:32'!
fromBytes: bytes 
	| inst |
	inst _ super new: bytes size.
	^ inst
		replaceFrom: 1
		to: bytes size
		with: bytes! !

!SqAccessId class methodsFor: 'instance creation' stamp: 'minami 5/10/2006 12:14'!
fromString: byteString
	^self withAll: byteString asByteArray! !

!SqAccessId class methodsFor: 'instance creation' stamp: 'mu 5/22/2006 18:14'!
userSerial: userNum imageId: imageId boardId: boardId

	"imageId 6, boardId 6, userName 4..., total 16 bytes"

	| inst |
	inst _ self new: self defaultSize.
	inst userSerial: userNum.
	inst imageId: imageId.
	inst boardId: boardId.
	^inst! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 5/10/2006 11:48'!
boardId
	^SqUid withAll: (self copyFrom: 7 to: 12)! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:52'!
boardId: uid
	self replaceFrom: 7 to: 12 with: uid! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 5/10/2006 11:48'!
imageId
	^SqUid withAll: (self copyFrom: 1 to: 6)! !

!SqAccessId methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:52'!
imageId: uid
	self replaceFrom: 1 to: 6 with: uid! !

!SqAccessId methodsFor: 'printing' stamp: 'mu 5/22/2006 15:20'!
printOn: aStream
	aStream nextPutAll: '[' , self userSerial asString.
	aStream nextPut: $@.
	aStream nextPutAll: self imageId asString, ']'.! !

!SqAccessId methodsFor: 'serialization' stamp: 'minami 5/10/2006 11:57'!
readDataFrom: aDataStream size: varsOnDisk
	| bytes |
	aDataStream beginReference: self.

	bytes _ aDataStream next.
	"^bytes primitiveChangeClassTo: self"

	1 to: bytes size do:
		[:i | self basicAt: i put: (bytes at: i)].

	^self
	! !

!SqAccessId methodsFor: 'serialization' stamp: 'minami 5/10/2006 11:56'!
storeDataOn: aDataStream

	aDataStream
		beginInstance: self class
		size: self basicSize.

	"aDataStream nextPut: self copy asRawBytes"

	aDataStream nextPut: (ByteArray streamContents: [:str | str nextPutAll: self])! !

!SqAccessId methodsFor: 'accessing' stamp: 'mu 5/22/2006 14:44'!
userSerial
	^(self copyFrom: 13 to: 16) readStream nextInt32! !

!SqAccessId methodsFor: 'accessing' stamp: 'mu 5/22/2006 14:44'!
userSerial: anInteger
	| str bytes |
	str _ #(0 0 0 0) asByteArray writeStream.
 	str nextInt32Put: anInteger.
 	bytes _ str contents.

	self replaceFrom: 13 to: 16 with: bytes! !

ByteArray variableByteSubclass: #SqPackedBytes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqPackedBytes class methodsFor: 'examples' stamp: 'MU 2/15/2006 17:22'!
example1
	"SqPackedBytes example1"
	| form data inst |
	form _ Form fromUser.
	data _ form asCompactBytesCompressedOnDemand.
	inst _ SqPackedBytes type: #Form bytes: data.
	{data. inst} inspect! !

!SqPackedBytes class methodsFor: 'examples' stamp: 'MU 2/15/2006 17:28'!
example2
	"SqPackedBytes example2"
	| inst |
	inst _ SqPackedBytes fromObject: (Form fromUser).
	
	{inst. inst asObject} inspect! !

!SqPackedBytes class methodsFor: 'instance creation' stamp: 'mu 5/19/2006 16:26'!
fromBytes: bytes 
	| inst |
	inst _ super new: bytes size.
	^ inst
		replaceFrom: 1
		to: bytes size
		with: bytes! !

!SqPackedBytes class methodsFor: 'instance creation' stamp: 'MU 2/15/2006 17:23'!
fromObject: obj
	^self type: obj class name bytes: obj asCompactBytesCompressedOnDemand.! !

!SqPackedBytes class methodsFor: 'instance creation' stamp: 'MU 2/16/2006 11:53'!
type: className bytes: bytes
	| stream |
	stream _ WriteStream
				on: (ByteArray new: (bytes size + 10)).
	stream nextLittleEndianNumber: 1 put: className size.
	stream nextPutAll: className asByteArray.
	stream nextPutAll: bytes.
	^self withAll: stream contents.! !

!SqPackedBytes methodsFor: 'serialization' stamp: 'MU 2/15/2006 17:45'!
asObject
	| kls |
	kls _ Smalltalk at: self type ifAbsent: [^nil].
	^kls fromCompactBytes: self bytes uncompressOnDemand! !

!SqPackedBytes methodsFor: 'accessing' stamp: 'MU 2/15/2006 17:44'!
bytes
	| readStream size |
	readStream := self readStream.
	size := readStream nextLittleEndianNumber: 1.
	readStream skip: size.
	^ readStream upToEnd! !

!SqPackedBytes methodsFor: 'serialization' stamp: 'MU 2/15/2006 17:28'!
forReceive
	^self asObject! !

!SqPackedBytes methodsFor: 'objects from disk' stamp: 'mu 3/13/2006 15:51'!
readDataFrom: aDataStream size: varsOnDisk
	| bytes |
	aDataStream beginReference: self.

	bytes _ aDataStream next.
	"^bytes primitiveChangeClassTo: self"

	1 to: bytes size do:
		[:i | self basicAt: i put: (bytes at: i)].

	^self
	! !

!SqPackedBytes methodsFor: 'objects from disk' stamp: 'mu 3/13/2006 15:49'!
storeDataOn: aDataStream

	aDataStream
		beginInstance: self class
		size: self basicSize.

	"aDataStream nextPut: self copy asRawBytes"

	aDataStream nextPut: (ByteArray streamContents: [:str | str nextPutAll: self])! !

!SqPackedBytes methodsFor: 'accessing' stamp: 'MU 2/15/2006 17:43'!
type
	| readStream size typeBytes |
	readStream := self readStream.
	size := readStream nextLittleEndianNumber: 1.
	typeBytes := readStream next: size.
	^ typeBytes asString asSymbol! !

ByteArray variableByteSubclass: #SqUid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqUid class methodsFor: 'instance creation' stamp: 'mu 5/19/2006 15:46'!
fromBytes: bytes
	| inst |
	inst _ super new: bytes size.
	^inst replaceFrom: 1 to: bytes size with: bytes ! !

!SqUid class methodsFor: 'instance creation' stamp: 'mu 5/9/2006 13:07'!
fromString: aString
	| object |
	object := self basicNew: aString size // 2. 
	object asSqUid: aString.
	^object! !

!SqUid class methodsFor: 'instance creation' stamp: 'mu 5/9/2006 12:55'!
new
	^ self new: 6! !

!SqUid class methodsFor: 'instance creation' stamp: 'mu 5/9/2006 12:55'!
new: size
"
SqUid new: 6
"
	| maker bytes inst |
	maker _ SqUidMaker default digitSize: size; yourself.
	bytes _ maker nextValue.
	inst _ super new: size.
	^inst replaceFrom: 1 to: inst size with: bytes ! !

!SqUid class methodsFor: 'instance creation' stamp: 'mu 5/9/2006 13:10'!
nilUid
	^self basicNew: 6! !

!SqUid methodsFor: 'converting' stamp: 'mu 5/9/2006 13:08'!
asSqUid: aString
	| stream token byte |
	stream _ ReadStream on: aString asUppercase.
	1 to: stream size/2 do: [:i | 
		token _ stream next: 2.
		byte _ Integer readFrom: (ReadStream on: token ) base: 16.
		self at: i put: byte].
	^self
! !

!SqUid methodsFor: 'converting' stamp: 'mu 5/9/2006 13:00'!
asString

	| strValue result |
	strValue := String new: self size * 2.
	result := WriteStream on: strValue.
	1
		to: self size
		do: [:i | self printHexAt: i to: result].
	^ strValue! !

!SqUid methodsFor: 'initialize-release' stamp: 'mu 5/9/2006 12:35'!
makeUid
	SqUidMaker default generateBytes: self! !

!SharedQueue2 class methodsFor: '*SqSquare-Core' stamp: 'mu 3/8/2006 11:10'!
new: initSize
	^self basicNew initialize: (OrderedCollection new: initSize)! !

!SharedQueue2 methodsFor: '*SqSquare-Core-initialization' stamp: 'mu 3/7/2006 17:08'!
initialize: itemCollection
	monitor _ Monitor new.
	items _ itemCollection
! !

!SharedQueue2 methodsFor: '*SqSquare-Core-releasing' stamp: 'mu 3/7/2006 17:04'!
release
	"all #next waiting processes will get nil"
	monitor defaultQueue size timesRepeat: [self nextPut: nil.]! !

CRectanglePlayer subclass: #SqGroupingPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqGroupingPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="attachedPlayers" toSet="attachedPlayers:" changeEvent="attachedPlayersChanged">attachedPlayers</field>
</fields>'!

!SqGroupingPlayer class methodsFor: 'instance creation' stamp: 'minami 3/30/2006 09:47'!
fromUser
	| inst |
	inst := self new.
	inst open.
	inst fromUser.
	^ inst! !

!SqGroupingPlayer methodsFor: 'accessing' stamp: 'minami 4/3/2006 14:48'!
attachedPlayers
	"Answer the attachedPlayers of the receiver"
	<bewareOf: #attachedPlayersChanged>
	^self propertyValueAt: #attachedPlayers! !

!SqGroupingPlayer methodsFor: 'accessing' stamp: 'minami 4/3/2006 14:48'!
attachedPlayers: aValue
	"Modify the receiver's attachedPlayers"
	^self propertyValueAt: #attachedPlayers put: aValue with: #attachedPlayersChanged! !

!SqGroupingPlayer methodsFor: 'initialization' stamp: 'minami 4/3/2006 14:49'!
initialize
	super initialize.
	
	attachedPlayers := OrderedCollection new.! !

!SqGroupingPlayer methodsFor: 'testing' stamp: 'minami 3/30/2006 12:17'!
isComplexPlayer
	^ true! !

!SqGroupingPlayer methodsFor: 'initialization' stamp: 'minami 4/7/2006 15:15'!
setupCostume
	super setupCostume.

	self extent: 0@0.
	self layout: CProportionalLayout new.

! !

SqGroupingPlayer subclass: #SqPolygonGroupingPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqPolygonGroupingPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="lineColor" toSet="lineColor:" changeEvent="lineColorChanged">lineColor</field>
	<field toGet="lineWidth" toSet="lineWidth:" changeEvent="lineWidthChanged">lineWidth</field>
</fields>'!

!SqPolygonGroupingPlayer methodsFor: 'adding' stamp: 'minami 4/7/2006 14:02'!
addPlayers: players
	| tmpBounds |
	self waitTickIfOnDisplayedBoard.
	tmpBounds := self bounds.

	players do: [:p |
		| t b l r |
		t := ((p bounds top - tmpBounds top) / tmpBounds height) asFloat.
		b := ((p bounds bottom - tmpBounds top) / tmpBounds height) asFloat.
		l := ((p bounds left - tmpBounds left) / tmpBounds width) asFloat.
		r := ((p bounds right - tmpBounds left) / tmpBounds width) asFloat.
		p layoutFrame: (l@t corner: r@b).
		p hResizing: #spaceFill.
		p vResizing: #spaceFill.
		self add: p.
		self attachedPlayers add: p.
	].
	^ players
! !

!SqPolygonGroupingPlayer methodsFor: 'adding' stamp: 'minami 4/5/2006 13:37'!
addPlayer: aPlayer
	self addPlayers: { aPlayer }! !

!SqPolygonGroupingPlayer methodsFor: 'testing' stamp: 'minami 3/30/2006 15:27'!
containsPoint: aPoint 
	self costume contents
		do: [:each | (each containsPoint: aPoint)
				ifTrue: [^ true]].
	^ false
! !

!SqPolygonGroupingPlayer methodsFor: 'contents access' stamp: 'mu 4/4/2006 17:26'!
contentsInfo
	| col |
	col := OrderedCollection new.
	self elements do: [:each | col add: {each vertices. each bounds origin}].
	^ col.! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineColor
	"Answer the lineColor of the receiver"
	<bewareOf: #lineColorChanged>
	^self propertyValueAt: #lineColor! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineColor: aValue
	"Modify the receiver's lineColor"
	^self propertyValueAt: #lineColor put: aValue with: #lineColorChanged! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineWidth
	"Answer the lineWidth of the receiver"
	<bewareOf: #lineWidthChanged>
	^self propertyValueAt: #lineWidth! !

!SqPolygonGroupingPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 14:00'!
lineWidth: aValue
	"Modify the receiver's lineWidth"
	^self propertyValueAt: #lineWidth put: aValue with: #lineWidthChanged! !

!SqPolygonGroupingPlayer methodsFor: 'load/save' stamp: 'minami 3/30/2006 14:53'!
loadOnPlayerCreatedFrom: dic withArgs: args
	| contentsInfo polygons |
	super loadOnPlayerCreatedFrom: dic withArgs: args.

	self loadProperties: #(lineColor lineWidth) from: dic.

	contentsInfo := dic at: #contentsInfo ifAbsent: [].

	polygons := contentsInfo collect: [:infoArray |
		CPolygonPlayer new  
				vertices: infoArray first;
				color: self lineColor;
				borderWidth: self lineWidth;
				position: infoArray second;
				closed: false;
				yourself.
	].
	self addPlayers: polygons.! !

!SqPolygonGroupingPlayer methodsFor: 'load/save' stamp: 'minami 3/30/2006 14:38'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(lineColor lineWidth contentsInfo) into: dic 
	! !

SqGroupingPlayer subclass: #SqSelectionPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqSelectionPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="resizeHandle" toSet="resizeHandle:" changeEvent="resizeHandleChanged">resizeHandle</field>
</fields>'!

!SqSelectionPlayer class methodsFor: 'instance creation' stamp: 'minami 3/30/2006 15:34'!
fromUser
	| bounds |
	bounds _ Rectangle fromUser.
	^ self new extent: bounds extent;
		 openAt: bounds origin;
		 yourself! !

!SqSelectionPlayer methodsFor: 'menu' stamp: 'minami 5/17/2006 15:06'!
addGroupingMenuOn: aMenu
	| menu |
	menu := CMenu new.
	
	self coveredPlayers size < 1
		ifTrue: [menu add: 'group' target: self action: #group disabled: true]
		ifFalse: [menu add: 'group' target: self action: #group argument: #()].

	self attachedPlayers isEmptyOrNil 
		ifTrue: [menu add: 'ungroup' target: self action: #ungroup disabled: true]
		ifFalse: [menu add: 'ungroup' target: self action: #ungroup argument: #()].

	aMenu add: 'grouping' subMenu: menu.
	^aMenu! !

!SqSelectionPlayer methodsFor: 'adding' stamp: 'mu 5/9/2006 12:32'!
addPlayer: aPlayer
	| tfm |
	(self isIn: aPlayer) ifTrue: [^ aPlayer signal: #dropReject].

	tfm := self globalToLocal composedWithLocal: aPlayer localToGlobal.
	aPlayer transform: tfm.
	self add: aPlayer.

	aPlayer == self resizeHandle ifTrue: [^ self].

	self attachedPlayers add: aPlayer.

	self isRecording ifFalse: [^ self].
	self isOnAnyBoard ifFalse: [^ self].

	aPlayer hasPlayerId ifFalse: [
		aPlayer playerId: SqUid new.
		self attachEventRecordBehavior: aPlayer.
		self recordCreateEventFor: aPlayer.
		self waitTickIfOnDisplayedBoard.
		self recordDefaultStatus: aPlayer.
		self attachBoardPropertiesTo: aPlayer.
		aPlayer attacheAllContentsTo: self.
	].

	aPlayer signal: #dropAccept with: self.
	self signal: #contentsChanged.

! !

!SqSelectionPlayer methodsFor: 'handle' stamp: 'minami 4/18/2006 12:07'!
addResizeHandle

	| handle |
	handle := SqHandlePlayer new
					extent: 8@8; 
					yourself.
	self waitTick.
	handle target: self.

	self resizeHandle: handle.
	handle startPos: self hand position.! !

!SqSelectionPlayer methodsFor: 'adding' stamp: 'mu 4/4/2006 17:26'!
addSelectedPlayers
	| col |
	col _ OrderedCollection new.
	self container elements
		do: [:aPlayer | (self bounds containsRect: aPlayer bounds)
				ifTrue: [col add: aPlayer]].
	self addPlayers: col! !

!SqSelectionPlayer methodsFor: 'actions' stamp: 'minami 4/5/2006 13:39'!
attachBoardPropertiesTo: aPlayer
	aPlayer scale: 1.
! !

!SqSelectionPlayer methodsFor: 'actions' stamp: 'minami 4/5/2006 13:40'!
attachEventRecordBehavior: aPlayer
	| behavior |
	self eventRecordBoard ifNil: [^ self].

	behavior := self eventRecordBehaviorClass attachTo: aPlayer.
	behavior board: self eventRecordBoard.
! !

!SqSelectionPlayer methodsFor: 'actions' stamp: 'minami 4/5/2006 12:28'!
attacheAllContentsTo: boardOrSheet
	| elems |
	elems := self elements asArray.
	
	elems size to: 1 by: -1 do:[:i |
		| p |
		p := elems at: i.
		p hasPlayer 
			ifFalse: [self addPlayer: p]
			ifTrue: [
				p player isComplexPlayer ifTrue: [
					self addPlayer: p player.
					p player attacheAllContentsTo: self].
			].
	].
! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/7/2006 15:22'!
beTransparentColor
	self color: Color transparent.! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 3/30/2006 16:01'!
close
	self resizeHandle ifNotNilDo: [:h | h close].
	super close.! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/5/2006 14:00'!
coveredPlayers
	| col |
	col _ OrderedCollection new.
	self container elements
		do: [:aPlayer | 
			((aPlayer ~= self) 
				and: [self bounds containsRect: aPlayer bounds]
				and: [(aPlayer isKindOf: CHalo) not])
					ifTrue: [col add: aPlayer]].
	^ col! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 3/30/2006 15:51'!
destroy
	self resizeHandle ifNotNilDo: [:h | h destroy].
	super destroy.! !

!SqSelectionPlayer methodsFor: 'defaults' stamp: 'minami 4/5/2006 14:04'!
eventRecordBehaviorClass
	^ SqEventRecordBehavior! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/5/2006 14:58'!
findParent
	| current |
	current := self container.
	[current notNil] whileTrue: [
		(current isKindOf: SqEventRecordBoard) ifTrue: [^ current].
		(current isKindOf: EToysWorld) ifTrue: [^ current].

		current := current container.
	].

	^ nil! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/7/2006 14:47'!
focusTo: aPlayer
	self project halo target: aPlayer.
	self close.! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/7/2006 15:01'!
forcusToSelectedPlayers
	| attached covered |

	((attached := self attachedPlayers) isEmpty and: 
		[(covered := self coveredPlayers) isEmpty]) ifTrue: [
		
		^ self close.
	].

	covered size = 1 ifTrue: [
		^ self focusTo: covered first
	].

	self shrinkForSelectedPlayers: covered! !

!SqSelectionPlayer methodsFor: 'grouping' stamp: 'minami 4/7/2006 16:27'!
group
	| con covered |

	(con := self container) isBoard ifTrue: [
		con ifNil: [^ self].
		con addPlayer: self.
		self waitTickIfOnDisplayedBoard.
	].

	(covered := self coveredPlayers) size = 1 ifTrue: [
		^ self focusTo: self coveredPlayers first
	].

	(covered := self coveredPlayers) size >= 1 ifTrue: [
		covered do: [:p | self addPlayer: p]
	].

	self waitTickIfOnDisplayedBoard.
	self eventRecordBoard ifNotNil: [
		self eventRecordBoard addPlayer: self.
	].! !

!SqSelectionPlayer methodsFor: 'testing' stamp: 'minami 5/23/2006 14:07'!
hasPlayerOrElements
	^ self elements notEmpty! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 4/7/2006 15:21'!
initialize
	super initialize.
	
	self color: (Color gray alpha: 0.3).
	self borderWidth: 2.
	self borderColor: (Color darkGray alpha: 0.8).
! !

!SqSelectionPlayer methodsFor: 'events' stamp: 'minami 4/11/2006 17:11'!
onGeometryChanged
	<on: geometryChanged>
"
	self resizeHandle ifNil: [self close].
"! !

!SqSelectionPlayer methodsFor: 'events' stamp: 'minami 4/3/2006 14:20'!
onYellowButtonUp
	<on: yellowButtonUp>

	self selectionMenu open! !

!SqSelectionPlayer methodsFor: 'actions' stamp: 'minami 4/5/2006 13:40'!
recordCreateEventFor: aPlayer
	| evt  |
	self eventRecordBoard ifNil: [^ self].

	evt := SqPlayerEventFactory
				createEvent: #playerCreated
				target: aPlayer
				accessId: self eventRecordBoard accessId
				args: #().
	self eventRecordBoard recordEvent: evt.
! !

!SqSelectionPlayer methodsFor: 'actions' stamp: 'minami 5/22/2006 16:25'!
recordDefaultStatus: aPlayer
	| aBehavior |
	aBehavior := aPlayer eventRecordBehavior.

	aBehavior recordEvent: #flagsChanged.
	aBehavior recordEvent: #fillChanged.
	aBehavior recordEvent: #geometryChanged.
	aBehavior recordEvent: #borderChanged.
	aBehavior recordEvent: #textChanged.
	aBehavior recordEvent: #graphicChanged.
! !

!SqSelectionPlayer methodsFor: 'handle' stamp: 'minami 4/7/2006 15:08'!
removeResizeHandle
	| h |
	h := self resizeHandle: nil.
	self resizeHandle: nil.
	
	h ifNotNil: [
		h target: nil.
		h close.
	].
	! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 4/3/2006 15:36'!
resetAttachedPlayers
	self attachedPlayers: OrderedCollection new.! !

!SqSelectionPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 15:28'!
resizeHandle
	"Answer the resizeHandle of the receiver"
	<bewareOf: #resizeHandleChanged>
	^self propertyValueAt: #resizeHandle! !

!SqSelectionPlayer methodsFor: 'accessing' stamp: 'minami 3/30/2006 15:28'!
resizeHandle: aValue
	"Modify the receiver's resizeHandle"
	^self propertyValueAt: #resizeHandle put: aValue with: #resizeHandleChanged! !

!SqSelectionPlayer methodsFor: 'menu' stamp: 'minami 5/17/2006 15:06'!
selectionMenu
	| menu |
	menu := CMenu new.
	self addGroupingMenuOn: menu.
	^menu ! !

!SqSelectionPlayer methodsFor: 'initialization' stamp: 'minami 4/7/2006 15:21'!
setupCostume
	super setupCostume.

! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/7/2006 14:50'!
shrinkForSelectedPlayers
	self shrinkForSelectedPlayers: self coveredPlayers! !

!SqSelectionPlayer methodsFor: 'private' stamp: 'minami 4/7/2006 15:22'!
shrinkForSelectedPlayers: coveredPlayers
	| newBounds |
	newBounds := coveredPlayers first bounds.
	(coveredPlayers size >= 1)
		ifTrue: [coveredPlayers allButFirst do: [:p | newBounds := newBounds merge: p bounds]].

	newBounds := newBounds expandBy: 8@8.
	self bounds: newBounds.

	self beTransparentColor! !

!SqSelectionPlayer methodsFor: 'grouping' stamp: 'minami 4/7/2006 13:57'!
ungroup
	| parent |
	self container class == self class ifTrue: [^ self container ungroup].
	
	parent := self findParent.

	attachedPlayers shallowCopy do: [:p |
		| newPos |
		newPos := p globalPosition - parent globalBounds topLeft.
		
		self remove: p.

		p position: newPos.
		parent add: p.
	].

	self signal: #ungroup.
	self waitTickIfOnDisplayedBoard.
	self resetAttachedPlayers.
	self close.
	! !

!Association methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:35'!
isAssociation
	^true! !

!CEncoder methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 5/16/2006 14:49'!
playerIds
	litSet ifNil: [^#()].
	^litSet keys select: [:e | e isString and: [e size = 25]]! !

!Object class methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/14/2006 16:31'!
fromCompactBytes: bytes
	| rawBytes |
	rawBytes _ bytes uncompressOnDemand.
	^RmtStreamer unstream: rawBytes by: #DataStream! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/8/2006 16:21'!
asCompactBytes
	"Default is not so compact"
	^RmtStreamer stream: self 
	! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/14/2006 16:13'!
asCompactBytesCompressedOnDemand
	^self asCompactBytes compressIfMoreThan: SqSettings compressThreshold
	! !

!Object methodsFor: '*SqSquare-Core-releasing' stamp: 'MU 2/10/2006 15:04'!
destroy
	self release! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/15/2006 17:01'!
forReceive
	^self! !

!Object methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/15/2006 17:00'!
forSend
	^self! !

!Object methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:36'!
isAssociation
	^false! !

!Object methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:33'!
isAssociationCollection
	^false! !

!Object methodsFor: '*SqSquare-Core-testing' stamp: 'mu 6/2/2006 16:44'!
isAuthentication
	^false! !

!Object methodsFor: '*SqSquare-Core-testing' stamp: 'minami 5/23/2006 16:59'!
isTickMessageSend
	^ false! !

!Object methodsFor: '*SqSquare-Core-Scripting-Extensions-override' stamp: 'minami 5/9/2006 16:39'!
makeTicking: scriptDescriptor withArguments: args at: frequency
	"If no trigger is given, the script is evaluated exactly once"
	| script |
	script := self findScript: scriptDescriptor withArguments: args.
	(script == nil or:[script isTickingScript not]) ifTrue:[
		"Create a new script"
		script := scriptDescriptor asTickMessageIn: self arguments: args.
		script eventSpec: (Array with: self with: #ticking).
	] ifFalse:[
		script pauseScript.
	].
	script frequency: frequency.
	self privateAddScript: script.
	self signal: #scriptStatusChanged with: script selector with: #ticking.
	^script! !

!Object methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 14:29'!
originalClass
	^ self isUniClass
		ifTrue: [self isBehavior
				ifTrue: [| className | 
					className := (self originalClassName readStream upTo: Character space) asSymbol.
					(Smalltalk at: className) class]
				ifFalse: [Smalltalk at: self originalClassName]]
		ifFalse: [self class]! !

!Object methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 14:24'!
originalClassName
	^ ((self isUniClass)
		ifTrue: [self className copyFrom: 2 to: self className size]
		ifFalse: [self className]) asSymbol! !

!Object methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 14:41'!
originalTheNonMetaClassName
	^ (self originalClassName readStream upTo: Character space) asSymbol! !

!Object methodsFor: '*SqSquare-Core-override' stamp: 'minami 2/27/2006 04:50'!
printString
	"Answer a String whose characters are a description of the receiver. 
	If you want to print without a character limit, use fullPrintString."

	^ self printStringLimitedTo: 100000! !

!Object methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:52'!
readMementoFieldsFrom: deserializer	
	"If not player, just read self normally"
	^self readFieldsFrom: deserializer! !

!Object methodsFor: '*SqSquare-Core-Scripting-Extensions-override' stamp: 'minami 5/23/2006 17:05'!
signalEvent: anEvent
	"Signal the occurance of anEvent"

	| current more signaler times |

	current := thisContext sender.
	signaler := #normal.
	more := true.
	times := 30.
	[more 
		and: [(times := times - 1) > 0] 
		and: [(current := current sender) notNil]] whileTrue: [
		
		(current receiver isTickMessageSend) ifTrue: [
			signaler := #tick.
			more := false
		].
	].
	anEvent signaler: signaler.

	^self privateSignalEvent: anEvent! !

!Object methodsFor: '*SqSquare-Core-Scripting-Extensions-override' stamp: 'minami 4/27/2006 14:44'!
startScript: aScriptDescriptor withArguments: args when: aTrigger
	"Evaluate the given script whenever the trigger becomes active."
	| script spec |
	script := aScriptDescriptor asAsyncScriptMessageIn: self arguments: args.
	self privateAddScript: script.
	self signal: #scriptStatusChanged with: script selector with: #started.
	aTrigger ifNil:[^script valueWithEvent: ScriptEvent new].
	spec := aTrigger asEventSpecificationIn: self.
	spec ifNil:[^script valueWithEvent: ScriptEvent new].
	"Note: Normally, we should be able to just do a pauseScript/resumeScript here. 
	However, this would dump any existing event queue in the async scripts which
	may already contain events."
	1 to: spec size by: 2 do:[:i|
		(spec at: i) on: (spec at: i+1) notify: script.
	].
	script eventSpec size = 0
		ifTrue:[script eventSpec: spec]
		ifFalse:[script eventSpec: script eventSpec, spec].
	^script! !

!Object methodsFor: '*SqSquare-Core-Scripting-Extensions-override' stamp: 'minami 5/9/2006 16:18'!
startTicking: scriptDescriptor withArguments: args at: frequency
	"If no trigger is given, the script is evaluated exactly once"
	| script |
	script := self makeTicking: scriptDescriptor withArguments: args at: frequency.
	script resumeScript.
	self signal: #scriptStatusChanged with: script selector with: #started.
	^script! !

!Object methodsFor: '*SqSquare-Core-override' stamp: 'mu 5/11/2006 14:04'!
waitTick
	Processor activeProject ifNil: [^self].
	^Processor activeProject waitUntil: #tick.! !

!Object methodsFor: '*SqSquare-Core-scripting' stamp: 'minami 4/7/2006 13:48'!
waitTickIf: aBlock
	aBlock value ifTrue: [self waitTick]! !

!Object methodsFor: '*SqSquare-Core-override' stamp: 'mu 6/2/2006 12:17'!
writeFieldsOn: aSerializer
	"Write the fields of the receiver on the given serializer."
	| ivNames |
	ivNames := self class allInstVarNames.
	1 to: ivNames size do:[:i|
		aSerializer writeField: (ivNames at: i) value: (self instVarAt: i).
	].
	self class isVariable ifFalse:[^self].
	1 to: self basicSize do:[:i|
		aSerializer writeField: i asString value: (self basicAt: i).
	].! !

!Object methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:53'!
writeMementoFieldsOn: serializer
	"If not player, just serialize self normally"
	^self writeFieldsOn: serializer! !

Object subclass: #SqAbstractConnection
	instanceVariableNames: 'connector acceptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:14'!
acceptor
	^acceptor! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:14'!
acceptor: aAcceptor 
	acceptor := aAcceptor! !

!SqAbstractConnection methodsFor: 'actions' stamp: 'MU 3/1/2006 10:29'!
close
	connector ifNotNilDo: [:con | con close].
	acceptor ifNotNilDo: [:acc | acc close].

	connector _ acceptor _ nil

! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'mu 12/29/2005 00:33'!
connector
	^connector! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 12:02'!
connector: aConnector 
	connector := aConnector! !

!SqAbstractConnection methodsFor: 'actions' stamp: 'mu 5/21/2006 22:17'!
deferSend: aMessage 
	self connector
		ifNotNilDo: [:con | con isConnected
				ifTrue: [con command: aMessage encoder: #compactBytes]
				ifFalse: [self close]]! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:13'!
handler
	^self acceptor ifNotNilDo: [:acc | acc handler].! !

!SqAbstractConnection methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:13'!
handler: aBlock
	self acceptor ifNotNilDo: [:acc | acc handler: aBlock].! !

!SqAbstractConnection methodsFor: 'testing' stamp: 'mu 12/29/2005 00:37'!
isConnected
	^self connector notNil
		and: [self connector isConnected]! !

!SqAbstractConnection methodsFor: 'testing' stamp: 'minami 1/13/2006 10:40'!
isReady
	^ acceptor notNil
		and: [acceptor isReady]! !

!SqAbstractConnection methodsFor: 'testing' stamp: 'minami 1/13/2006 10:40'!
isValid
	^ self isConnected and: [self isReady]! !

!SqAbstractConnection methodsFor: 'printing' stamp: 'minami 1/12/2006 13:18'!
printOn: aStream
	super printOn: aStream.
	connector ifNotNilDo: [:con | aStream nextPutAll:' connector: '; nextPutAll: con asString].
	acceptor ifNotNilDo: [:acc | aStream nextPutAll:' acceptor: '; nextPutAll: acc asString].
	! !

!SqAbstractConnection methodsFor: 'actions' stamp: 'mu 5/21/2006 22:17'!
send: aMessage 
	self connector
		ifNotNilDo: [:con | con isConnected
				ifTrue: [con command: aMessage encoder: #compactBytes;
						 flush]
				ifFalse: [self close]]! !

SqAbstractConnection subclass: #SqExternalConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqExternalConnection class methodsFor: 'instance creation' stamp: 'MU 3/1/2006 10:17'!
connect: ipAddressOrHost forSend: portNumber forReturn: backPort do: returnDoBlock accessId: accessId 
	| inst |
	inst := self new
				connect: ipAddressOrHost
				forSend: portNumber
				forReturn: backPort
				accessId: accessId.
	inst handler: returnDoBlock.
	^ inst! !

!SqExternalConnection class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 16:59'!
connect: ipAddressOrHost to: portNumber returnDo: returnDoBlock 
	"SqExternalConnection connect: 'localhost' to: 12345 returnDo: [:msg |
	Transcript cr; show: '#return: ', msg]"
	^ self
		connect: ipAddressOrHost
		to: portNumber
		returnDo: returnDoBlock
		accessId: UUID new! !

!SqExternalConnection class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 16:57'!
connect: ipAddressOrHost to: portNumber returnDo: returnDoBlock accessId: accessId
	"SqExternalConnection connect: 'localhost' to: 12345 returnDo: [:msg | Transcript cr; show: '#return: ', msg] "
	^ self
		connect: ipAddressOrHost
		forSend: portNumber
		forReturn: portNumber + 1
		do: returnDoBlock
		accessId: accessId! !

!SqExternalConnection class methodsFor: 'utility' stamp: 'MU 2/15/2006 18:03'!
purgeAll
	self allInstancesDo: [:each | each close]! !

!SqExternalConnection methodsFor: 'accessing' stamp: 'mu 12/28/2005 18:25'!
acceptor
	^acceptor! !

!SqExternalConnection methodsFor: 'defaults' stamp: 'minami 1/19/2006 11:57'!
connectorClass
	^ SqConnector! !

!SqExternalConnection methodsFor: 'initialize-release' stamp: 'MU 1/20/2006 19:49'!
connect: ipAddressOrHost forSend: portNumber forReturn: backPort accessId: accessId 
	connector := self connectorClass
				connect: ipAddressOrHost
				port: portNumber
				accessId: accessId.
	acceptor := (self connectorClass
				connect: ipAddressOrHost
				port: backPort
				accessId: accessId) asAcceptor! !

!SqExternalConnection methodsFor: 'accessing' stamp: 'mu 12/28/2005 18:40'!
handler
	^self acceptor ifNotNilDo: [:acc | acc handler].! !

!SqExternalConnection methodsFor: 'accessing' stamp: 'mu 12/28/2005 18:40'!
handler: aBlock
	self acceptor ifNotNilDo: [:acc | acc handler: aBlock].! !

SqAbstractConnection subclass: #SqPassiveConnection
	instanceVariableNames: 'accessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

SqPassiveConnection class
	instanceVariableNames: 'serviceForReceiveDict serviceForReturnDict incomingConnectionDict'!

!SqPassiveConnection class methodsFor: 'actions' stamp: 'minami 1/13/2006 15:03'!
closeAll
	"SqPassiveConnection closeAll"
	incomingConnectionDict valuesDo: [:con | con close].
	incomingConnectionDict _ Dictionary new.! !

!SqPassiveConnection class methodsFor: 'actions' stamp: 'minami 1/13/2006 15:03'!
closeUnconnected
	"SqPassiveConnection closeUnconnected"
	incomingConnectionDict valuesDo: [:con | con isValid ifFalse: [con close]].
	incomingConnectionDict keysAndValuesRemove: [:accessId :con | con isValid not]! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'minami 1/12/2006 13:22'!
connections
	^ incomingConnectionDict values select: [:con | con isValid].
	! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'minami 1/17/2006 11:04'!
incomingConnectionDict
	^incomingConnectionDict! !

!SqPassiveConnection class methodsFor: 'class initialization' stamp: 'minami 1/12/2006 13:26'!
initialize
	"SqPassiveConnection initialize"
	serviceForReceiveDict _ serviceForReturnDict _  nil.

	incomingConnectionDict _ Dictionary new.! !

!SqPassiveConnection class methodsFor: 'testing' stamp: 'mu 3/9/2006 16:58'!
isRunningAt: listenPortNumber
	| service |
	service _ self serviceForReceiveDict at: listenPortNumber ifAbsent: [^false].
	^service isRunning! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'MU 1/20/2006 18:28'!
listenOn: portNumber acceptorClass: anAcceptorClass
	"SqPassiveConnection listenOn: 12345 receiveDo: [:msg | Transcript cr; show: '#received: ', msg] "
	^self listenOn: portNumber forReturn: portNumber + 1 acceptorClass: anAcceptorClass! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'MU 3/1/2006 10:18'!
listenOn: listenPortNumber forReturn: backPortNumber acceptorClass: anAcceptorClass
	 | serviceForReceive serviceForReturn |
	serviceForReceive _  self serviceForReceiveDict at: listenPortNumber ifAbsentPut: [
		((SqTcpService on: listenPortNumber) acceptorClass: anAcceptorClass) 
	].
	serviceForReceive start.

	serviceForReturn _ self serviceForReturnDict at: backPortNumber ifAbsentPut: [
	 	((SqTcpService on: backPortNumber) acceptorClass: SqAcceptor) 
	].
	serviceForReturn start.

	serviceForReceive 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			inst acceptor: newAcc.
	].

	serviceForReturn 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			inst connector: newAcc asConnector.
	]
! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'MU 3/1/2006 10:18'!
listenOn: listenPortNumber forReturn: backPortNumber do: aBlock
	 | serviceForReceive serviceForReturn |
	serviceForReceive _  self serviceForReceiveDict at: listenPortNumber ifAbsentPut: [
		((SqTcpService on: listenPortNumber) acceptorClass: SqAcceptor) 
	].
	serviceForReceive start.

	serviceForReturn _ self serviceForReturnDict at: backPortNumber ifAbsentPut: [
	 	((SqTcpService on: backPortNumber) acceptorClass: SqAcceptor) 
	].
	serviceForReturn start.

	serviceForReceive 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			newAcc handler: [:msg | aBlock value: msg].
			inst acceptor: newAcc.
	].

	serviceForReturn 
		onAccepted: [:newAcc | | inst |
			inst _ incomingConnectionDict 
						at: newAcc accessId 
						ifAbsentPut: [self with: newAcc accessId].
			inst connector: newAcc asConnector.
	]
! !

!SqPassiveConnection class methodsFor: 'listening' stamp: 'mu 12/29/2005 00:43'!
listenOn: portNumber receiveDo: receivedDoBlock 
	"SqPassiveConnection listenOn: 12345 receiveDo: [:msg | Transcript cr; show: '#received: ', msg] "
	^self listenOn: portNumber forReturn: portNumber + 1 do: receivedDoBlock! !

!SqPassiveConnection class methodsFor: 'utility' stamp: 'MU 2/15/2006 18:04'!
purgeAll
	self allInstancesDo: [:each | each close]! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:56'!
serviceForReceiveDict
	serviceForReceiveDict ifNil: [serviceForReceiveDict _ Dictionary new].
	^serviceForReceiveDict! !

!SqPassiveConnection class methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:57'!
serviceForReturnDict
	serviceForReturnDict ifNil: [serviceForReturnDict _ Dictionary new].
	^serviceForReturnDict! !

!SqPassiveConnection class methodsFor: 'actions' stamp: 'minami 1/13/2006 15:04'!
stopListening
	self serviceForReceiveDict valuesDo: [:each | each stop].
	self serviceForReturnDict valuesDo: [:each | each stop].

	self closeAll.

	self initialize! !

!SqPassiveConnection class methodsFor: 'instance creation' stamp: 'minami 1/13/2006 14:14'!
with: aSqAccessId 
	^ self new accessId: aSqAccessId;
		 yourself! !

!SqPassiveConnection methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:18'!
accessId
	^ accessId! !

!SqPassiveConnection methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:18'!
accessId: aSqAccessId
	accessId _ aSqAccessId! !

Object subclass: #SqAccessIdOld
	instanceVariableNames: 'userId imageId boardId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqAccessIdOld class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 15:16'!
userId: userName imageId: imageUUID boardId: boardUUID
	^ self new userId: userName;
		 imageId: imageUUID;
		 boardId: boardUUID;
		 yourself! !

!SqAccessIdOld methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:15'!
boardId
	^ boardId! !

!SqAccessIdOld methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:15'!
boardId: uuid
	boardId _ uuid! !

!SqAccessIdOld methodsFor: 'comparing' stamp: 'minami 1/23/2006 10:31'!
hash
	^ (self userId hash bitXor: self imageId hash) bitXor: self boardId hash! !

!SqAccessIdOld methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:53'!
imageId
	^ imageId! !

!SqAccessIdOld methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:54'!
imageId: uuid
	imageId _ uuid! !

!SqAccessIdOld methodsFor: 'printing' stamp: 'minami 1/13/2006 14:40'!
printOn: aStream
	aStream nextPutAll: '[' , self userId asString.
	aStream nextPut: $@.
	aStream nextPutAll: self imageId asString, ']'.! !

!SqAccessIdOld methodsFor: 'serialization' stamp: 'mu 5/9/2006 13:13'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.


	userId _ aDataStream next.
	boardId _ (aDataStream next ifNotNilDo: [:str | str asSqUid]).
	imageId _ (aDataStream next ifNotNilDo: [:str | str asSqUid]).

	! !

!SqAccessIdOld methodsFor: 'serialization' stamp: 'mu 3/8/2006 17:04'!
storeDataOn: aDataStream
	aDataStream
		beginInstance: self class
		size: 3.
	aDataStream nextPut: userId asString.
	aDataStream nextPut: boardId asString.
	aDataStream nextPut: imageId asString.
	! !

!SqAccessIdOld methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:53'!
userId
	^ userId! !

!SqAccessIdOld methodsFor: 'accessing' stamp: 'minami 1/13/2006 13:55'!
userId: aString
	userId _ aString! !

!SqAccessIdOld methodsFor: 'comparing' stamp: 'MU 2/6/2006 16:24'!
= other 
	self class = other class ifFalse: [^false].

	^ self userId = other userId
		and: [self imageId = other imageId]
		and: [self boardId = other boardId]! !

Object subclass: #SqAuthentication
	instanceVariableNames: 'timeStamp role userId serialNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqAuthentication class methodsFor: 'instance creation' stamp: 'mu 5/22/2006 13:53'!
userId: str serialNumber: number 
	^ self new userId: str;
		 serialNumber: number! !

!SqAuthentication methodsFor: 'initialize-release' stamp: 'mu 10/20/2005 22:48'!
initialize
	timeStamp _ DateAndTime current! !

!SqAuthentication methodsFor: 'testing' stamp: 'mu 12/14/2005 19:56'!
isAdmin
	^self role == #administrator! !

!SqAuthentication methodsFor: 'testing' stamp: 'mu 6/2/2006 16:44'!
isAuthentication
	^true! !

!SqAuthentication methodsFor: 'printing' stamp: 'minami 1/26/2006 17:25'!
printOn: aStream
	aStream nextPutAll: 'auth'.
	aStream nextPut: $[.
	aStream nextPutAll: self userId.
	aStream nextPut: $]! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/14/2005 19:53'!
role
	^ role.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/14/2005 19:53'!
role: anObject
	role := anObject.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 5/22/2006 13:52'!
serialNumber
	serialNumber ifNil: [serialNumber _ 0].
	^ serialNumber.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 5/22/2006 13:53'!
serialNumber: anInteger
	serialNumber := anInteger.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'mu 12/14/2005 15:33'!
timeStamp
	^timeStamp! !

!SqAuthentication methodsFor: 'accessing' stamp: 'MU 1/24/2006 11:45'!
userId
	^ userId.
! !

!SqAuthentication methodsFor: 'accessing' stamp: 'MU 1/24/2006 11:51'!
userId: str
	userId := str.
! !

Object subclass: #SqCSVLineParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqCSVLineParser class methodsFor: 'examples' stamp: 'mu 1/11/2006 12:04'!
ex01
"
	self ex01
"

	| parser aString |
	aString := 'aaa,bbb,"ccc1, ccc2",ddd'.

	parser := SqCSVLineParser new.
	^ parser parse: aString.! !

!SqCSVLineParser class methodsFor: 'examples' stamp: 'mu 1/11/2006 12:04'!
ex02
"
	self ex02
"

	| parser aString |
	aString := 'aaa,bbb,"ccc1, ccc2",ddd'.

	parser := SqCSVLineParser new.
	^ parser parse: aString ignoreSize: 1.! !

!SqCSVLineParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:47'!
ex03
"
	self ex03
"

	| parser aString headers |
	aString := 'aaa,bbb,"ccc1, ccc2",ddd'.
	headers := #(AA BB CC DD).

	parser := self new.
	^ parser parse: aString headers: headers.
! !

!SqCSVLineParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:47'!
ex04
"
	self ex04
"

	| parser aString headers |
	aString := 'aaa,bbb,ccc,ddd'.
	headers := #(BB CC DD).

	parser := self new.
	^ parser parse: aString ignoreSize: 1 headers: headers
! !

!SqCSVLineParser methodsFor: 'parse' stamp: 'minami 6/12/2005 21:06'!
parse: aString 
	^ self parse: aString ignoreSize: 0! !

!SqCSVLineParser methodsFor: 'util' stamp: 'minami 6/12/2005 21:07'!
parse: aString headers: headers
	^ self parse: aString ignoreSize: 0 headers: headers! !

!SqCSVLineParser methodsFor: 'parse' stamp: 'minami 6/12/2005 20:26'!
parse: aString ignoreSize: ignoreSize

	| wordStream words comma quota notDelimitter readStream |
	comma := $,.
	quota := $".
	words := OrderedCollection new.
	readStream := aString readStream.
	wordStream := '' writeStream.

	notDelimitter := true.
	[readStream atEnd] whileFalse: [
		| char | 
		char := readStream next.
		char == quota
			ifTrue: [notDelimitter := notDelimitter not]
			ifFalse: [(notDelimitter and: [char == comma])
						ifTrue: [
							wordStream close.
							words add: wordStream contents.
							wordStream := '' writeStream]
						ifFalse: [wordStream nextPut: char]]].
	wordStream close.
	words add: wordStream contents.
	readStream close.

	^ words allButFirst: ignoreSize! !

!SqCSVLineParser methodsFor: 'util' stamp: 'minami 6/12/2005 21:08'!
parse: aString ignoreSize: ignoreSize headers: headers
	| words dic |
	words := self parse: aString ignoreSize: ignoreSize.

	dic := Dictionary new.
	words with: headers do: [:word :header | dic at: header put: word].
	^ dic! !

Object subclass: #SqCSVParser
	instanceVariableNames: 'lineParser fromStream headerSize horizontalHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqCSVParser class methodsFor: 'constants' stamp: 'minami 6/13/2005 01:38'!
defaultConverter
	^ ShiftJISTextConverter new! !

!SqCSVParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:51'!
ex01
"
	self ex01
"

	| csv fromStream parser |
	csv := 'headA,headB,headC
1,aaa,"aaa,bbb,ccc"
2,bbb,"bbb,ccc,ddd"
3,ccc,"ccc,ddd,eee"
'.
	fromStream := csv readStream.
	parser := self parseStream: fromStream headerSize: 0@1.

	^ parser records 
	! !

!SqCSVParser class methodsFor: 'examples' stamp: 'minami 6/13/2005 01:52'!
ex02
"
	self ex02
"

	| csv fromStream parser |
	csv := 'headA,headB,headC
1,aaa,"aaa,bbb,ccc"
2,bbb,"bbb,ccc,ddd"
3,ccc,"ccc,ddd,eee"
'.
	fromStream := csv readStream.
	parser := self parseStream: fromStream headerSize: 0@1.

	^ parser recordDics 
	! !

!SqCSVParser class methodsFor: 'util' stamp: 'minami 6/13/2005 01:57'!
fromFile: filePath headerSize: aPoint 
	| fs |
	fs := FileDirectory default readOnlyFileNamed: filePath.
	(fs respondsTo: #converter:) ifTrue: [ fs converter: self defaultConverter].
	^ self parseStream: fs headerSize: aPoint! !

!SqCSVParser class methodsFor: 'instance creation' stamp: 'minami 6/13/2005 01:58'!
parseStream: aStream headerSize: aPoint 
	^ self basicNew initialize; 
		setFromStream: aStream; 
		setHeaderSize: aPoint; 
		yourself! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 11/25/2005 16:56'!
closeStream
	(fromStream respondsTo: #close) ifTrue: [fromStream close].
	fromStream := nil.! !

!SqCSVParser methodsFor: 'factory' stamp: 'mu 1/11/2006 12:04'!
defaultLineParserClass
	^ SqCSVLineParser ! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 20:05'!
fromStream
	^ fromStream! !

!SqCSVParser methodsFor: 'testing' stamp: 'minami 6/12/2005 22:26'!
hasHorizontalHeader
	^ self headerSize y > 0! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 20:05'!
headerSize
	^ headerSize! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 21:12'!
horizontalHeaders
	^ horizontalHeaders! !

!SqCSVParser methodsFor: 'initialize-release' stamp: 'minami 6/13/2005 01:11'!
initialize
	lineParser := self defaultLineParserClass new.
! !

!SqCSVParser methodsFor: 'accessing' stamp: 'minami 6/12/2005 19:45'!
lineParser
	^ lineParser! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 20:14'!
nextLineOrNil
	| line |
	^ self fromStream atEnd
		ifFalse: [
			line := self fromStream upTo: Character cr.
			line copyWithout: Character lf]! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 6/13/2005 01:36'!
privProcess: aBlock
	| line ignoreSize resultCol |
	self resetFromStream.
	self resetHorizontalHeaders.

	ignoreSize := self headerSize x.

	self hasHorizontalHeader ifTrue: [
		line := self nextLineOrNil.
		(line notNil and: [line notEmpty]) ifTrue: [
			self setHorizontalHeaders: (self lineParser parse: line ignoreSize: ignoreSize).
		].
	].

	resultCol := OrderedCollection new.
	[(line := self nextLineOrNil) notNil and: [line notEmpty]] whileTrue: [
		resultCol add: (aBlock value: line value: ignoreSize).
	].

	^ resultCol! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 6/13/2005 01:36'!
recordDics
	^ self privProcess: [:line :ignoreSize | 
						self lineParser
							parse: line
							ignoreSize: ignoreSize
							headers: self horizontalHeaders]! !

!SqCSVParser methodsFor: 'processing' stamp: 'minami 6/13/2005 01:36'!
records
	^ self privProcess: [:line :ignoreSize | self lineParser parse: line ignoreSize: ignoreSize]! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/13/2005 01:10'!
resetFromStream
	self fromStream reset! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/13/2005 01:11'!
resetHorizontalHeaders
	horizontalHeaders := nil! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 21:32'!
setFromStream: aStream
	fromStream := aStream! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 19:53'!
setHeaderSize: aPoint
	headerSize := aPoint! !

!SqCSVParser methodsFor: 'private' stamp: 'minami 6/12/2005 22:31'!
setHorizontalHeaders: aCollection
	horizontalHeaders := aCollection! !

Object subclass: #SqDomainModel
	instanceVariableNames: 'id name updatedTime serialNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqDomainModel class methodsFor: 'instance creation' stamp: 'MU 2/21/2006 15:10'!
id: id
	^self new id: id! !

!SqDomainModel class methodsFor: 'instance creation' stamp: 'MU 2/22/2006 12:21'!
id: id name: nameStr 
	^ self new id: id;
		 name: nameStr;
		 yourself! !

!SqDomainModel class methodsFor: 'instance creation' stamp: 'mu 5/22/2006 14:08'!
name: nameStr 
	^ self new name: nameStr;
		 yourself! !

!SqDomainModel methodsFor: 'actions' stamp: 'MU 2/21/2006 15:07'!
computeUpdatedTime
	updatedTime := TimeStamp now! !

!SqDomainModel methodsFor: 'private' stamp: 'mu 5/9/2006 14:43'!
generateId
	^SqUid new asString! !

!SqDomainModel methodsFor: 'comparing' stamp: 'MU 2/21/2006 15:18'!
hash
	^self id hash! !

!SqDomainModel methodsFor: 'accessing' stamp: 'mu 4/14/2006 13:51'!
id
	id ifNil: [id := self generateId].
	^id! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:06'!
id: aString
	id _ aString! !

!SqDomainModel methodsFor: 'initialize-release' stamp: 'MU 2/21/2006 15:08'!
initialize
	self computeUpdatedTime ! !

!SqDomainModel methodsFor: 'testing' stamp: 'MU 2/22/2006 12:22'!
isGroup
	^false! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:12'!
name
	name ifNil: [^self id asString].
	^name! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:12'!
name: aString
	name _ aString! !

!SqDomainModel methodsFor: 'printing' stamp: 'MU 2/22/2006 12:20'!
printDetailsOn: aStream 
	self name isEmptyOrNil
		ifFalse: [aStream nextPutAll: self name]! !

!SqDomainModel methodsFor: 'printing' stamp: 'MU 2/22/2006 12:20'!
printOn: aStream 
	aStream nextPutAll: 'a ', self className.
	aStream nextPutAll: '( '.
	self printDetailsOn: aStream .
	aStream nextPutAll: ' )'! !

!SqDomainModel methodsFor: 'initialize-release' stamp: 'MU 2/21/2006 15:07'!
release
	! !

!SqDomainModel methodsFor: 'initialize-release' stamp: 'MU 2/21/2006 15:07'!
releaseForStore
	self computeUpdatedTime.
	! !

!SqDomainModel methodsFor: 'accessing' stamp: 'mu 5/11/2006 14:24'!
serialNumber
	serialNumber ifNil: [serialNumber := 0].
	^serialNumber! !

!SqDomainModel methodsFor: 'accessing' stamp: 'mu 5/11/2006 14:24'!
serialNumber: anInteger
	serialNumber _ anInteger! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:06'!
updatedTime

	^updatedTime! !

!SqDomainModel methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:06'!
updatedTime: aValue

	updatedTime := aValue! !

!SqDomainModel methodsFor: 'comparing' stamp: 'mu 4/14/2006 16:45'!
<= other
	self class = other class ifFalse: [^false].
	^self id <= other id! !

!SqDomainModel methodsFor: 'comparing' stamp: 'mu 4/14/2006 16:22'!
= other
	self class = other class ifFalse: [^false].
	^self id = other id! !

SqDomainModel subclass: #SqGroup
	instanceVariableNames: 'members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

SqGroup subclass: #SqBoard
	instanceVariableNames: 'description thumbnail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:08'!
boardId
	^ self id! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:09'!
boardId: anUUID 
	self id: anUUID! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:09'!
boardName
	^ self name! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:09'!
boardName: nameStr 
	self name: nameStr! !

!SqBoard methodsFor: 'accessing' stamp: 'mu 4/17/2006 17:05'!
description
	description ifNil: [description _ ''].
	^description! !

!SqBoard methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:12'!
description: aString
	description _ aString! !

!SqBoard methodsFor: 'private' stamp: 'mu 5/9/2006 12:32'!
generateId
	^SqUid new! !

!SqBoard methodsFor: 'accessing' stamp: 'mu 6/8/2006 14:00'!
name
	name ifNil: [^'Unnamed' translated, 99999 atRandom asString].
	^name! !

!SqBoard methodsFor: 'printing' stamp: 'minami 1/23/2006 10:42'!
printOn: aStream
	aStream nextPut: $[. 
	aStream nextPutAll: self boardName asString, '@', self boardId asString.
	aStream nextPut: $].! !

!SqGroup methodsFor: 'accessing' stamp: 'mu 4/14/2006 15:48'!
addMember: aMember
	aMember ifNil: [^self].
	self members add: aMember! !

!SqGroup methodsFor: 'accessing' stamp: 'mu 4/14/2006 14:22'!
includesMember: aMember
	^self members includes: aMember! !

!SqGroup methodsFor: 'testing' stamp: 'MU 2/22/2006 12:22'!
isGroup
	^true! !

!SqGroup methodsFor: 'accessing' stamp: 'mu 4/14/2006 16:50'!
members
	members ifNil: [members _ Set new].
	^members! !

!SqGroup methodsFor: 'accessing' stamp: 'mu 4/14/2006 16:51'!
members: memberCollection
	members _ memberCollection! !

!SqGroup methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:18'!
removeMember: aMember
	self members remove: aMember! !

!SqGroup methodsFor: 'accessing' stamp: 'mu 4/14/2006 15:19'!
removeMember: aMember ifAbsent: block
	self members remove: aMember ifAbsent: block! !

SqDomainModel subclass: #SqRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

SqRole class
	instanceVariableNames: 'roles'!

!SqRole class methodsFor: 'instance creation' stamp: 'MU 2/21/2006 15:20'!
admin
	^ self roleAt: #admin! !

!SqRole class methodsFor: 'instance creation' stamp: 'mu 4/12/2006 11:24'!
guest
	^self roleAt: #guest! !

!SqRole class methodsFor: 'instance creation' stamp: 'MU 2/21/2006 15:21'!
leader
	^ self roleAt: #leader! !

!SqRole class methodsFor: 'instance creation' stamp: 'mu 4/12/2006 11:26'!
none
	^self roleAt: #none! !

!SqRole class methodsFor: 'instance creation' stamp: 'mu 4/12/2006 11:34'!
normal
	^self roleAt: #normal! !

!SqRole class methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:20'!
roleAt: id
	^ self roles
		at: id
		ifAbsentPut: [self id: id]! !

!SqRole class methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:19'!
roles
	roles ifNil: [roles _ IdentityDictionary new].
	^roles! !

SqDomainModel subclass: #SqUser
	instanceVariableNames: 'password role email male birthday initials icon color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Model'!

!SqUser class methodsFor: 'instance creation' stamp: 'mu 4/12/2006 11:30'!
adminId: id
	^(self id: id) beAdmin! !

!SqUser class methodsFor: 'instance creation' stamp: 'MU 2/22/2006 12:10'!
id: id password: passwd 
	^ self new id: id;
		 password: passwd! !

!SqUser methodsFor: 'actions' stamp: 'mu 8/18/2005 22:05'!
age
	^self birthday isNil
		ifFalse: [ (Date today subtractDate: self birthday) // 365 ]
		ifTrue: [ String new ]! !

!SqUser methodsFor: 'actions' stamp: 'mu 4/26/2006 12:18'!
asProfile
	password _ nil.
	^self! !

!SqUser methodsFor: 'role changing' stamp: 'mu 4/12/2006 11:29'!
beAdmin
	role := SqRole admin! !

!SqUser methodsFor: 'role changing' stamp: 'mu 4/12/2006 11:33'!
beGuest
	role := SqRole guest! !

!SqUser methodsFor: 'role changing' stamp: 'mu 4/12/2006 11:32'!
beLeader
	role := SqRole leader! !

!SqUser methodsFor: 'role changing' stamp: 'mu 4/12/2006 11:35'!
beNormal
	role := SqRole normal! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:05'!
birthday
	^birthday! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:05'!
birthday: anObject
	birthday := anObject! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/26/2006 14:56'!
color
	color ifNil: [color _ Color random muchDarker].
	^ color! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/25/2006 16:27'!
color: aColor
	color _ aColor! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 21:42'!
email
	^email! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:07'!
email: aString
	email _ aString! !

!SqUser methodsFor: 'actions' stamp: 'mu 8/18/2005 22:07'!
female
	^self male not! !

!SqUser methodsFor: 'private' stamp: 'mu 6/5/2006 23:23'!
guessInitials
	| nm tokens |
	nm := self name.
	tokens := nm findTokens: ' '.
	tokens size >= 2
		ifTrue: [^(String with: tokens first first with: tokens last first) asUppercase].
	nm size >= 10
		ifTrue: [^nm copyFrom: 1 to: 10].
	^ nm! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/25/2006 16:26'!
icon
	^ icon! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/25/2006 16:27'!
icon: iconForm
	icon _ iconForm! !

!SqUser methodsFor: 'initialize-release' stamp: 'mu 4/12/2006 11:35'!
initialize
	super initialize.
	role _ SqRole normal.
	email := ''.
	! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/26/2006 14:30'!
initials
	initials
		ifNil: [initials := self guessInitials].
	^ initials! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/25/2006 16:27'!
initials: initialsString
	initials _ initialsString! !

!SqUser methodsFor: 'testing' stamp: 'MU 2/21/2006 15:27'!
isAdmin
	^self role = SqRole admin! !

!SqUser methodsFor: 'actions' stamp: 'mu 4/13/2006 14:45'!
isAdmin: aBoolean
	aBoolean ifTrue: [self beAdmin] ifFalse: [self beNormal]! !

!SqUser methodsFor: 'testing' stamp: 'mu 4/12/2006 11:25'!
isGuest
	^self role = SqRole guest! !

!SqUser methodsFor: 'testing' stamp: 'MU 2/21/2006 15:29'!
isLeader
	^self role = SqRole leader! !

!SqUser methodsFor: 'testing' stamp: 'mu 4/12/2006 11:34'!
isNormal
	^self role = SqRole normal! !

!SqUser methodsFor: 'accessing' stamp: 'mu 12/13/2005 20:09'!
male
	male ifNil: [male _ true].
	^male! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/18/2005 22:05'!
male: aBoolean
	male := aBoolean! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/24/2005 23:25'!
password
	^password! !

!SqUser methodsFor: 'accessing' stamp: 'mu 8/24/2005 23:25'!
password: aString
	password _ aString! !

!SqUser methodsFor: 'printing' stamp: 'mu 12/13/2005 19:45'!
printOn: aStream 
	self isAdmin
		ifTrue: [aStream nextPutAll: '[admin] '].
	self name isEmptyOrNil
		ifFalse: [aStream nextPutAll: self name]! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/12/2006 11:35'!
role
	role ifNil: [role _ SqRole normal].
	^role! !

!SqUser methodsFor: 'accessing' stamp: 'MU 2/21/2006 15:03'!
role: aRole
	role _ aRole! !

!SqUser methodsFor: 'accessing' stamp: 'mu 4/14/2006 14:07'!
sex
	^self male
		ifTrue: [ 'mail' ]
		ifFalse: [ 'female' ]! !

Object subclass: #SqEvent
	instanceVariableNames: 'target targetId args timeStamp eventId undoArgs accessId millisecondsStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event'!

SqEvent subclass: #SqBorderChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqBorderChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#borderColor #borderWidth #borderStyle)	! !

!SqBorderChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:08'!
type
	^ #borderChanged! !

SqEvent subclass: #SqCursorPointChangedCommand
	instanceVariableNames: 'point'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqCursorPointChangedCommand class methodsFor: 'instance creation' stamp: 'mu 4/27/2006 16:17'!
accessId: aid point: point
	^self new
		accessId: aid;	
		point: point! !

!SqCursorPointChangedCommand class methodsFor: 'testing' stamp: 'mu 4/26/2006 16:50'!
isCommand
	^true! !

!SqCursorPointChangedCommand methodsFor: 'actions' stamp: 'mu 5/22/2006 15:34'!
execute: board

	board cursorPointChanged: self point of: self userSerial.

	! !

!SqCursorPointChangedCommand methodsFor: 'testing' stamp: 'mu 4/27/2006 16:31'!
isDisposable
	^true! !

!SqCursorPointChangedCommand methodsFor: 'accessing' stamp: 'mu 4/27/2006 16:10'!
point
	^point! !

!SqCursorPointChangedCommand methodsFor: 'accessing' stamp: 'mu 4/28/2006 10:49'!
point: aPoint
	point _ aPoint asIntegerPoint! !

!SqCursorPointChangedCommand methodsFor: 'serializing' stamp: 'mu 5/11/2006 15:17'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.
	
	accessId _ aDataStream next.
	point _ Point fromCompactBytes: aDataStream next asByteArray.! !

!SqCursorPointChangedCommand methodsFor: 'serializing' stamp: 'mu 5/11/2006 15:17'!
storeDataOn: aDataStream
	aDataStream
		beginInstance: self class
		size: 2.
	
	aDataStream nextPut: accessId.
	aDataStream nextPut: point asCompactBytes asString.

	! !

!SqCursorPointChangedCommand methodsFor: 'defaults' stamp: 'mu 4/27/2006 16:09'!
type
	^ #cursorPointChangedCommand! !

SqEvent subclass: #SqCursorStyleChangedCommand
	instanceVariableNames: 'style'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqCursorStyleChangedCommand class methodsFor: 'instance creation' stamp: 'mu 5/8/2006 16:09'!
accessId: aid style: style
	^self new
		accessId: aid;	
		style: style! !

!SqCursorStyleChangedCommand class methodsFor: 'testing' stamp: 'mu 5/8/2006 16:09'!
isCommand
	^true! !

!SqCursorStyleChangedCommand methodsFor: 'actions' stamp: 'mu 5/22/2006 15:42'!
execute: board

	board cursorStyleChanged: self style of: self userSerial! !

!SqCursorStyleChangedCommand methodsFor: 'testing' stamp: 'mu 5/8/2006 15:43'!
isDisposable
	^true! !

!SqCursorStyleChangedCommand methodsFor: 'serializing' stamp: 'mu 5/8/2006 15:43'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.
	
	accessId _ aDataStream next.
	style _ aDataStream next.! !

!SqCursorStyleChangedCommand methodsFor: 'serializing' stamp: 'mu 5/8/2006 15:43'!
storeDataOn: aDataStream
	aDataStream
		beginInstance: self class
		size: 2.
	
	aDataStream nextPut: accessId.
	aDataStream nextPut: style.! !

!SqCursorStyleChangedCommand methodsFor: 'accessing' stamp: 'mu 5/8/2006 16:27'!
style
	^ style! !

!SqCursorStyleChangedCommand methodsFor: 'accessing' stamp: 'mu 5/8/2006 16:27'!
style: aSymbol
	style _ aSymbol! !

!SqCursorStyleChangedCommand methodsFor: 'defaults' stamp: 'minami 5/10/2006 15:00'!
type
	^ #mouseCursorStyleChangedCommand! !

SqEvent subclass: #SqDropAcceptEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqDropAcceptEvent methodsFor: 'accessing' stamp: 'mu 5/23/2006 14:36'!
distPlayer
	^self argsAt: #distPlayer! !

!SqDropAcceptEvent methodsFor: 'accessing' stamp: 'mu 5/23/2006 14:37'!
distPlayer: value
	^self argsAt: #distPlayer put: value! !

!SqDropAcceptEvent methodsFor: 'actions' stamp: 'mu 5/23/2006 14:37'!
execute: board
	| targetPlayer distPlayer |
	targetPlayer := self findPlayerByUid: self targetId on: board.
	targetPlayer ifNil: [^ self].

	distPlayer := self findPlayerByUid: (self distPlayer) on: board.
	distPlayer ifNil: [distPlayer := board].


	targetPlayer stopRecordingWhile: [
		distPlayer addPlayer: targetPlayer.
		board isHeadless ifFalse: [self waitTick]. 
		targetPlayer position: (self targetPosition)
	].
! !

!SqDropAcceptEvent methodsFor: 'properties' stamp: 'mu 5/23/2006 14:37'!
saveProperties: aPlayer withArgs: anArray 
	| distPlayer |
	super saveProperties: aPlayer withArgs: anArray.

	self targetPosition: aPlayer position.

	anArray isEmpty ifTrue: [^ self].
	distPlayer := anArray first.
	self distPlayer: distPlayer playerId.
! !

!SqDropAcceptEvent methodsFor: 'accessing' stamp: 'mu 5/23/2006 14:36'!
targetPosition
	^self argsAt: #targetPosition! !

!SqDropAcceptEvent methodsFor: 'accessing' stamp: 'mu 5/23/2006 14:37'!
targetPosition: value
	^self argsAt: #targetPosition put: value! !

!SqDropAcceptEvent methodsFor: 'defaults' stamp: 'minami 2/9/2006 16:35'!
type
	^ #dropAccept! !

!SqEvent class methodsFor: 'instance creation' stamp: 'mu 5/21/2006 22:30'!
fromCompactBytes: data
	| dec |
	dec _ SqEventDecoder new.
	^dec decode: data ! !

!SqEvent class methodsFor: 'instance creation' stamp: 'mu 6/5/2006 20:52'!
fromStoredBytes: data
	| dec |
	dec _ SqEventDecoder new.
	dec forStore: true.
	^dec decode: data ! !

!SqEvent class methodsFor: 'testing' stamp: 'mu 3/17/2006 11:29'!
isCommand
	^false! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 1/29/2006 03:53'!
accessId
	^ accessId! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 1/29/2006 03:53'!
accessId: aSqAccessId
	accessId := aSqAccessId! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:53'!
argsAt: key
	^ self arguments at: key ifAbsent: []! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 5/29/2006 15:18'!
argsAt: key ifAbsent: aBlock
	^ self arguments at: key ifAbsent: aBlock! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:53'!
argsAt: key put: value
	^ self arguments at: key put: value! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:53'!
arguments
	args ifNil: [args := Dictionary new].
	^ args! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 5/29/2006 15:05'!
argumentsAsArray
	^self propertyNames collect: [:key | self arguments at: key]! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:52'!
arguments: arguments
	args := arguments! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 5/21/2006 19:34'!
asCompactBytes
	| enc |
	enc _ SqEventEncoder new.
	enc encode: self.
	^enc contents. ! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 6/5/2006 20:49'!
asStoredBytes
	| enc |
	enc _ SqEventEncoder new.
	enc forStore: true.
	enc encode: self.
	^enc contents. ! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 1/29/2006 03:54'!
boardId
	^ self accessId boardId! !

!SqEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 15:40'!
defaultEnabledPropertyNames
	^ #()! !

!SqEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #()! !

!SqEvent methodsFor: 'save/load' stamp: 'MU 2/16/2006 15:46'!
enabledPropertyNames
	self target ifNil: [^self defaultEnabledPropertyNames].
	
	^ self target wantsReturnEnabledPropertyNames
		ifTrue: [self target enabledPropertyNamesFor: self]
		ifFalse: [self defaultEnabledPropertyNames]! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/20/2005 11:04'!
eventId
	^ eventId! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/20/2005 11:04'!
eventId: anInteger
	eventId := anInteger! !

!SqEvent methodsFor: 'actions' stamp: 'mu 5/23/2006 16:30'!
execute: board
	| player |
	player := self findPlayerByUid: self targetId on: board.
	player ifNil: [^ nil].

	player stopRecordingWhile: [
		self saveUndoProperties: player.

		(board isRecovering or: [self accessId ~= board accessId]) ifTrue: [
			self loadProperties: player.
		].
	
		self waitTickIfNeededOn: board
	].! !

!SqEvent methodsFor: 'query' stamp: 'minami 5/23/2006 11:01'!
findPlayerByUid: uid on: board
	^ board findPlayerByUid: uid
! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 6/5/2006 20:48'!
forSend
	target _ nil.
	millisecondsStamp _ nil.
	! !

!SqEvent methodsFor: 'comparing' stamp: 'mu 3/17/2006 12:53'!
hash
	^ (self type hash bitXor: self targetId hash) bitXor: self arguments hash
! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/6/2006 14:56'!
imageId
	^ self accessId imageId! !

!SqEvent methodsFor: 'testing' stamp: 'mu 3/17/2006 11:31'!
isCommand
	^self class isCommand! !

!SqEvent methodsFor: 'testing' stamp: 'mu 4/27/2006 16:31'!
isDisposable
	^false! !

!SqEvent methodsFor: 'testing' stamp: 'MU 2/9/2006 16:20'!
isOnTheSameBoard: board
	^self boardId = board boardId! !

!SqEvent methodsFor: 'save/load' stamp: 'mu 5/29/2006 15:19'!
loadProperties: aPlayer
	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := self argsAt: nameSymbol ifAbsent: [true].
		aPlayer loadProperty: nameSymbol to: value.
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		| value |
		value := self argsAt: nameSymbol.
		aPlayer loadProperty: nameSymbol to: value.
	].

	aPlayer
		perform: self loadSelector 
		with: self arguments 
		with: #().
! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:35'!
loadSelector
	^ ('loadOn', self type capitalized , 'From:withArgs:') asSymbol


! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:41'!
loadUndoProperties: aPlayer
	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := self undoArgs at: nameSymbol.
		aPlayer loadProperty: nameSymbol to: value.
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		| value |
		value := self undoArgs at: nameSymbol.
		aPlayer loadProperty: nameSymbol to: value.
	].

	aPlayer
		perform: self loadSelector 
		with: self undoArgs 
		with: #().
! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:32'!
millisecondsFromCurrent
	^(Time millisecondClockValue -  self millisecondsStamp) abs! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:13'!
millisecondsStamp
	millisecondsStamp ifNil: [millisecondsStamp _ Time millisecondClockValue].
	^millisecondsStamp! !

!SqEvent methodsFor: 'printing' stamp: 'minami 12/20/2005 11:04'!
printOn: aStream
	aStream nextPutAll: '['.
	aStream nextPutAll: '#', self eventId printString, ': '.
	aStream nextPutAll: self timeStamp printString, ': '.
	aStream nextPutAll: self type.
	aStream nextPutAll: ']'.! !

!SqEvent methodsFor: 'save/load' stamp: 'MU 2/16/2006 15:37'!
propertyNames
	self target ifNil: [^ self defaultPropertyNames].

	^ self target wantsReturnPropertyNames
		ifTrue: [self target propertyNamesFor: self]
		ifFalse: [self defaultPropertyNames]! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 5/10/2006 14:05'!
readArgsFrom: aDataStream 
	args _ aDataStream next.
	

	
	
	! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 5/19/2006 14:27'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.

	targetId _ (aDataStream next ifNotNilDo: [:str | str asSqUid]).
	timeStamp _ (aDataStream next ifNotNilDo: [:sec | TimeStamp fromSeconds: sec]).
	eventId _ aDataStream next.	
	accessId _ (aDataStream next ifNotNilDo: [:str | SqAccessId fromString: str]).
	self readArgsFrom: aDataStream
	

	
	
	! !

!SqEvent methodsFor: 'save/load' stamp: 'mu 3/17/2006 12:55'!
saveProperties: aPlayer withArgs: anArray
	aPlayer ifNil: [^self].

	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := aPlayer saveProperty: nameSymbol into: self arguments. 
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		aPlayer saveProperty: nameSymbol into: self arguments. 
	].

	aPlayer
		perform: self saveSelector 
		with: self arguments 
		with: anArray.
! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:36'!
saveSelector
	^ ('saveOn', self type capitalized, 'Into:withArgs:') asSymbol


! !

!SqEvent methodsFor: 'save/load' stamp: 'minami 2/17/2006 09:42'!
saveUndoProperties: aPlayer
	self enabledPropertyNames do: [:nameSymbol | 
		| value |
		value := aPlayer saveProperty: nameSymbol into: self undoArgs. 
		value ifFalse: [^ self].
	].

	self propertyNames do: [:nameSymbol | 
		aPlayer saveProperty: nameSymbol into: self undoArgs. 
	].

	aPlayer
		perform: self saveSelector 
		with: self undoArgs 
		with: #().
! !

!SqEvent methodsFor: 'debugging' stamp: 'mu 3/9/2006 11:02'!
serializedSize
	"only for debug"
	^(RmtStreamer stream: self) size! !

!SqEvent methodsFor: 'actions' stamp: 'mu 5/23/2006 14:12'!
setArrayArguments: values
	self propertyNames with: values do: [:key :value|
		self argsAt: key put: value
	]! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:14'!
setMillisecondsStamp
	millisecondsStamp _ Time millisecondClockValue! !

!SqEvent methodsFor: 'stamp' stamp: 'mu 3/9/2006 14:13'!
setTimeStamp
	timeStamp := TimeStamp current.
	! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 5/10/2006 14:04'!
storeArgsOn: aDataStream
	"override for performance"
	aDataStream nextPut: args.

	
	! !

!SqEvent methodsFor: 'serializing' stamp: 'mu 5/19/2006 14:27'!
storeDataOn: aDataStream
	"target targetId args timeStamp eventId undoArgs accessId"

	aDataStream
		beginInstance: self class
		size: self class instSize.

	aDataStream nextPut: targetId asString.
	aDataStream nextPut: (timeStamp ifNotNilDo: [:t | t asSeconds]).
	aDataStream nextPut: eventId.	
	aDataStream nextPut: accessId asString.
	self storeArgsOn: aDataStream
	
	! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/16/2006 12:42'!
target

	^ target
! !

!SqEvent methodsFor: 'accessing' stamp: 'MU 2/16/2006 12:08'!
targetId
	^ targetId! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 5/23/2006 13:31'!
targetId: uuid
	targetId := uuid.
	! !

!SqEvent methodsFor: 'accessing' stamp: 'MU 2/16/2006 13:16'!
target: player 
	player isPlayer ifFalse: [^self].
	target := player.
	self targetId: target playerId! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/19/2005 16:51'!
timeStamp
	^ timeStamp! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 6/5/2006 20:57'!
timeStamp: aTimeStamp
	 timeStamp _ aTimeStamp! !

!SqEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:27'!
type
	"self subclassResponsibility "

	"Default uses reflection - override for performance"
	| nm |
	nm _ self class name.
	^ (nm copyFrom: 3 to: ((nm size - 5) max: 4)) withFirstCharacterDownshifted
	
	! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/16/2006 12:25'!
undoArgs
	undoArgs ifNil: [undoArgs := Dictionary new].
	^ undoArgs ! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/16/2006 15:48'!
undoArgsAt: key
	^ self undoArgs at: key ifAbsent: []! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 2/17/2006 08:41'!
undoArgsAt: key put: value
	^ self undoArgs at: key put: value! !

!SqEvent methodsFor: 'accessing' stamp: 'minami 12/22/2005 15:32'!
undoArgs: dic
	undoArgs := dic! !

!SqEvent methodsFor: 'actions' stamp: 'mu 5/17/2006 13:51'!
undo: board
	| player |
	player := self findPlayerByUid: self targetId on: board.
	player ifNil: [^ nil].

	self loadUndoProperties: player.

! !

!SqEvent methodsFor: 'accessing' stamp: 'mu 5/22/2006 15:30'!
userSerial
	^ self accessId userSerial! !

!SqEvent methodsFor: 'actions' stamp: 'mu 5/23/2006 16:30'!
waitTickIfNeededOn: board
	self waitTickNeeded ifFalse: [^ self].

	board isHeadless ifFalse: [self waitTick].! !

!SqEvent methodsFor: 'testing' stamp: 'mu 5/23/2006 16:29'!
waitTickNeeded
	^ false! !

!SqEvent methodsFor: 'comparing' stamp: 'minami 5/10/2006 17:19'!
= aEventRecord
	aEventRecord ifNil: [^ false].	

	self type == aEventRecord type ifFalse: [^ false].
	self targetId == aEventRecord targetId ifFalse: [^ false].
	self accessId = aEventRecord accessId ifFalse: [^ false].
	self eventId == aEventRecord eventId ifFalse: [^ false].

"	self args = aEventRecord args ifFalse: [^ false]."

	^ true! !

SqEvent subclass: #SqFillChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqFillChangedEvent methodsFor: 'accessing' stamp: 'mu 5/23/2006 14:19'!
alpha
	^self argsAt: #alpha! !

!SqFillChangedEvent methodsFor: 'accessing' stamp: 'mu 5/23/2006 14:19'!
alpha: value
	self argsAt: #alpha put: value! !

!SqFillChangedEvent methodsFor: 'defaults' stamp: 'mu 5/23/2006 14:17'!
defaultPropertyNames
	^ #(#color #fillAlpha #fillAngle #fillColor #fillColors #fillOffset #fillStyle)	! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'mu 5/23/2006 14:16'!
loadProperties: aPlayer
	super loadProperties: aPlayer.

	aPlayer color: (aPlayer color alpha: (self argsAt: #alpha)).! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'minami 2/3/2006 17:08'!
loadUndoProperties: aPlayer
	super loadUndoProperties: aPlayer.

	aPlayer color: (aPlayer color: (self undoArgs at: #alpha)).! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'mu 5/23/2006 14:16'!
saveProperties: aPlayer withArgs: anArray
	super saveProperties: aPlayer withArgs: anArray.

	self argsAt: #alpha put: aPlayer color alpha.! !

!SqFillChangedEvent methodsFor: 'properties' stamp: 'minami 2/3/2006 17:05'!
saveUndoProperties: aPlayer
	super saveUndoProperties: aPlayer.

	self undoArgs at: #alpha put: aPlayer color alpha.! !

!SqFillChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:08'!
type
	^ #fillChanged! !

SqEvent subclass: #SqFlagsChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqFlagsChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#clipping #floating #infinite #locked #sticky #userDraw #visible)	! !

!SqFlagsChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:09'!
type
	^ #flagsChanged! !

SqEvent subclass: #SqGenericCommand
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event'!

!SqGenericCommand class methodsFor: 'instance creation' stamp: 'mu 3/17/2006 11:44'!
accessId: aid selector: selector arguments: args
	"SqGenericCommand accessId: nil selector: #test: arguments: #(a)"
	^self new
		accessId: aid;	
		selector: selector;
		arguments: args
		! !

!SqGenericCommand class methodsFor: 'instance creation' stamp: 'mu 3/27/2006 14:53'!
accessId: aid targetId: id selector: selector arguments: args
	"SqGenericCommand accessId: nil targetId: UUID new selector: #test: arguments: #(a)"
	^self new
		accessId: aid;
		targetId: id;
		selector: selector;
		arguments: args
		! !

!SqGenericCommand class methodsFor: 'testing' stamp: 'mu 3/17/2006 11:28'!
isCommand
	^true! !

!SqGenericCommand methodsFor: 'accessing' stamp: 'mu 3/17/2006 12:56'!
arguments
	args ifNil: [args := #()].
	^ args! !

!SqGenericCommand methodsFor: 'actions' stamp: 'mu 3/17/2006 12:52'!
execute: board
	"By default, just use board as perform:''s target "
	board perform: self selector withArguments: self arguments! !

!SqGenericCommand methodsFor: 'serializing' stamp: 'mu 5/9/2006 13:13'!
readDataFrom: aDataStream size: varsOnDisk
	aDataStream beginReference: self.
	
	targetId _ (aDataStream next ifNil: [nil] ifNotNilDo: [:str | str asSqUid]).
	args _ aDataStream next.
	timeStamp _ aDataStream next.
	eventId _ aDataStream next.	
	accessId _ aDataStream next.
	selector _ aDataStream next.! !

!SqGenericCommand methodsFor: 'accessing' stamp: 'mu 3/17/2006 11:31'!
selector
	^selector! !

!SqGenericCommand methodsFor: 'accessing' stamp: 'mu 3/17/2006 11:31'!
selector: aSymbol
	selector _ aSymbol! !

!SqGenericCommand methodsFor: 'serializing' stamp: 'mu 3/17/2006 12:30'!
storeDataOn: aDataStream
	aDataStream
		beginInstance: self class
		size: 6.
	
	aDataStream nextPut: (targetId ifNil: [] ifNotNilDo: [:tid | tid asString]).
	aDataStream nextPut: args.
	aDataStream nextPut: timeStamp.
	aDataStream nextPut: eventId.	
	aDataStream nextPut: accessId.
	aDataStream nextPut: selector.
! !

!SqGenericCommand methodsFor: 'defaults' stamp: 'mu 3/17/2006 11:26'!
type
	^ #genericCommand! !

!SqGenericCommand methodsFor: 'actions' stamp: 'mu 3/17/2006 12:50'!
undo: board
	"not supported - you have to subclass me"! !

!SqGenericCommand methodsFor: 'testing' stamp: 'mu 5/23/2006 16:32'!
waitTickNeeded
	^ true! !

SqEvent subclass: #SqGeometryChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqGeometryChangedEvent methodsFor: 'defaults' stamp: 'mu 5/23/2006 13:46'!
defaultPropertyNames
	^ #(#nose #scale #aspectRatio #position #extent #direction)	! !

!SqGeometryChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:10'!
type
	^ #geometryChanged! !

SqEvent subclass: #SqGraphicChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqGraphicChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 15:41'!
defaultEnabledPropertyNames
	^ #(#graphicEnabled )! !

!SqGraphicChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#graphicAnchorPoint #graphicFit #graphicOffset #graphicForm)	! !

!SqGraphicChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:09'!
type
	^ #graphicChanged! !

!SqGraphicChangedEvent methodsFor: 'testing' stamp: 'minami 5/26/2006 13:14'!
waitTickNeeded
	^ true! !

SqEvent subclass: #SqImageChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqImageChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#image)	! !

!SqImageChangedEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:27'!
type
	^ #imageChanged! !

SqEvent subclass: #SqLabelChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqLabelChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#label)	! !

!SqLabelChangedEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:00'!
type
	^ #labelChanged! !

SqEvent subclass: #SqPlayerCreatedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerCreatedEvent methodsFor: 'actions' stamp: 'mu 6/1/2006 19:26'!
execute: board
	| aPlayer behavior className key |
self flag: #minami. "undo?"

	(self findPlayerByUid: self targetId on: board) ifNotNil: [^ nil].

	className _ self argsAt: #class.

	aPlayer := (self argsAt: #playerBytes) 
			ifNil: [(Smalltalk at: className asSymbol ifAbsent: [CValuePlayer]) new] 
			ifNotNilDo: [:bytes | bytes asPlayer].	

	"aPlayer := (Smalltalk at: (self argsAt: #class)) new."
	
	board isHeadless ifFalse: [self waitTick]. 

	self saveUndoProperties: aPlayer.
	self loadProperties: aPlayer.

	behavior := board eventRecordBehaviorClass attachTo: aPlayer.
	behavior board: board.
	key _ aPlayer userDataAt: #lookupSpec. 
	key notNil ifTrue: [
		board register: aPlayer lookupKey: key.
		self project ifNotNilDo: [:proj | proj scriptManager registerObject: aPlayer at: key].
	].

	board removeCoverWhile: [board add: aPlayer].
	board isHeadless ifFalse: [self waitTick].! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'mu 3/17/2006 14:14'!
loadProperties: aPlayer
	aPlayer playerId: self targetId.

	aPlayer graphicEnabled: (self argsAt: #graphicEnabled).
	aPlayer textEnabled: (self argsAt: #textEnabled).
	aPlayer graphicForm: (self argsAt: #graphicForm).
	(self arguments includesKey: #graphicFit) ifTrue: [
		aPlayer graphicFit: (self argsAt: #graphicFit).
	].
	aPlayer extent: (self argsAt: #extent).
	aPlayer position: (self argsAt: #position).
	aPlayer nose: (self argsAt: #nose).

	aPlayer
		perform: self loadSelector 
		with: self arguments 
		with: #().
! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'minami 12/26/2005 14:48'!
loadUndoProperties: aPlayer
	"do nothing"! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'mu 3/17/2006 12:54'!
saveProperties: aPlayer withArgs: anArray

	aPlayer isUniClass 
		ifTrue: [self argsAt: #playerBytes put: aPlayer asCompactBytes].

	self argsAt: #class put: aPlayer className. 

	self argsAt: #position put: aPlayer position.
	self argsAt: #extent put: aPlayer extent.
	self argsAt: #nose put: aPlayer nose.

	self argsAt: #textEnabled put: aPlayer textEnabled.
	self argsAt: #graphicEnabled put: aPlayer graphicEnabled.
	self argsAt: #graphicForm put: aPlayer graphicForm.
	aPlayer graphicEnabled ifTrue: [
		self argsAt: #graphicFit put: aPlayer graphicFit
	].

	aPlayer
		perform: self saveSelector 
		with: self arguments 
		with: #().
! !

!SqPlayerCreatedEvent methodsFor: 'properties' stamp: 'mu 3/1/2006 17:16'!
saveUndoProperties: aPlayer

	aPlayer isUniClass 
		ifTrue: [self undoArgsAt: #playerBytes put: aPlayer asCompactBytes].

	self undoArgsAt: #class put: aPlayer className.

	self undoArgsAt: #position put: aPlayer position. 
	self undoArgsAt: #extent put: aPlayer extent.
	self undoArgsAt: #nose put: aPlayer nose.

	self undoArgsAt: #textEnabled put: aPlayer textEnabled.
	self undoArgsAt: #graphicEnabled put: aPlayer graphicEnabled.
	self undoArgsAt: #graphicForm put: aPlayer graphicForm.
	aPlayer graphicEnabled ifTrue: [
		self undoArgsAt: #graphicFit put: aPlayer graphicFit
	].

	aPlayer
		perform: self saveSelector 
		with: self undoArgs 
		with: #().
! !

!SqPlayerCreatedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 10:59'!
type
	^ #playerCreated! !

!SqPlayerCreatedEvent methodsFor: 'actions' stamp: 'mu 5/17/2006 13:52'!
undo: board
	| player |
	player := self findPlayerByUid: self targetId on: board.
	player ifNil: [^ nil].

	player destroy! !

SqEvent subclass: #SqPlayerLockEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerLockEvent methodsFor: 'actions' stamp: 'mu 5/22/2006 18:28'!
execute: board
	board isRecovering ifTrue: [^self].
	board freezePlayer: self targetId from: self userSerial! !

!SqPlayerLockEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:05'!
type
	^ #lock! !

!SqPlayerLockEvent methodsFor: 'actions' stamp: 'minami 2/9/2006 11:58'!
undo: board
	Transcript cr; show: thisContext printString.! !

SqEvent subclass: #SqPlayerRemovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerRemovedEvent methodsFor: 'actions' stamp: 'mu 5/17/2006 13:52'!
execute: board
	| player dic |

self flag: #minami. "undo?"

	player := self findPlayerByUid: self targetId on: board.
	player ifNil: [^ nil].

	dic := Dictionary new.
	dic at: #myself put: player.
	self undoArgs: dic.

	player detachBoardProperties.
	player container remove: player ifAbsent: [].
! !

!SqPlayerRemovedEvent methodsFor: 'properties' stamp: 'MU 2/16/2006 12:14'!
loadProperties: aPlayer
	aPlayer playerId: self targetId.! !

!SqPlayerRemovedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:11'!
type
	^ #playerRemoved! !

!SqPlayerRemovedEvent methodsFor: 'actions' stamp: 'minami 1/31/2006 20:11'!
undo: board
	| aPlayer |
	aPlayer := self undoArgs at: #myself.
	board add: aPlayer.
	self loadProperties: aPlayer.
	! !

SqEvent subclass: #SqPlayerSelectedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerSelectedEvent methodsFor: 'actions' stamp: 'mu 5/17/2006 13:52'!
execute: board
	| player h |
	player := self findPlayerByUid: self targetId on: board.
	player ifNil: [^ nil].

	h _ SqSelectionHighlight new.
	h target: player.
	h open.! !

!SqPlayerSelectedEvent methodsFor: 'defaults' stamp: 'minami 1/18/2006 15:20'!
type
	^ #playerSelected! !

SqEvent subclass: #SqPlayerUnlockEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPlayerUnlockEvent methodsFor: 'actions' stamp: 'mu 5/22/2006 15:29'!
execute: board
	board isRecovering ifTrue: [^self].
	board unfreezePlayer: self targetId from: self userSerial! !

!SqPlayerUnlockEvent methodsFor: 'defaults' stamp: 'MU 2/15/2006 16:05'!
type
	^ #unlock! !

!SqPlayerUnlockEvent methodsFor: 'actions' stamp: 'minami 2/9/2006 11:58'!
undo: board
	Transcript cr; show: thisContext printString.! !

SqEvent subclass: #SqPolygonStateChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqPolygonStateChangedEvent methodsFor: 'defaults' stamp: 'minami 4/12/2006 16:25'!
defaultPropertyNames
	^ #(#smoothCurve #closed #arrowStyle #color)	! !

!SqPolygonStateChangedEvent methodsFor: 'defaults' stamp: 'minami 4/12/2006 15:54'!
type
	^ #polygonStateChanged! !

SqEvent subclass: #SqRemoteVerticesChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqRemoteVerticesChangedEvent methodsFor: 'defaults' stamp: 'mu 5/31/2006 15:47'!
defaultPropertyNames
	^ #(#vertices)	! !

!SqRemoteVerticesChangedEvent methodsFor: 'actions' stamp: 'mu 5/31/2006 15:59'!
execute: board 
	| player hasHandles |
	player _ self findPlayerByUid: self targetId on: board.
	player ifNil: [^ nil].

	player stopRecordingWhile: [
		hasHandles _ player hasHandles.
		[(board isRecovering or: [self accessId ~= board accessId])
			ifTrue: [
				player wantsPropagateEvents: false.
				player vertices: (self argsAt: #vertices).
				player wantsPropagateEvents: true.]
		] ensure: [
			hasHandles ifTrue: [player addHandles]]
	]! !

!SqRemoteVerticesChangedEvent methodsFor: 'defaults' stamp: 'mu 5/31/2006 15:47'!
type
	^ #remoteVerticesChanged! !

!SqRemoteVerticesChangedEvent methodsFor: 'testing' stamp: 'mu 5/31/2006 15:47'!
waitTickNeeded
	^ true! !

SqEvent subclass: #SqRoundCornersChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqRoundCornersChangedEvent methodsFor: 'defaults' stamp: 'MU 2/16/2006 11:59'!
defaultPropertyNames
	^ #(#roundCorners)	! !

!SqRoundCornersChangedEvent methodsFor: 'defaults' stamp: 'minami 12/27/2005 14:08'!
type
	^ #roundCornersChanged! !

SqEvent subclass: #SqScriptModifiedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqScriptModifiedEvent methodsFor: 'private' stamp: 'mu 6/2/2006 11:35'!
compileScript: targetPlayer on: board 
	| tile assocs scriptSource |
	scriptSource _ self argsAt: #scriptSource.
	assocs _ self argsAt: #playerAssociations.
	assocs
		ifNotEmpty: [assocs
				do: [:each | 
					| lookupKey pid obj | 
					lookupKey _ each key.
					pid _ each value asSqUid.
					obj _ self findPlayerByUid: pid on: board.
					board register: obj lookupKey: lookupKey]].
	tile _ targetPlayer scriptorFromSource: scriptSource.
	targetPlayer isUniClass
		ifTrue: [targetPlayer recompileScriptNode: tile asParseNode]
		ifFalse: [targetPlayer compileScriptNode: tile asParseNode].
	targetPlayer addScriptor: tile.

	board openFlapWithScriptor: tile.! !

!SqScriptModifiedEvent methodsFor: 'actions' stamp: 'mu 5/17/2006 13:52'!
execute: board 
	| targetPlayer scriptSelector scriptStatus |
	targetPlayer _ self findPlayerByUid: self targetId on: board.
	targetPlayer ifNil: [^ self].
	scriptSelector _ self argsAt: #scriptSelector.
	scriptStatus _ self argsAt: #scriptStatus.
	targetPlayer
		stopRecordingWhile: [scriptStatus == #compiled
				ifTrue: [self compileScript: targetPlayer on: board].
			scriptStatus == #removed
				ifTrue: [targetPlayer removeScript: scriptSelector].
			board isHeadless
				ifFalse: [targetPlayer waitTick]]! !

!SqScriptModifiedEvent methodsFor: 'properties' stamp: 'mu 5/16/2006 15:17'!
saveProperties: aPlayer withArgs: anArray
	| sele scriptOwner |
	super saveProperties: aPlayer withArgs: anArray.

	sele _ anArray first.
	self argsAt: #scriptSelector put: sele.
	self argsAt: #scriptStatus put: anArray second.
	self argsAt: #scriptSource put: anArray third.

	scriptOwner _ anArray last.
	self argsAt: #playerAssociations put: (scriptOwner playerAssociationsIn: sele).! !

!SqScriptModifiedEvent methodsFor: 'defaults' stamp: 'minami 4/28/2006 14:18'!
type
	^ #scriptModified! !

!SqScriptModifiedEvent methodsFor: 'actions' stamp: 'minami 4/28/2006 14:19'!
undo: board
	Transcript cr; show: thisContext printString.! !

SqEvent subclass: #SqScriptStatusChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqScriptStatusChangedEvent methodsFor: 'actions' stamp: 'minami 5/17/2006 14:45'!
execute: board
	| targetPlayer scriptSelector scriptStatus |

	targetPlayer := self findPlayerByUid: self targetId on: board.
	targetPlayer ifNil: [^ self].

	scriptSelector := self argsAt: #scriptSelector.
	scriptStatus := self argsAt: #scriptStatus.

	targetPlayer stopRecordingWhile: [
		scriptStatus == #resumed ifTrue: [targetPlayer resumeScript: scriptSelector].
		scriptStatus == #paused ifTrue: [targetPlayer pauseScript: scriptSelector].
		scriptStatus == #terminated ifTrue: [targetPlayer stopScript: scriptSelector].
		scriptStatus == #started ifTrue: [targetPlayer startScript: scriptSelector].

		board isHeadless ifFalse: [targetPlayer waitTick].
	].

! !

!SqScriptStatusChangedEvent methodsFor: 'properties' stamp: 'minami 5/9/2006 16:41'!
saveProperties: aPlayer withArgs: anArray
	super saveProperties: aPlayer withArgs: anArray.

	self argsAt: #scriptSelector put: anArray first.
	self argsAt: #scriptStatus put: anArray second.
! !

!SqScriptStatusChangedEvent methodsFor: 'defaults' stamp: 'minami 4/27/2006 14:48'!
type
	^ #scriptStatusChanged! !

!SqScriptStatusChangedEvent methodsFor: 'actions' stamp: 'minami 4/27/2006 14:49'!
undo: board
	Transcript cr; show: thisContext printString.! !

SqEvent subclass: #SqTextChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqTextChangedEvent methodsFor: 'defaults' stamp: 'mu 5/29/2006 15:04'!
defaultEnabledPropertyNames
	^ #(#textEnabled)	! !

!SqTextChangedEvent methodsFor: 'defaults' stamp: 'mu 5/29/2006 15:05'!
defaultPropertyNames
	^ #(#text)	! !

!SqTextChangedEvent methodsFor: 'accessing' stamp: 'mu 5/29/2006 15:04'!
text
	^self argsAt: #text! !

!SqTextChangedEvent methodsFor: 'accessing' stamp: 'mu 5/29/2006 15:04'!
textEnabled
	^(self argsAt: #textEnabled) ifNil: [true]! !

!SqTextChangedEvent methodsFor: 'accessing' stamp: 'mu 5/29/2006 15:10'!
textEnabled: aBoolean
	self argsAt: #textEnabled put: aBoolean == true! !

!SqTextChangedEvent methodsFor: 'defaults' stamp: 'minami 12/22/2005 11:09'!
type
	^ #textChanged! !

SqEvent subclass: #SqTextEditorStatusChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqTextEditorStatusChangedEvent methodsFor: 'defaults' stamp: 'minami 5/17/2006 14:24'!
defaultPropertyNames
	^ #(#allowEditing)	! !

!SqTextEditorStatusChangedEvent methodsFor: 'defaults' stamp: 'minami 5/17/2006 14:24'!
type
	^ #textEditorStatusChanged! !

!SqTextEditorStatusChangedEvent methodsFor: 'testing' stamp: 'minami 5/26/2006 14:59'!
waitTickNeeded
	^ true! !

SqEvent subclass: #SqUngroupEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqUngroupEvent methodsFor: 'actions' stamp: 'mu 5/17/2006 13:52'!
execute: board
	| targetPlayer |
	targetPlayer := self findPlayerByUid: self targetId on: board.
	targetPlayer ifNil: [^ self].

	targetPlayer ungroup
! !

!SqUngroupEvent methodsFor: 'defaults' stamp: 'minami 4/5/2006 14:12'!
type
	^ #ungroup! !

SqEvent subclass: #SqVerticesChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event-Concrete'!

!SqVerticesChangedEvent methodsFor: 'defaults' stamp: 'minami 4/12/2006 15:40'!
defaultPropertyNames
	^ #(#vertices)	! !

!SqVerticesChangedEvent methodsFor: 'actions' stamp: 'mu 5/31/2006 14:44'!
execute: board 
	| player hasHandles |
	player _ self findPlayerByUid: self targetId on: board.
	player
		ifNil: [^ nil].
	player
		stopRecordingWhile: [hasHandles _ player hasHandles.
			[(board isRecovering
					or: [self accessId ~= board accessId])
				ifTrue: [player basicSetVertices: self vertices]]
				ensure: [hasHandles
						ifTrue: [player addHandles]]]! !

!SqVerticesChangedEvent methodsFor: 'defaults' stamp: 'minami 4/11/2006 17:24'!
type
	^ #verticesChanged! !

!SqVerticesChangedEvent methodsFor: 'accessing' stamp: 'mu 5/29/2006 17:29'!
vertices
	^self argsAt: #vertices ifAbsent: []! !

!SqVerticesChangedEvent methodsFor: 'accessing' stamp: 'mu 5/29/2006 17:30'!
vertices: values
	self argsAt: #vertices put: values! !

!SqVerticesChangedEvent methodsFor: 'testing' stamp: 'minami 5/26/2006 13:15'!
waitTickNeeded
	^ true! !

Object subclass: #SqEventPlayer
	instanceVariableNames: 'events board executedEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

!SqEventPlayer class methodsFor: 'defaults' stamp: 'minami 4/26/2006 15:17'!
maxEventBufferSize
	^ 300! !

!SqEventPlayer class methodsFor: 'instance creation' stamp: 'minami 12/22/2005 15:14'!
on: aBoard 
	^ super new on: aBoard;
		 yourself! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:28'!
addAllDifferences: col
	| lae |
	lae := self lastEvent.
	col do: [:evt | 
		(lae eventId < evt eventId) 
			ifTrue: [self events addLast: evt]].
	^ col! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:29'!
addAllFirst: col
	col reverseDo: [:each | self events addFirst: each].
	^ col! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:30'!
addAll: col
	col do: [:each | self events addLast: each].
	^ col! !

!SqEventPlayer methodsFor: 'adding' stamp: 'minami 4/26/2006 15:10'!
addExecutedEvent: evt
	(self executedEvents size >= self class maxEventBufferSize)
		ifTrue: [self executedEvents removeFirst].

	self executedEvents addLast: evt.! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:28'!
addFirst: event
	^ self events addFirst: event! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:30'!
addLast: event
	^ self events addLast: event! !

!SqEventPlayer methodsFor: 'adding' stamp: 'mu 3/1/2006 17:27'!
add: event
	^ self events addLast: event! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'minami 12/22/2005 15:16'!
board
	^ board! !

!SqEventPlayer methodsFor: 'initialize' stamp: 'MU 2/10/2006 15:44'!
destroy
	self stop.
	board ifNotNilDo: [:bo | bo boardClient ifNotNilDo: [:bc | bc unregisterEventPlayer: self]].
	
	events _ board _ executedEvents _ nil! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:26'!
events
	events ifNil: [events _ SqSharedCollection new: 100].
	^events! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:27'!
executedEvents
	executedEvents ifNil: [executedEvents _ SqSharedCollection new: 100].
	^executedEvents! !

!SqEventPlayer methodsFor: 'actions' stamp: 'mu 5/23/2006 16:02'!
executeNextEvent
	| evt |
	
	evt := self events firstOrNil ifNil: [^ nil].
	(evt isOnTheSameBoard: board) ifFalse: [^ nil].

	evt displayForDebug: 3.
	
	(board isRecovering
			or: [evt userSerial ~= board userSerial
					or: [evt imageId ~= board imageId]])
		ifTrue: [evt execute: board].
	"self addExecutedEvent: evt."

	self hasMoreEventsToPlay ifFalse: [self signal: #allEventsExecuted]
	! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:30'!
firstEvent
	self events notEmpty ifTrue: [^ self events first].
	self executedEvents notEmpty ifTrue: [^ self executedEvents first].
	^ nil! !

!SqEventPlayer methodsFor: 'running' stamp: 'mu 3/1/2006 17:28'!
forward
	self stop.

	[self events isEmpty] whileFalse: [
		self executeNextEvent
	].! !

!SqEventPlayer methodsFor: 'testing' stamp: 'MU 2/10/2006 17:12'!
hasMoreEventsToPlay
	^self isEmpty not! !

!SqEventPlayer methodsFor: 'testing' stamp: 'mu 3/1/2006 17:30'!
isEmpty
	^ self events isEmpty.
! !

!SqEventPlayer methodsFor: 'accessing' stamp: 'mu 3/1/2006 17:28'!
lastEvent
	self events notEmpty ifTrue: [^ events last].
	self executedEvents notEmpty ifTrue: [^ executedEvents last].
	^ nil! !

!SqEventPlayer methodsFor: 'initialize' stamp: 'mu 3/1/2006 17:27'!
on: aBoard
	board := aBoard.
	events := nil.
	executedEvents := nil.
	board boardClient registerEventPlayer: self! !

!SqEventPlayer methodsFor: 'running' stamp: 'minami 1/30/2006 15:08'!
play
	self stop.

	self startTicking: #executeNextEvent at: 100! !

!SqEventPlayer methodsFor: 'running' stamp: 'minami 1/30/2006 15:09'!
playReverse
	self stop.

	self startTicking: #undoPreviousEvent at: 100! !

!SqEventPlayer methodsFor: 'printing' stamp: 'MU 2/8/2006 16:52'!
printOn: aStream
	aStream nextPutAll: 'a ', self class name, '('.
	events ifNotNilDo: [:o | aStream nextPutAll: ' events: ', o asString]. 
	executedEvents ifNotNilDo: [:o | aStream nextPutAll: ' executedEvents: ', o asString].
	board ifNotNilDo: [:o | aStream nextPutAll: ' board: ', o asString].
	aStream nextPutAll: ')'! !

!SqEventPlayer methodsFor: 'running' stamp: 'minami 5/17/2006 15:00'!
stop
	self stopScript: #executeNextEvent.
	self stopScript: #undoPreviousEvent ! !

!SqEventPlayer methodsFor: 'actions' stamp: 'mu 3/1/2006 17:31'!
undoPreviousEvent
	| evt |
	evt := self executedEvents lastOrNil.
	evt ifNotNil: [	
		evt undo: self board.
		self events addFirst: evt.
	].
! !

!SqEventPlayer methodsFor: 'running' stamp: 'mu 3/1/2006 17:31'!
unwind
	self stop.

	[self executedEvents isEmpty] whileFalse: [
		self undoPreviousEvent
	].! !

!SqEventPlayer methodsFor: 'updating' stamp: 'minami 1/16/2006 12:13'!
update: aspect with: args
	aspect == #eventAdded ifTrue: [self addLast: args].

	super update: aspect with: args! !

Object subclass: #SqEventRecordHolder
	instanceVariableNames: 'events currentNumber mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

!SqEventRecordHolder methodsFor: 'adding' stamp: 'mu 4/28/2006 15:09'!
add: event 
	(self shouldAddEvent: event)
		ifTrue: [self processAddingEvent: event.
			self basicAdd: event]! !

!SqEventRecordHolder methodsFor: 'adding' stamp: 'mu 4/28/2006 15:02'!
basicAdd: event
	"mutex critical: [self events add: event.]." self flag: #TODO.
	self events add: event.
	
! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 3/7/2006 15:07'!
currentNumber
	^currentNumber! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'minami 3/29/2006 15:35'!
currentNumber: anInteger
	currentNumber := anInteger! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 4/5/2006 17:22'!
events
	events ifNil: [events := OrderedCollection new:100].
	^ events! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 4/5/2006 17:22'!
events: collection
	events := collection! !

!SqEventRecordHolder methodsFor: 'accessing' stamp: 'mu 4/5/2006 16:54'!
firstEventNumber
	self events ifEmpty: [^-1. "I have no events"].
	^self events first eventId! !

!SqEventRecordHolder methodsFor: 'private' stamp: 'minami 12/19/2005 16:46'!
incrementCurrentNumber
	currentNumber := currentNumber + 1.
	^ currentNumber! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'mu 4/5/2006 17:22'!
initEventRecords
	events := OrderedCollection new:100! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'MU 2/9/2006 14:58'!
initialize
	super initialize.
	mutex := Semaphore forMutualExclusion.
	self resetEventRecords! !

!SqEventRecordHolder methodsFor: 'private' stamp: 'mu 4/28/2006 15:09'!
lastIsSame: event
	self events ifEmpty: [^false].
	^self events last = event! !

!SqEventRecordHolder methodsFor: 'printing' stamp: 'MU 2/9/2006 14:54'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	currentNumber ifNotNilDo: [:num | aStream nextPutAll: 'currentNumber: ', num asString].
	aStream nextPutAll: ')'! !

!SqEventRecordHolder methodsFor: 'adding' stamp: 'mu 4/28/2006 15:12'!
processAddingEvent: event
	event eventId ifNil: [
		event eventId: self incrementCurrentNumber.
		event setTimeStamp.
	].
! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'MU 2/10/2006 15:36'!
release
	self resetEventRecords.
	mutex initSignals! !

!SqEventRecordHolder methodsFor: 'initializing' stamp: 'mu 4/5/2006 16:32'!
resetEventRecords
	self currentNumber: 0. 
	self initEventRecords .! !

!SqEventRecordHolder methodsFor: 'adding' stamp: 'mu 4/28/2006 15:09'!
shouldAddEvent: event
	^(self lastIsSame: event) not! !

Object subclass: #SqExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Tests'!

!SqExample class methodsFor: 'scripts' stamp: 'mu 5/22/2006 14:36'!
createBoardOnServer
	"SqExample createBoardOnServer"
	| uid bd |
	uid := '50dfb1655b98' asSqUid.
	bd := SqBoard id: uid name: 'board1'.
	SqSquareDB default registerGroup: bd.
	^ bd! !

!SqExample class methodsFor: 'scripts' stamp: 'minami 1/26/2006 18:11'!
initRpcServices
	SqRpcDispatcher registerAllServices! !

!SqExample class methodsFor: 'scripts' stamp: 'mu 5/9/2006 13:12'!
startClientByMenu
	"SqExample startClientByMenu"
	| userId password client board boardClient boards menuCol selectedUid |

	SqConnectionKeeper default start.

	"RPC"
	userId _ UIManager default request: 'userId?'.
	password _ UIManager default requestPassword: userId, '''s password?'.
	client _ SqClient userId: userId.
	(client login: userId password: password) ifFalse: [^ self error: 'login failed'].

	boards _ client boards.
	menuCol _ boards collect: [:e | Array with: e name with: e boardId].

	menuCol _ {{'create new board...'. SqUid nilUid}}, menuCol.
	selectedUid _ (SelectionMenu fromArray: menuCol) startUp ifNil: [^ self].
	
	board _ selectedUid = SqUid nilUid 
		ifTrue: [| bn |
				bn _ UIManager default request: 'new board name?'.
				bn isEmptyOrNil ifTrue: [^ self].
				 client createNewBoard: bn]
		ifFalse: [client boardAt: selectedUid asSqUid].

	"Create BoardClient"
	boardClient _ client enterIn: board.

	"Tweak"
	SqUIBuilder default openBoardWindowFor: boardClient! !

!SqExample class methodsFor: 'scripts' stamp: 'MU 1/20/2006 16:39'!
startRpcDispatcher
"
SqExample startRpcDispatcher
"
	SqRpcDispatcher start! !

!SqExample class methodsFor: 'scripts' stamp: 'mu 3/27/2006 15:33'!
startServer
"
SqExample startServer
"
	SqServer default stop.
	SqServer initialize.
	SqServer default start.
	SqServer default inspectAll.
	
	SqAudioChatServerFacade default start; inspect.
	SqServicePublisher startPublish.

	^ SqServer default ! !

!SqExample class methodsFor: 'scripts' stamp: 'mu 3/27/2006 16:14'!
stopAndInitAll
"
SqExample stopAndInitAll
"
	SqAudioChatServerFacade default stop.
	SqConnectionKeeper default stop.
	SqUtil prepareForClient.
	self initRpcServices.

	
	! !

!SqExample class methodsFor: 'scripts' stamp: 'MU 2/23/2006 18:34'!
stopClient
	SqClient closeAll.
! !

!SqExample class methodsFor: 'scripts' stamp: 'minami 1/19/2006 16:45'!
stopServer
	SqServer default stop.
	SqServer initialize.
! !

Object subclass: #SqImageId
	instanceVariableNames: ''
	classVariableNames: 'LastIdString LastImageName LastIp'
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

SqImageId class
	instanceVariableNames: 'current'!

!SqImageId class methodsFor: 'accessing' stamp: 'mu 8/15/2005 11:31'!
current
	^ current! !

!SqImageId class methodsFor: 'private' stamp: 'minami 1/13/2006 13:34'!
hasEnvironmentChanged
	"SqImageId hasEnvironmentChanged"
	self lastIp ~= self localAddress ifTrue: [^true].
	self lastImageName ~= SmalltalkImage current imageName ifTrue: [^true].
	^false
	! !

!SqImageId class methodsFor: 'class initialization' stamp: 'mu 5/9/2006 14:44'!
initCurrent
	self initCurrent: SqUid new.
	! !

!SqImageId class methodsFor: 'class initialization' stamp: 'mu 5/14/2005 00:43'!
initCurrent: uuid 
	| oldCurrent |
	oldCurrent _ current.
	current _ uuid.
	oldCurrent = current
		ifFalse: [self changed: #imageIdNew with: current asString]! !

!SqImageId class methodsFor: 'class initialization' stamp: 'minami 1/13/2006 13:36'!
initialize
	"SqImageId initialize"
	LastIdString _ LastIp _ LastImageName _ nil.
	self nullify.
	self rememberEnvironment.
	self initCurrent.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	! !

!SqImageId class methodsFor: 'private' stamp: 'mu 5/9/2006 14:44'!
lastIdString
	LastIdString
		ifNil: [LastIdString _ SqUid new asString].
	^ LastIdString! !

!SqImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:40'!
lastImageName
	LastImageName
		ifNil: [LastImageName _ SmalltalkImage current imageName].
	^ LastImageName! !

!SqImageId class methodsFor: 'private' stamp: 'minami 1/13/2006 13:33'!
lastIp
	LastIp
		ifNil: [LastIp _ self localAddress].
	^ LastIp! !

!SqImageId class methodsFor: 'actions' stamp: 'mu 8/16/2005 07:47'!
leave
	"self leave"
	self changed: #imageIdLeave with: current asString.
! !

!SqImageId class methodsFor: 'private' stamp: 'mu 3/31/2006 14:14'!
localAddress
	^SqUtil localAddressStringAskIfDetectionFailed! !

!SqImageId class methodsFor: 'actions' stamp: 'mu 8/15/2005 11:40'!
nullify
	"self nullify"
	self changed: #imageIdNull with: current asString.
	current _ nil
! !

!SqImageId class methodsFor: 'class initialization' stamp: 'minami 1/13/2006 13:34'!
obsolete
	"SqImageId initialize"
	self nullify.
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.
	! !

!SqImageId class methodsFor: 'private' stamp: 'minami 1/13/2006 13:33'!
rememberEnvironment
	current
		ifNotNilDo: [:uid | LastIdString _ uid asString].
	LastIp _ self localAddress.
	LastImageName _ SmalltalkImage current imageName! !

!SqImageId class methodsFor: 'actions' stamp: 'mu 5/9/2006 14:45'!
resetTo: uid 
	| newCurrent |
	newCurrent _ (uid isMemberOf: SqUid)
				ifTrue: [uid]
				ifFalse: [[SqUid fromString: uid asString]
						on: Error
						do: [:ex | ex return: nil]].
	newCurrent isNil
		ifTrue: [^ self].
	self leave.
	self initCurrent: newCurrent.
	! !

!SqImageId class methodsFor: 'system startup' stamp: 'mu 8/15/2005 11:21'!
shutDown: quitting
	quitting ifTrue: [self leave]! !

!SqImageId class methodsFor: 'system startup' stamp: 'mu 5/9/2006 14:45'!
startUp: resuming 
	self hasEnvironmentChanged
		ifTrue: [self initCurrent]
		ifFalse: [current _ SqUid fromString: self lastIdString].
	self rememberEnvironment! !

Object subclass: #SqPlayerEventFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Event'!

SqPlayerEventFactory class
	instanceVariableNames: 'eventClassDic'!

!SqPlayerEventFactory class methodsFor: 'private' stamp: 'mu 3/17/2006 11:27'!
buildEventClassDic
	"SqPlayerEventFactory buildEventClassDic"
	| dic |
	dic := Dictionary new.
	(SqEvent allSubclasses reject: [:each | each isCommand]) do: [:each | dic at: each basicNew type put: each name].
	^dic

	
	! !

!SqPlayerEventFactory class methodsFor: 'factory' stamp: 'mu 5/16/2006 14:57'!
createEvent: symbol target: player accessId: accessId args: args
	| clazz |
	clazz := self eventClass: symbol.
	clazz ifNil: [^ nil].

	^ clazz new
		 target: player;
		 accessId: accessId;
		 saveProperties: player withArgs: args;
		 forSend;
		 yourself! !

!SqPlayerEventFactory class methodsFor: 'private' stamp: 'MU 2/15/2006 16:12'!
eventClassDic
	"SqEventFactory eventClassDic"
	eventClassDic ifNil: [eventClassDic := self buildEventClassDic].
	^ eventClassDic! !

!SqPlayerEventFactory class methodsFor: 'factory' stamp: 'minami 1/9/2006 05:05'!
eventClass: eventSymbol 
	
	| clsName |
	clsName := self eventClassDic at: eventSymbol ifAbsent: [].
	clsName ifNil: [self inform: 'UnhandledEvent => ' , eventSymbol. ^ nil].
	
	^ Smalltalk at: clsName ifAbsent: [^ nil].! !

!SqPlayerEventFactory class methodsFor: 'class initialization' stamp: 'minami 1/9/2006 04:48'!
initialize
	eventClassDic := nil! !

Object subclass: #SqProjectSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqProjectSerializer class methodsFor: 'private' stamp: 'mu 3/1/2006 16:00'!
compress: bytes
	^bytes compressIfMoreThan: SqSettings compressThreshold! !

!SqProjectSerializer class methodsFor: 'default serialization' stamp: 'mu 5/17/2006 14:58'!
defaultDeserialize: bytes
	| parts player |
	parts _ RmtStreamer unstream: (self uncompress: bytes) by: #default.
	player _ SqPlayerMaker fromParts: parts.
	^player! !

!SqProjectSerializer class methodsFor: 'default serialization' stamp: 'mu 5/18/2006 16:14'!
defaultSerialize: aCPlayer
	| serializer parts |
	serializer _ SqPlayerSerializer new.
	serializer isForSendingEvents: false.
	parts _ serializer serialize: aCPlayer.
	"parts inspect."
	^self compress: (RmtStreamer stream: parts by: #default)! !

!SqProjectSerializer class methodsFor: 'actions' stamp: 'MU 2/24/2006 16:17'!
deserialize: bytes
	| deserializer |
	deserializer _ SqSettings playerSerializer.
	deserializer = #ODF ifTrue: [^self odfDeserialize: bytes].
	^self defaultDeserialize: bytes! !

!SqProjectSerializer class methodsFor: 'odf serialization' stamp: 'MU 2/27/2006 12:00'!
odfDeserialize: bytes 
	| stream player |
	[stream := RWBinaryOrTextStream with: bytes.
	player := [(ODFParser parseOn: stream) firstCPlayer]
				on: Error
				do: [:ex | 
					ex pass.
					"ex log.
					ex return"]]
		ensure: [stream
				ifNotNilDo: [:str | str close]].
	^ Processor activeIsland copy: player! !

!SqProjectSerializer class methodsFor: 'odf serialization' stamp: 'MU 2/24/2006 16:22'!
odfSerialize: aPlayer
	| stream |
	stream := RWBinaryOrTextStream on: (ByteArray new: 500).
	ODF exportPlayer: aPlayer on: stream.
	stream close.
	^stream contents! !

!SqProjectSerializer class methodsFor: 'actions' stamp: 'MU 2/24/2006 16:20'!
serialize: aCPlayer
	| serializer |
	serializer _ SqSettings playerSerializer.
	serializer = #ODF ifTrue: [^self odfSerialize: aCPlayer].
	^self defaultSerialize: aCPlayer! !

!SqProjectSerializer class methodsFor: 'private' stamp: 'mu 3/1/2006 15:20'!
uncompress: bytes
	^bytes uncompressOnDemand! !

Object subclass: #SqSharedCollection
	instanceVariableNames: 'contentsCollection accessProtect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqSharedCollection class methodsFor: 'instance creation' stamp: 'minami 12/22/2005 17:16'!
new
	^ self new: 10! !

!SqSharedCollection class methodsFor: 'instance creation' stamp: 'minami 12/22/2005 17:18'!
new: anInteger 
	^super new init: anInteger! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:46'!
addFirst: value 
	accessProtect critical: [contentsCollection addFirst: value].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:46'!
addLast: value 
	accessProtect critical: [contentsCollection addLast: value].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:13'!
first
	^ contentsCollection first! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:47'!
firstOrNil
	| value |

	accessProtect critical: [
		value := self isEmpty 
			ifTrue: [nil]
			ifFalse: [contentsCollection removeFirst].
	].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:47'!
flush
	"Throw out all pending contents"
	accessProtect critical: [
		contentsCollection := OrderedCollection new: 10.
	].! !

!SqSharedCollection methodsFor: 'private' stamp: 'minami 12/26/2005 16:47'!
init: size 
	contentsCollection := OrderedCollection new: size.
	accessProtect := Semaphore forMutualExclusion.
! !

!SqSharedCollection methodsFor: 'testing' stamp: 'minami 12/22/2005 14:50'!
isEmpty
	^ contentsCollection isEmpty! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:13'!
last
	^ contentsCollection last! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/26/2005 16:47'!
lastOrNil
	| value |

	accessProtect critical: [
		value := self isEmpty 
			ifTrue: [nil]
			ifFalse: [contentsCollection removeLast].
	].
	^value! !

!SqSharedCollection methodsFor: 'testing' stamp: 'minami 12/26/2005 16:12'!
notEmpty
	^ self isEmpty not! !

!SqSharedCollection methodsFor: 'printing' stamp: 'MU 2/8/2006 16:45'!
printOn: aStream
	aStream nextPutAll: 'a ', self class name, '('.
	aStream nextPutAll: contentsCollection asString.
	aStream nextPutAll: ')'! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 4/26/2006 15:12'!
removeFirst
	| value |
	accessProtect critical: [value := contentsCollection removeFirst].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 4/26/2006 15:13'!
removeLast
	| value |
	accessProtect critical: [value := contentsCollection removeLast].
	^value! !

!SqSharedCollection methodsFor: 'accessing' stamp: 'minami 12/22/2005 14:55'!
size
	"Answer the number of objects that have been sent through the
	receiver and not yet received by anyone."

	^ contentsCollection size! !

Object subclass: #SqUidMaker
	instanceVariableNames: 'highValue lowValue highValueCounter digitSize'
	classVariableNames: 'RandomGenerator'
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

SqUidMaker class
	instanceVariableNames: 'default'!

!SqUidMaker class methodsFor: 'instance creation' stamp: 'mu 5/9/2006 10:41'!
default
	^ default ifNil: [default _ self new]! !

!SqUidMaker class methodsFor: 'class initialization' stamp: 'mu 5/9/2006 12:14'!
initialize
	"SqIdMaker initialize"

	RandomGenerator _ nil.
	default _ nil.

	Smalltalk addToStartUpList: self! !

!SqUidMaker class methodsFor: 'class initialization' stamp: 'mu 5/9/2006 11:43'!
obsolete
	RandomGenerator _ nil.
	default _ nil.

	Smalltalk removeFromStartUpList: self.
	super obsolete! !

!SqUidMaker class methodsFor: 'accessing' stamp: 'mu 5/9/2006 11:41'!
randomGenerator
	RandomGenerator
		ifNil: [RandomGenerator := Random seed: UUIDGenerator default makeSeed].
	^ RandomGenerator! !

!SqUidMaker class methodsFor: 'startUp' stamp: 'mu 5/9/2006 12:19'!
startUp: resuming 
	resuming
		ifTrue: [self initialize]! !

!SqUidMaker methodsFor: 'accessing' stamp: 'mu 5/9/2006 11:36'!
digitSize
	^digitSize! !

!SqUidMaker methodsFor: 'accessing' stamp: 'mu 5/9/2006 12:51'!
digitSize: anInteger
	anInteger even ifFalse: [self error: 'Please use even number!!'].

	(digitSize ~= anInteger) ifTrue: [
		self highValueCounter: 0.
		self highValue: nil].

	digitSize _ anInteger! !

!SqUidMaker methodsFor: 'accessing' stamp: 'mu 5/9/2006 12:52'!
highValue
	highValue ifNil: [highValue _ self privNextValue].
	^ highValue! !

!SqUidMaker methodsFor: 'accessing' stamp: 'M.U 6/6/1999 00:58'!
highValueCounter
	^highValueCounter! !

!SqUidMaker methodsFor: 'accessing' stamp: 'M.U 6/6/1999 00:58'!
highValueCounter: aValue

	highValueCounter := aValue! !

!SqUidMaker methodsFor: 'accessing' stamp: 'mu 5/9/2006 12:49'!
highValue: aValue
	highValue _ aValue! !

!SqUidMaker methodsFor: 'initialize-release' stamp: 'mu 5/9/2006 12:00'!
initialize
	highValueCounter := 0.
	digitSize _ 6.

	highValue _ lowValue _ nil! !

!SqUidMaker methodsFor: 'accessing' stamp: 'mu 5/9/2006 12:49'!
lowValue
	^ lowValue! !

!SqUidMaker methodsFor: 'accessing' stamp: 'mu 5/9/2006 12:52'!
lowValue: aValue
	lowValue ifNil: [lowValue _ self privNextValue].
	lowValue _ aValue! !

!SqUidMaker methodsFor: 'private' stamp: 'mu 5/9/2006 12:24'!
nextHighValue
	self highValueCounter: self highValueCounter + 1.
	self highValueCounter > 255
		ifTrue: 
			[self highValueCounter: 0.
			self highValue: self privNextValue].
	^ self highValue.! !

!SqUidMaker methodsFor: 'private' stamp: 'M.U 6/6/1999 01:02'!
nextLowValue
	self lowValue: self privNextValue.
	^ self lowValue.! !

!SqUidMaker methodsFor: 'actions' stamp: 'mu 5/9/2006 12:10'!
nextStringValue
	| result strValue nextValue |
	nextValue := self nextValue.
	strValue := String new: self digitSize * 2.
	result := WriteStream on: strValue.
	1
		to: self digitSize
		do: [:i | nextValue printHexAt: i to: result].
	^ strValue! !

!SqUidMaker methodsFor: 'actions' stamp: 'M.U 6/6/1999 00:56'!
nextValue
	^self nextHighValue , self nextLowValue! !

!SqUidMaker methodsFor: 'private' stamp: 'mu 5/9/2006 11:57'!
privNextValue
	| sz bytes |
	sz := self digitSize // 2.
	bytes := ByteArray new: sz.
	1 to: sz do:[ :idx |
	bytes at: idx put: 255 atRandom]. 
	^bytes
	
	! !

!SqUidMaker methodsFor: 'private' stamp: 'mu 5/9/2006 11:41'!
randomGenerator
	^self class randomGenerator! !

!CTextLabel methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:39'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.

	self loadProperties: #(#smartEdit #allowEditing #autoFit ) from: dic ! !

!CTextLabel methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:34'!
loadOnTextEditorStatusChangedFrom: dic withArgs: args 
	super loadOnTextEditorStatusChangedFrom: dic withArgs: args.
	self loadProperties: #(#smartEdit #allowEditing #autoFit ) from: dic! !

!CTextLabel methodsFor: '*SqSquare-Core-events-override' stamp: 'minami 5/17/2006 14:25'!
onAutoFitChanged
	<on: autoFitChanged>
	autoFit ifTrue:[
		self hResizing: #shrinkWrap.
		self vResizing: #shrinkWrap.
	] ifFalse:[
		self hResizing: #spaceFill.
		self vResizing: #spaceFill.
	].

	self signal: #textEditorStatusChanged with: #autoFit! !

!CTextLabel methodsFor: '*SqSquare-Core-events-override' stamp: 'minami 5/17/2006 14:25'!
onEnableEdit
	"Note: Cannot be done by overriding onKeyboardFocusEnter as this gets paused by superclass when allowEditing changes. Since we want to enable it here, we must do so without being affected by it."
	<on: keyboardFocusEnter>
	smartEdit ifTrue:[self allowEditing: true].

	self signal: #textEditorStatusChanged with: #allowEditing! !

!CTextLabel methodsFor: '*SqSquare-Core-events-override' stamp: 'minami 5/17/2006 14:25'!
onSmartEditChanged
	"Turn on editing if not smart; turn off editing if smart and not focus"
	<on: smartEditChanged>
	smartEdit 
		ifTrue:[self hasKeyboardFocus ifFalse:[self allowEditing: false]]
		ifFalse:[self allowEditing: true].

	self signal: #textEditorStatusChanged with: #smartEdit! !

!CTextLabel methodsFor: '*SqSquare-Core-maker-helper' stamp: 'minami 5/29/2006 16:35'!
postBuildBoard

	self autoFit ifTrue: [^ self].

	self autoFit: true; autoFit: false.		"quick hack"! !

!CTextLabel methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:40'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(#smartEdit #allowEditing #autoFit ) into: dic ! !

!CTextLabel methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:34'!
saveOnTextEditorStatusChangedInto: dic withArgs: args 
	super saveOnTextEditorStatusChangedInto: dic withArgs: args.
	self saveProperties: #(#smartEdit #allowEditing #autoFit ) into: dic! !

CTextLabel subclass: #SqSheetPlayer
	instanceVariableNames: 'prevContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqSheetPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="players" toSet="players:" changeEvent="playersChanged">players</field>
	<field instanceVariable="true" serializable="false" toGet="prevContents" toSet="prevContents:">prevContents</field>
</fields>'!

!SqSheetPlayer class methodsFor: 'class initialization' stamp: 'minami 3/27/2006 11:34'!
initialize
	self registerToPartsBin! !

!SqSheetPlayer class methodsFor: 'instance creation' stamp: 'minami 3/27/2006 11:57'!
newSample
	| sample |
	sample := self new.
	sample extent: 150@150.
	^sample! !

!SqSheetPlayer class methodsFor: 'class initialization' stamp: 'minami 3/27/2006 11:33'!
registerToPartsBin
"
	SqSheetPlayer registerToPartsBin
"
	CPartsBin
		registerPartDescription: (CPartDescription
				partDescriptionWithLabel: 'Sheet'
				balloonHelp: 'a player works like a paper '
				category: '-SqSquare'
				creator: SqSheetPlayer
				selector: #newbornPartToDropIn:
				customForm: nil).! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'minami 4/14/2006 15:57'!
addPlayer: aPlayer
	self eventRecordBoard 
		ifNil: [self doAddPlayer: aPlayer]
		ifNotNilDo: [:b |
			b removeCoverWhile: [self doAddPlayer: aPlayer]]! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'mu 4/3/2006 17:23'!
attachBoardPropertiesTo: aPlayer
	aPlayer scale: 1.
! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'minami 2/24/2006 17:20'!
attachEventRecordBehavior: aPlayer
	| behavior |
	self eventRecordBoard ifNil: [^ self].

	behavior := self eventRecordBehaviorClass attachTo: aPlayer.
	behavior board: self eventRecordBoard.
! !

!SqSheetPlayer methodsFor: 'actions' stamp: 'minami 4/5/2006 13:30'!
attacheAllContentsTo: boardOrSheet
	| elems |
	elems := self elements asArray.

	elems size to: 1 by: -1 do:[:i |
		| p |
		p := elems at: i.
		p hasPlayer 
			ifFalse: [self addPlayer: p]
			ifTrue: [
				p player isComplexPlayer ifTrue: [
					self addPlayer: p player.
					p player attacheAllContentsTo: self].
			].
	].
! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'mu 5/9/2006 12:32'!
doAddPlayer: aPlayer
	| tfm targetInstance |
	(self isIn: aPlayer) ifTrue: [^ aPlayer signal: #dropReject].
	aPlayer isHandle ifTrue: [^ aPlayer close].

	aPlayer isDropAcceptable ifFalse: [^ aPlayer signal: #dropReject].

	tfm := self globalToLocal composedWithLocal: aPlayer localToGlobal.
	aPlayer transform: tfm.

	self add: aPlayer.

	self isRecording ifFalse: [^ self].
	self isOnAnyBoard ifFalse: [^ self].

	targetInstance := (aPlayer isKindOf: CPartPrecursor)
							ifTrue: [aPlayer signal: #dropAccept with: self. "see: CPartPrecursor >> onDropped"
									self waitTick.
									aPlayer instance]
							ifFalse: [aPlayer].

	targetInstance hasPlayerId ifFalse: [
		targetInstance playerId: SqUid new.
		self attachEventRecordBehavior: targetInstance.
		self recordCreateEventFor: targetInstance.
		self waitTickIfOnDisplayedBoard.
		self recordDefaultStatus: targetInstance.
		self attachBoardPropertiesTo: targetInstance.
		targetInstance attacheAllContentsTo: self.
	].

	targetInstance signal: #dropAccept with: self.
! !

!SqSheetPlayer methodsFor: 'defaults' stamp: 'minami 2/13/2006 13:39'!
eventRecordBehaviorClass
	^ SqEventRecordBehavior! !

!SqSheetPlayer methodsFor: 'testing' stamp: 'minami 5/23/2006 14:07'!
hasPlayerOrElements
	^ self elements notEmpty! !

!SqSheetPlayer methodsFor: 'initialize' stamp: 'minami 2/8/2006 10:56'!
initialize
	super initialize.

	self autoFit: false.
	self text: 'Edit here'.

! !

!SqSheetPlayer methodsFor: 'testing' stamp: 'minami 3/30/2006 12:16'!
isComplexPlayer
	^true! !

!SqSheetPlayer methodsFor: 'events' stamp: 'minami 5/25/2006 12:07'!
onDragDrop: aPlayer 
	<on: dragDrop>

	aPlayer isTileLike ifTrue: [
		aPlayer dropAt: aPlayer globalPosition in: self world.
		^ self
	].

	self addPlayer: aPlayer.
! !

!SqSheetPlayer methodsFor: 'actions' stamp: 'minami 3/2/2006 10:49'!
onDropAccepted
	self attacheAllContentsTo: self! !

!SqSheetPlayer methodsFor: 'events' stamp: 'minami 2/8/2006 11:06'!
onMouseDrag
	| draggee |

	<on: mouseDrag>

	draggee := self findDraggablePlayerAt: self cursorPoint.
	draggee ifNotNilDo: [:d | 	^ d onDrag].

	super onMouseDrag! !

!SqSheetPlayer methodsFor: 'opening' stamp: 'minami 2/21/2006 13:36'!
open
	super open.
	self postOpen.! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/6/2006 15:18'!
players
	"Answer the players of the receiver"
	<bewareOf: #playersChanged>
	^self propertyValueAt: #players! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/6/2006 15:18'!
players: aValue
	"Modify the receiver's players"
	^self propertyValueAt: #players put: aValue with: #playersChanged! !

!SqSheetPlayer methodsFor: 'opening' stamp: 'minami 2/21/2006 13:37'!
postOpen
	self width: 100.
	self height: 100.
! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/7/2006 19:20'!
prevContents
	"Answer the prevContents of the receiver"
	^prevContents! !

!SqSheetPlayer methodsFor: 'accessing' stamp: 'minami 2/7/2006 19:20'!
prevContents: aValue
	"Modify the receiver's prevContents"
	prevContents := aValue! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'mu 3/17/2006 11:21'!
recordCreateEventFor: aPlayer
	| evt  |
	self eventRecordBoard ifNil: [^ self].

	evt := SqPlayerEventFactory
				createEvent: #playerCreated
				target: aPlayer
				accessId: self eventRecordBoard accessId
				args: #().
	self eventRecordBoard recordEvent: evt.
! !

!SqSheetPlayer methodsFor: 'adding' stamp: 'minami 5/22/2006 16:25'!
recordDefaultStatus: aPlayer
	| aBehavior |
	aBehavior := aPlayer eventRecordBehavior.

	aBehavior recordEvent: #flagsChanged.
	aBehavior recordEvent: #fillChanged.
	aBehavior recordEvent: #geometryChanged.
	aBehavior recordEvent: #borderChanged.
	aBehavior recordEvent: #textChanged.
	aBehavior recordEvent: #graphicChanged.
! !

!SqSheetPlayer methodsFor: 'actions' stamp: 'minami 2/7/2006 19:20'!
setNewContents: aText
	self prevContents: aText.
	self contents: aText.
! !

!SqSheetPlayer methodsFor: 'initialize' stamp: 'minami 3/2/2006 10:51'!
setupCostume
	super setupCostume.

	self color: (Color r: 1.0 g: 1.0 b: 0.5)
	! !

!SoundPlayer class methodsFor: '*SqSquare-Core-player process' stamp: 'minami 4/10/2006 14:10'!
playLoop
	"The sound player process loop."

	| bytesPerSlice count willStop mayStop |
	mayStop _ Preferences soundStopWhenDone.
	bytesPerSlice _ Stereo ifTrue: [4] ifFalse: [2].
	[true] whileTrue: [
		[(count _ self primSoundAvailableBytes // bytesPerSlice) > 100]
			whileFalse: [ReadyForBuffer ifNotNilDo: [:sem | sem wait]].

		count _ count min: Buffer stereoSampleCount.
		PlayerSemaphore critical: [
			ActiveSounds _ ActiveSounds select: [:snd | snd samplesRemaining > 0].
			ActiveSounds do: [:snd |
				snd ~~ SoundJustStarted ifTrue: [
					snd playSampleCount: count into: Buffer startingAt: 1]].
			ReverbState == nil ifFalse: [
				ReverbState applyReverbTo: Buffer startingAt: 1 count: count].
			self primSoundPlaySamples: count from: Buffer startingAt: 1.
			willStop _ mayStop and:[
						(ActiveSounds size = 0) and:[
							self isAllSilence: Buffer size: count]].
			LastBuffer ifNotNil:[
				LastBuffer replaceFrom: 1 to: LastBuffer size with: Buffer startingAt: 1.
			].
			willStop
				ifTrue:[self shutDown. PlayerProcess _ nil]
				ifFalse:[Buffer primFill: 0].
			SoundJustStarted _ nil].
		willStop ifTrue:[^self].
	].
! !

!CHalo methodsFor: '*SqSquare-Core-override' stamp: 'MU 2/13/2006 15:48'!
handleSpecs
	"Answer specs defining the halo handles to use."

	^ Preferences debugHaloHandle
	 	ifFalse:
			[{{#haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.5.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.5.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.5.		Color cyan. 'v'. 	'Open Viewer'	}}]
		ifTrue:
			[{{ #haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.66667.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.66667.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloDebug.  1.0.		0.33333.		Color cyan muchLighter. 'D'. 'Debug'}.
			{ #haloTile.      0.0.		0.33333.	Color orange.	 't'.		'Tile'			}.
			{ #haloLink.      0.0.		0.5.	Color palePeach.	 'l'.		'Link'			}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.66667.		Color cyan. 'v'. 	'Open Viewer'	}}]
	! !

!CHalo methodsFor: '*SqSquare-Core-override' stamp: 'minami 2/16/2006 09:10'!
onSelectTarget
	| index list cc aHand boardPos |
	aHand := self hand.
	list := aHand playersUnder: aHand world.
	list isEmpty ifTrue:[^self].
"list inspect."
	boardPos := list findLast: [:e | e player findPlayerOf: SqBoardWindow].
	boardPos >= 3 ifTrue: [
		list := (list first: (boardPos - 1)) reverse , (list allButFirst: boardPos).
	].
"list inspect."
	cc := self target ifNotNil:[self target asPrimCostume].
	index := list identityIndexOf: (cc ifNil:[self rootContext]).
	index = 0 ifTrue:[
		aHand shiftPressed 
			ifTrue:[index := 1]
			ifFalse:[index := list size - 1]
	] ifFalse:[
		aHand shiftPressed
			ifTrue:[index := index+1]
			ifFalse:[index := index-1].
	].
	"@@@@: Fix this. Later figure out how to wrap and ask guys for interest"
	self target: (list atWrap: index) asPlayer haloTarget! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 20:30'!
addCustomeMenuItemsTo: aMenu
	super addCustomeMenuItemsTo: aMenu.

	aMenu addSeparator.

	aMenu add: self handlesShowingPhrase target: self action: #showOrHideHandles argument: #().

	self vertices size > 2 ifTrue: [
		aMenu add: self openOrClosePhrase target: self action: #makeOpenOrClosed.
		aMenu add: self smoothOrCloseSegmentedPhrase target: self action: #makeSmoothOrSegmented
	]. 

	closed ifFalse: [
		aMenu addSeparator.
		aMenu add: '---' target: self action: #makeNoArrows checked: (arrowStyle == #none).
		aMenu add: '-->' target: self action: #makeForwardArrow checked: (arrowStyle == #forward).
		aMenu add: '<--' target: self action: #makeBackArrow checked: (arrowStyle == #back).
		aMenu add: '<->' target: self action: #makeBothArrows checked: (arrowStyle == #both).
	]! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 4/8/2006 19:32'!
addHandles
	| handle newVert tri |
	self removeHandles.
	handles _ OrderedCollection new.
	tri _ Array with: 0@-4 with: 4@3 with: -3@3.
	vertices withIndexDo:
		[:vertPt :vertIndex |
		handle _ CEllipsePlayer new 
					bounds: (Rectangle center: vertPt extent: 8@8);
					color: Color yellow;
					yourself.
		self startVertHandleScripts: handle index: vertIndex.

		self addLast: handle.
		handles addLast: handle.

		(closed or: [vertIndex < vertices size]) ifTrue:
			[newVert _ CPolygonPlayer new
							vertices: (tri collect: [:p | p + (vertPt + (vertices atWrap: vertIndex+1) // 2)]);
							color: Color green;
							borderWidth: 1;
							borderColor: Color black;
							yourself.

			self startNewVertHandleScripts: newVert index: vertIndex.

			self addLast: newVert.
			handles addLast: newVert]].

	self waitTick.
	self updateHandles.

! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-private' stamp: 'mu 5/31/2006 12:12'!
basicComputeBounds
	| oldBounds newBounds |
	vertices ifNil: [^ self].

	oldBounds _ bounds.
	self releaseCachedState.
	newBounds _ self curveBounds.
	self arrowForms do: [:f | newBounds _ newBounds merge: (f offset extent: f extent)].

	handles ifNotNil: [self updateHandles].

	newBounds origin isZero ifFalse: [
		self basicSetVertices: (vertices collect: [:pt | pt - newBounds origin]).
		self releaseCachedState.
	].
	newBounds _ self asPrimCostume childToParent: newBounds.
	oldBounds = newBounds ifFalse:[self basicSetBounds: newBounds].
	self invalidate: (oldBounds merge: bounds).
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-private' stamp: 'mu 5/31/2006 12:38'!
basicSetBounds: aRectangle
	self pauseScript: #geometryChanged.
	self pauseScript: #extentChanged.
	self pauseScript: #verticesChanged.

	self bounds: aRectangle.

	self pauseScript: #geometryChanged.
	self pauseScript: #extentChanged.
	self pauseScript: #verticesChanged.! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-private' stamp: 'mu 5/31/2006 12:36'!
basicSetExtent: aPoint
	self pauseScript: #geometryChanged.
	self pauseScript: #extentChanged.
	self pauseScript: #verticesChanged.

	self extent: aPoint.

	self resumeScript: #geometryChanged.
	self resumeScript: #extentChanged.
	self resumeScript: #verticesChanged.! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-private' stamp: 'mu 5/31/2006 16:03'!
basicSetVertices: newVertices
	
	self propertyValueAt: #vertices put: newVertices.
	! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-private-override' stamp: 'mu 5/31/2006 14:55'!
computeBounds
	| oldBounds newBounds |
	vertices ifNil: [^ self].

	oldBounds _ bounds.
	self releaseCachedState.
	newBounds _ self curveBounds.
	self arrowForms do: [:f | newBounds _ newBounds merge: (f offset extent: f extent)].

	handles ifNotNil: [self updateHandles].

	newBounds origin isZero ifFalse: [
		self vertices: (vertices collect: [:pt | pt - newBounds origin]).
		self releaseCachedState.
	].
	newBounds _ self asPrimCostume childToParent: newBounds.
	oldBounds = newBounds ifFalse:[bounds _ newBounds].
	self invalidate: (oldBounds merge: bounds).
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-private-override' stamp: 'minami 4/12/2006 16:46'!
curveBounds
	| curveBounds pointAfterFirst pointBeforeLast |
	smoothCurve 
		ifFalse:
			[^(Rectangle encompassing: vertices) expandBy: (borderWidth + 1) // 2].

	"Compute the bounds from actual curve traversal, with leeway for borderWidth.
	Also note the next-to-first and next-to-last points for arrow directions."
	curveState := nil.	"Force recomputation"
	curveBounds := vertices first corner: vertices last.
	pointAfterFirst := nil.
	self lineSegmentsDo:[:p1 :p2 | 
		pointAfterFirst isNil ifTrue:[
				pointAfterFirst := p2 asIntegerPoint.
				curveBounds := curveBounds encompass: p1 asIntegerPoint].
			curveBounds := curveBounds encompass: p2 asIntegerPoint.
			pointBeforeLast := p1 asIntegerPoint].
	curveState at: 2 put: pointAfterFirst.
	curveState at: 3 put: pointBeforeLast.
	^curveBounds expandBy: (borderWidth + 1) // 2
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 3/31/2006 14:35'!
dragVertex: ix fromHandle: handle
	| p |
	self hand redButtonPressed ifFalse: [^ self].

	p _ self isCurve
		ifTrue: [self globalToLocal: self hand position.]
		ifFalse: [self globalToLocal: self hand position].
	handle center: p - (handle extent//2).
	self verticesAt: ix put: p.
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/7/2006 19:35'!
handlesShowingPhrase
	^ (self showingHandles
		ifTrue: ['hide handles']
		ifFalse: ['show handles']) translated! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 4/12/2006 16:45'!
hasHandles
	^ self handles notNil! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/12/2006 16:04'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.

	self loadProperties: #(#vertices #closed #smoothCurve #arrowStyle) from: dic ! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-properties' stamp: 'mu 5/31/2006 15:13'!
loadProperty: propName to: newValue 
	
	self wantsPropagateEvents: false.

	propName = 'extent'
		ifTrue: [self basicSetExtent: newValue forReceive.
			self basicComputeBounds]
		ifFalse: [self perform: (propName , ':') asSymbol with: newValue forReceive].


	self wantsPropagateEvents: true.! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:43'!
makeBackArrow
	arrowStyle _ #back.
	self computeBounds! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:44'!
makeBothArrows
	arrowStyle _ #both.
	self computeBounds! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:28'!
makeClosed
	closed := true.
	handles ifNotNil: [
		self removeHandles; addHandles.
		self waitTick.
		self computeBounds.
	].! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:43'!
makeForwardArrow
	arrowStyle _ #forward.
	self computeBounds! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:43'!
makeNoArrows
	arrowStyle _ #none.
	self computeBounds! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:28'!
makeOpen
	closed := false.
	handles ifNotNil: [
		self removeHandles; addHandles.
		self waitTick.
		self computeBounds.
	].! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:29'!
makeOpenOrClosed
	"toggle the open/closed status of the receiver"
	closed
		ifTrue: [self makeOpen]
		ifFalse: [self makeClosed]! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 17:51'!
makeSmoothOrSegmented
	self toggleSmoothing! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 3/30/2006 20:09'!
mouseDownVertex: ix fromHandle: handle
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 3/30/2006 20:08'!
mouseUpVertex: ix fromHandle: handle
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 4/8/2006 21:09'!
newVertex: ix fromHandle: handle
	| pt |
	pt _ handle center.
	self setVertices: (self vertices copyReplaceFrom: ix + 1 to: ix with: (Array with: pt)).
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-events' stamp: 'minami 4/12/2006 16:44'!
onClosedChanged
	<on: closedChanged>

	self computeBounds.
	self invalidate.! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-events' stamp: 'mu 5/31/2006 15:44'!
onVerticesChanged
	<on: verticesChanged>

	self computeBounds.
	self invalidate.! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-events' stamp: 'mu 5/31/2006 15:43'!
onVerticesChangedWith: evt
	<on: verticesChanged>

	self computeBounds.
	self invalidate.! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/7/2006 19:44'!
openOrClosePhrase
	| curveName |
	curveName _ self isCurve ifTrue: ['curve'] ifFalse: ['polygon'].
	^ closed
		ifTrue: ['make open ' , curveName]
		ifFalse: ['make closed ' , curveName]! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-copying-override' stamp: 'minami 4/12/2006 16:43'!
postCopy
	self removeHandles.
	super postCopy.! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 3/30/2006 19:10'!
removeHandles
	handles ifNotNil: [
		handles do: [:h | h close].
		handles _ nil].! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/12/2006 16:04'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(#vertices #closed #smoothCurve #arrowStyle) into: dic ! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-private' stamp: 'minami 4/12/2006 16:46'!
setVertices: newVertices
	vertices _ newVertices.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/7/2006 19:37'!
showingHandles
	^ handles notNil! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/7/2006 19:36'!
showOrHideHandles
	self showingHandles
		ifTrue:	[self removeHandles]
		ifFalse:	[self addHandles]! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/7/2006 20:02'!
smoothOrCloseSegmentedPhrase
	| lineName |
	lineName := (closed ifTrue: ['outline'] ifFalse: ['line']) translated.
	^ self isCurve 
		ifTrue: ['make segmented {1}' translated format: {lineName translated}]
		ifFalse: ['make smooth {1}' translated format: {lineName translated}]
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'mu 5/31/2006 15:25'!
startNewVertHandleScripts: newVertHandle index: vertIndex 
	newVertHandle
		startScript: [:i :h | 
						self wantsPropagateEvents: false.
						self newVertex: i fromHandle: h]
		withArguments: {vertIndex. newVertHandle}
		when: #mouseDown.

	newVertHandle
		startScript: [:i :h | ]
		withArguments: {vertIndex. newVertHandle}
		when: #mouseMove.

	newVertHandle
		startScript: [:i :h | 
						self wantsPropagateEvents: true.
						self newVertex: i fromHandle: h]
		withArguments: {vertIndex. newVertHandle}
		when: #mouseUp! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'mu 5/31/2006 15:44'!
startVertHandleScripts: handle index: vertIndex 
	handle
		startScript: [:i :h | 
						self wantsPropagateEvents: false.
						self mouseDownVertex: i fromHandle: h]
		withArguments: {vertIndex. handle}
		when: #mouseDown.

	handle
		startScript: [:i :h | self dragVertex: i fromHandle: h]
		withArguments: {vertIndex. handle}
		when: #mouseMove.

	handle
		startScript: [:i :h | 
					self wantsPropagateEvents: true.
					self mouseUpVertex: i fromHandle: h.
					self signal: #remoteVerticesChanged]
		withArguments: {vertIndex. handle}
		when: #mouseUp! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/8/2006 19:20'!
toggleSmoothing
	self smoothCurve: self smoothCurve not.
! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 4/8/2006 19:15'!
updateHandles
	smoothCurve
		ifTrue: [self updateHandlesAsSmoothCurve]
		ifFalse: [self updateHandlesAsNormal]! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 4/8/2006 17:55'!
updateHandlesAsNormal
	| newVert oldVert |
	vertices
		withIndexDo: [:vertPt :vertIndex | 
			oldVert _ handles at: vertIndex * 2 - 1.
			oldVert center: vertPt - (oldVert extent // 2) + (4 @ 4).
			(closed
					or: [vertIndex < vertices size])
				ifTrue: [newVert _ handles at: vertIndex * 2.
					newVert center: vertPt
							+ (vertices atWrap: vertIndex + 1) - newVert extent // 2 + (2 @ 2)]]! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 4/8/2006 18:59'!
updateHandlesAsSmoothCurve
	| newVert midPts nextVertIx tweens |


	1 to: handles size by: 2 do: [:idx |
		| handle vertPt |
		handle := handles at: idx.
		vertPt := self vertices at: (idx // 2 + 1).
		handle bounds: (Rectangle center: vertPt extent: 8@8).
	].

	midPts _ OrderedCollection new.
	nextVertIx _ 2.
	tweens _ OrderedCollection new.
	self
		lineSegmentsDo: [:p1 :p2 | 
			tweens addLast: p2 asIntegerPoint.
			p2
					= (vertices atWrap: nextVertIx)
				ifTrue: ["Found endPoint."
					midPts addLast: (tweens at: tweens size // 2)
							+ (tweens at: tweens size + 1 // 2) // 2.
					tweens _ OrderedCollection new.
					nextVertIx _ nextVertIx + 1]].
	midPts
		withIndexDo: [:midPt :vertIndex | (closed
					or: [vertIndex < vertices size])
				ifTrue: [newVert _ handles at: vertIndex * 2.
					newVert center: midPt - (newVert extent // 2)]]! !

!CPolygonPlayer methodsFor: '*SqSquare-Core-editing' stamp: 'minami 3/30/2006 20:05'!
verticesAt: ix put: newPoint
	vertices at: ix put: newPoint.
	self computeBounds.
	self invalidate.! !

CPolygonPlayer subclass: #SqLineConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqLineConnector class
	instanceVariableNames: 'cachedColors'!

SqLineConnector defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="fromTarget" toSet="fromTarget:" changeEvent="fromTargetChanged">fromTarget</field>
	<field toGet="toTarget" toSet="toTarget:" changeEvent="toTargetChanged">toTarget</field>
	<field toGet="alphaIndex" toSet="alphaIndex:" changeEvent="alphaIndexChanged">alphaIndex</field>
	<field toGet="lastPos" toSet="lastPos:" changeEvent="lastPosChanged">lastPos</field>
	<field toGet="lastVertices" toSet="lastVertices:" changeEvent="lastVerticesChanged">lastVertices</field>
	<field toGet="constraintType" toSet="constraintType:" changeEvent="constraintTypeChanged">constraintType</field>
	<field toGet="fadeType" toSet="fadeType:" changeEvent="fadeTypeChanged">fadeType</field>
</fields>'!

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
baseColor
	^ Color green! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColorSize
	^ 100
! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColors
"
	TXLineConnector cachedColors.
"
	| bColor delta |
	bColor := self baseColor.
	delta := 0.01.

	cachedColors isNil ifTrue: [
		cachedColors := OrderedCollection new: self frequency.
		1 to: self cachedColorSize do: [:idx |
			cachedColors add: (bColor alpha: idx * delta).
		].
		cachedColors at: 1 put: Color transparent.
		cachedColors at: self cachedColorSize put: bColor.
	].
	
	^ cachedColors! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
defaultWidth
	^ 5! !

!SqLineConnector class methodsFor: 'examples' stamp: 'minami 2/20/2006 12:06'!
ex01
"
	SqLineConnector ex01
"
	| c |
	c := SqLineConnector newWithConstraint.
	c open.
	^ c! !

!SqLineConnector class methodsFor: 'examples' stamp: 'minami 2/20/2006 12:06'!
ex02
"
	SqLineConnector ex02
"
	| c |
	c := SqLineConnector newWithConstraint.
	c fromTarget 
			constraintType: #fix;
			constraintPoint: #bottomLeft.
	c toTarget constraintType: #free.

	c open.
	^ c! !

!SqLineConnector class methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
frequency
	^ 10! !

!SqLineConnector class methodsFor: 'instance creation' stamp: 'minami 10/26/2005 04:23'!
from: fromTarget to: toTarget 
	^ super new 
		 setFromTarget: fromTarget toTarget: toTarget;
		 yourself! !

!SqLineConnector class methodsFor: 'class initialization' stamp: 'minami 10/26/2005 03:08'!
initialize
"
	TXLineConnector initialize.
"
	cachedColors := nil.! !

!SqLineConnector class methodsFor: 'instance creation' stamp: 'minami 2/20/2006 12:06'!
newWithConstraint
	| inst |
	inst := self from: SqConstraintPlayer new to: SqConstraintPlayer new.
	inst start.
	^ inst
	! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
alphaIndex
	"Answer the alphaIndex of the receiver"
	<bewareOf: #alphaIndexChanged>
	^self propertyValueAt: #alphaIndex! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
alphaIndex: aValue
	"Modify the receiver's alphaIndex"
	^self propertyValueAt: #alphaIndex put: aValue with: #alphaIndexChanged! !

!SqLineConnector methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColorSize
	^ self class cachedColorSize! !

!SqLineConnector methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
cachedColors
	^ self class cachedColors! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 11/1/2005 13:11'!
computeFromPos
	| fromBounds toBounds newPos |
	(self fromTarget isNil or: [self toTarget isNil]) ifTrue: [^ self].

	((constraintType == #centerToCenter) or: [constraintType == #centerToEdge])
		ifTrue: [^ self fromTarget globalPosition].
	
	fromBounds := self fromTarget globalBounds.
	toBounds := self toTarget globalBounds.

	newPos := fromBounds intersectionWithLineSegmentFromCenterTo: toBounds center.
	
	^ newPos asIntegerPoint
! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 11/1/2005 13:11'!
computeToPos
	| fromBounds toBounds newPos |
	(self fromTarget isNil or: [self toTarget isNil]) ifTrue: [^ self].

	((constraintType == #centerToCenter) or: [constraintType == #edgeToCenter])
		ifTrue: [^ self toTarget position].
	
	fromBounds := self fromTarget globalBounds.
	toBounds := self toTarget globalBounds.

	newPos := toBounds intersectionWithLineSegmentFromCenterTo: fromBounds center.
	^ newPos asIntegerPoint
! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
constraintType
	"Answer the constraintType of the receiver"
	<bewareOf: #constraintTypeChanged>
	^self propertyValueAt: #constraintType! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
constraintType: aValue
	"Modify the receiver's constraintType"
	^self propertyValueAt: #constraintType put: aValue with: #constraintTypeChanged! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 13:33'!
decreaseAlpha
	self alphaIndex > 1 ifTrue: [self alphaIndex: self alphaIndex - 1].
	self setAlpha: self alphaIndex.! !

!SqLineConnector methodsFor: 'defaults' stamp: 'minami 10/26/2005 03:08'!
defaultWidth
	^ self class defaultWidth! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 15:42'!
deleteIf: conditionBlock 
	self deleteIf: conditionBlock postScript: []! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:08'!
deleteIf: conditionBlock postScript: postScriptBlock 
	(conditionBlock value: self) ifTrue: [
		postScriptBlock value: self.
		self destroy.
	]! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/30/2005 14:02'!
fadeType
	"Answer the fadeType of the receiver"
	<bewareOf: #fadeTypeChanged>
	^self propertyValueAt: #fadeType! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/30/2005 14:02'!
fadeType: aValue
	"Modify the receiver's fadeType"
	^self propertyValueAt: #fadeType put: aValue with: #fadeTypeChanged! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
fromTarget
	"Answer the fromTarget of the receiver"
	<bewareOf: #fromTargetChanged>
	^self propertyValueAt: #fromTarget! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
fromTarget: aValue
	"Modify the receiver's fromTarget"
	^self propertyValueAt: #fromTarget put: aValue with: #fromTargetChanged! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 14:16'!
increaseAlpha
	self cachedColorSize > self alphaIndex ifTrue: [self alphaIndex: self alphaIndex + 1].
	self setAlpha: self alphaIndex.! !

!SqLineConnector methodsFor: 'initialize' stamp: 'minami 10/30/2005 14:02'!
initialize
	super initialize.

	alphaIndex := self cachedColorSize.
	lastPos := nil.
	lastVertices := nil.
	constraintType := #centerToCenter. "#centerToCenter, #centerToEdge, #edgeToCenter, #edgeToEdge"
	arrowStyle := #forward. "#none, #forward, #back, #both"
	arrowSpec := 4@5.
	closed := false.

	borderWidth := self defaultWidth.
	color := self class baseColor.
	borderColor := self class baseColor.

	fadeType := #still. "{#out. #in. #still}"! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastPos
	"Answer the lastPos of the receiver"
	<bewareOf: #lastPosChanged>
	^self propertyValueAt: #lastPos! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastPos: aValue
	"Modify the receiver's lastPos"
	^self propertyValueAt: #lastPos put: aValue with: #lastPosChanged! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastVertices
	"Answer the lastVertices of the receiver"
	<bewareOf: #lastVerticesChanged>
	^self propertyValueAt: #lastVertices! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
lastVertices: aValue
	"Modify the receiver's lastVertices"
	^self propertyValueAt: #lastVertices put: aValue with: #lastVerticesChanged! !

!SqLineConnector methodsFor: 'events' stamp: 'minami 10/30/2005 13:24'!
onBorderChanged
	| radius oldBox newBox |
	<on: borderChanged>
	radius := (borderWidth + 1) // 2.
	oldBox := Rectangle encompassing: self getVertices.
	newBox := (0@0 extent: width@height) insetBy: radius.
	(oldBox width < 1 or:[oldBox height < 1]) ifTrue:[
		extent := (oldBox expandBy: radius) extent.
		^self].
	(newBox width < 1 or:[newBox height < 1]) ifTrue:[
		extent := ((oldBox origin extent: 1@1) expandBy: radius) extent.
		^self].! !

!SqLineConnector methodsFor: 'events' stamp: 'minami 2/20/2006 12:06'!
onMouseEnter: evt
	<on: mouseEnter>

	(self fromTarget isKindOf: SqConstraintPlayer) ifTrue: [self fromTarget comeToFront].
	(self toTarget isKindOf: SqConstraintPlayer) ifTrue: [self toTarget comeToFront].
! !

!SqLineConnector methodsFor: 'opening' stamp: 'minami 2/20/2006 12:06'!
open: aPlayer in: aContainer at: aPoint
	super open: aPlayer in: aContainer at: aPoint.

	(self fromTarget isKindOf: SqConstraintPlayer)
		ifTrue: [self fromTarget open].
	(self toTarget isKindOf: SqConstraintPlayer)
		ifTrue: [self toTarget open]! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:08'!
privUpdateConnector
	| pos newFromPos newToPos |
	(self fromTarget isNil or: [self toTarget isNil]) ifTrue: [^ self].

	newFromPos := self computeFromPos.
	newToPos := self computeToPos.
	self setNewVertices: {newFromPos. newToPos.}.
	pos := (newFromPos corner: newToPos) center.
	self position: pos.

! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:08'!
resetAlpha
	self alphaIndex: self cachedColorSize! !

!SqLineConnector methodsFor: 'private' stamp: 'minami 10/26/2005 03:08'!
setAlpha: index
	| c |
	c := self cachedColors at: index.
	self borderColor: c.
! !

!SqLineConnector methodsFor: 'private' stamp: 'minami 2/20/2006 12:06'!
setFromTarget: from toTarget: to 
	self fromTarget: from.
	self toTarget: to.
	(from isKindOf: SqConstraintPlayer)
		ifTrue: [from connector: self edge: #from].
	(to isKindOf: SqConstraintPlayer)
		ifTrue: [to connector: self edge: #to]! !

!SqLineConnector methodsFor: 'private' stamp: 'mu 5/31/2006 15:44'!
setNewVertices: points
	vertices := points.
	self onVerticesChanged! !

!SqLineConnector methodsFor: 'initialize' stamp: 'minami 10/30/2005 14:19'!
setupCostume
	super setupCostume.

! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:39'!
start
	self startScript: #updateConnector when: {self fromTarget. #geometryChanged}.
	self startScript: #updateConnector when: {self toTarget. #geometryChanged}.

	self startScript: #onMouseEnter: when: {self fromTarget. #mouseEnter}.

	self startTicking: #updateBorderColor at: 10.

	self updateConnector.! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:42'!
startAndDeleteIf: conditionBlock
	self startAndDeleteIf: conditionBlock postScript: []! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:41'!
startAndDeleteIf: conditionBlock postScript: postScriptBlock 

	self
		startTicking: #deleteIf:postScript:
		withArguments: {conditionBlock. postScriptBlock}
		at: 10.

	self start.! !

!SqLineConnector methodsFor: 'start / stop' stamp: 'minami 10/30/2005 15:49'!
stop
	self stopScript: #updateConnector.
	self stopScript: #updateBorderColor.
	self stopScript: #onMouseEnter:.
	self stopScript: #deleteIf:postScript:.
! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
toTarget
	"Answer the toTarget of the receiver"
	<bewareOf: #toTargetChanged>
	^self propertyValueAt: #toTarget! !

!SqLineConnector methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:08'!
toTarget: aValue
	"Modify the receiver's toTarget"
	^self propertyValueAt: #toTarget put: aValue with: #toTargetChanged! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/30/2005 14:07'!
updateBorderColor
	self fadeType = #out
		ifTrue: [self decreaseAlpha].
	self fadeType = #in
		ifTrue: [self increaseAlpha]! !

!SqLineConnector methodsFor: 'actions' stamp: 'minami 10/26/2005 03:09'!
updateConnector
	self privUpdateConnector.
"	self comeToFront."

! !

!CPlayer class methodsFor: '*SqSquare-Core-snapshot' stamp: 'mu 3/2/2006 12:01'!
readSnapshotByteArray: bytes

	^SqProjectSerializer deserialize: bytes! !

!CPlayer class methodsFor: '*SqSquare-Core-snapshot' stamp: 'MU 1/19/2006 16:58'!
readSnapshotDataFrom: snapShotStream

	| bytes |
	bytes _ snapShotStream binary contents.
	^self readSnapshotByteArray: bytes! !

!CPlayer methodsFor: '*SqSquare-Core-menu' stamp: 'minami 4/7/2006 19:44'!
addCustomeMenuItemsTo: aMenu
	"override if you need"! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 17:22'!
addSelectionHighlight
self flag: #minami.
	self addSelectionHighlight: Color red! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 17:22'!
addSelectionHighlight: aColor
	| highlight |
self flag: #minami.
	highlight := CFramingHighlight new.
	highlight border: (CBorder complexAltRaised width: 3; color: aColor).
	highlight name: #selectionHighlight.
	highlight inset: -5.
	self addHighlight: highlight.! !

!CPlayer methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/2/2006 12:01'!
asSnapshotData
	^SqProjectSerializer serialize: self! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 14:26'!
attacheAllContentsTo: boardOrSheet
	"do nothing"! !

!CPlayer methodsFor: '*SqSquare-Core-initialize-override' stamp: 'mu 3/9/2006 16:21'!
becomeUniClass
	"Make the receiver an instance of a unique class"
	| mgr |	
	super becomeUniClass.
	mgr := Processor activeProject ifNotNilDo: [:p | p scriptManager].
	mgr ifNotNil: [mgr uniClassCreatedFor: self]! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 5/23/2006 17:48'!
clearBoardLookupScope
	self boardLookupScope: Dictionary new.! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 5/10/2006 11:29'!
cursorBehavior
	^ self eventBehaviors detect: [:b | b isCursorBehavior] ifNone: [].! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'mu 4/3/2006 16:15'!
detachBoardProperties
	self detachEventRecordBehavior.
	self removePlayerId.
	self removeFrozenFlag.
	self removeRecordingFlag.
	self scale: 1.0.
	costume detachBoardProperties.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/13/2006 16:50'!
detachEventRecordBehavior
	self eventRecordBehavior ifNotNilDo: [:b | b detach]! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'mu 6/2/2006 10:35'!
ensureBoardLookupScope
	self
		boardLookupScope: (self eventRecordBoard
				ifNil: [self boardLookupScope]
				ifNotNilDo: [:bo | bo referencingPlayers]).
	^ self boardLookupScope! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 5/16/2006 15:12'!
ensurePlayerId
	self hasPlayerId
		ifFalse: [self playerId: SqUid new].
	^ self playerId! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 5/23/2006 14:53'!
eventRecordBehavior
	self eventBehaviors isEmptyOrNil ifTrue: [^nil].
	^ self eventBehaviors detect: [:b | b isEventRecordBehavior] ifNone: [].! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 5/18/2006 17:23'!
eventRecordBoard
	
	| cont |
	cont _ self container.
	[cont isNil or: [cont isBoard]] whileFalse: [ 
		cont _ cont container.
	].

	cont ifNil: [self eventRecordBehavior ifNotNilDo: [:be | cont _ be board]]. "last resort"

	^cont
! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'minami 10/26/2005 11:03'!
findPlayerAt: aPoint but: rejectBlockWithOneArg
	"Search the receiver to find the first player located at the given position."
	^costume findPlayerAt: aPoint but: rejectBlockWithOneArg! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'minami 5/23/2006 14:35'!
findPlayerByUid: squid 
	squid ifNil: [^ nil].
	self playerId = squid ifTrue: [^ self].
	^ self primitiveCostume findPlayerByUid: squid! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'minami 2/16/2006 09:05'!
findPlayerOf: clazz
	(self isKindOf: clazz) ifTrue: [^ true].

	self hasPlayer ifFalse: [^ false].	
	^ self player findPlayerOf: clazz! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'minami 4/14/2006 16:49'!
findPlayerOf: clazz at: aPoint
	((self isKindOf: clazz) and: [self costume containsPoint: aPoint]) ifTrue: [^ true].
	^ self costume findPlayerOf: clazz at: aPoint! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 15:03'!
freeze
	self propertyValueAt: #frozen put: true! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 12/19/2005 15:24'!
hasPlayer
	^ self player notNil! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 2/13/2006 15:48'!
hasPlayerId
	^ self playerId notNil! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 5/23/2006 14:06'!
hasPlayerOrElements
	^ self player notNil! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/16/2006 13:41'!
isBoard
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/30/2006 12:16'!
isComplexPlayer
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 5/10/2006 11:28'!
isCursorBehavior
	^ false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/9/2006 15:39'!
isDropAcceptable
	^ true.! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 5/10/2006 11:28'!
isEventRecordBehavior
	^ false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 5/25/2006 13:57'!
isFlapTab
	^ false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 1/17/2006 15:03'!
isFrozen
	^ (self propertyValueAt: #frozen) == true! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 4/6/2006 15:40'!
isHandle
	^ false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/16/2006 17:15'!
isLabel
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/2/2006 11:42'!
isOnAnyBoard
	self container ifNil: [^ false].
	self container isBoard ifTrue: [^ true].

	^ self container isOnAnyBoard.! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 3/2/2006 17:31'!
isOnBoard: board
	self container ifNil: [^ false].
	self container == board ifTrue: [^ true].

	^ self container isOnBoard: board! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'minami 1/16/2006 12:50'!
isRecording
	^ self propertyValueAt: #recording ifAbsentPut: [true]! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 3/16/2006 17:05'!
isSheet
	^false! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 5/18/2006 16:02'!
justLoaded
	self clearBoardLookupScope! !

!CPlayer methodsFor: '*SqSquare-Core-tiles' stamp: 'MU 2/15/2006 16:38'!
linkForSelf
	"Answer a tile representing the receiver"

	| aTile |
	aTile _ SqLinkTile new.
	aTile value: self.
	aTile targetId: self playerId.
	^ aTile
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
loadOnBorderChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnDropAcceptFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnFillChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnFlagsChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnGeometryChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnGraphicChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnImageChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnLabelChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnLockFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnPlayerCreatedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnPlayerRemovedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnPlayerSelectedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/12/2006 15:56'!
loadOnPolygonStateChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'mu 5/31/2006 15:57'!
loadOnRemoteVerticesChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
loadOnRoundCornersChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/28/2006 14:23'!
loadOnScriptModifiedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/27/2006 14:55'!
loadOnScriptStatusChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:49'!
loadOnTextChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:26'!
loadOnTextEditorStatusChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/5/2006 14:36'!
loadOnUngroupInto: dic withArgs: args
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
loadOnUnlockFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/11/2006 17:28'!
loadOnVerticesChangedFrom: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:42'!
loadProperties: propertyNames from: dic 
	propertyNames
		do: [:nameSymbol | self
				loadProperty: nameSymbol
				to: (dic at: nameSymbol)]! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:01'!
loadProperties: propertyNames from: dic withArgs: args 
	propertyNames
		do: [:nameSymbol | self
				loadProperty: nameSymbol
				to: (dic at: nameSymbol)]! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'mu 6/2/2006 10:03'!
lookupRootDocument
	^SqDummyDocument on: self ensureBoardLookupScope! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'mu 5/18/2006 16:08'!
lookupScope

	self eventRecordBoard ifNotNilDo: [:board | ^board lookupScope].

	^super lookupScope! !

!CPlayer methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 16:09'!
mementoEventBehaviors

	| mementoEventBehaviors |
	mementoEventBehaviors _ self eventBehaviors asOrderedCollection.
	mementoEventBehaviors removeAllSuchThat: [:each | each isEventRecordBehavior].
	^mementoEventBehaviors asArray! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 16:44'!
objectId
	^self playerId! !

!CPlayer methodsFor: '*SqSquare-Core-positioning' stamp: 'minami 3/30/2006 12:16'!
onBoardPosition: pos
	| con |
	(self container isBoard) ifTrue: [^ pos].

	((con := self container) isComplexPlayer) ifTrue: [
		^ con onBoardPosition: (con position + pos)
	].

	^ pos! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 5/18/2006 15:03'!
playerAssociationsIn: scriptName
	| scriptor proj ids assocs |
	scriptor _ self scriptorFor: scriptName asSymbol.
	scriptor ifNil: [^#()].

	proj _ self project.
	proj ifNil: [^#()].
	ids _ scriptor playerIds.
	assocs _ OrderedCollection new.
	ids do: [:each | (self lookupScope lookup: each) ifNotNilDo: [:p | assocs add: (each -> p ensurePlayerId asString)]].
	^assocs! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 6/9/2006 14:08'!
playerId
	"Answer the playerId of the receiver"
	<bewareOf: #playerIdChanged>
	^self propertyValueAt: #playerId! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 6/9/2006 14:08'!
playerId: aValue
	"Modify the receiver's playerId"
	^self propertyValueAt: #playerId put: aValue with: #playerIdChanged! !

!CPlayer methodsFor: '*SqSquare-Core-maker-helper' stamp: 'minami 5/29/2006 16:30'!
postBuildBoard
! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 5/18/2006 15:58'!
prepareToBeSaved
	self ensureBoardLookupScope! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 4/5/2006 12:09'!
primitiveCostume
	| current |
	current := self costume.

	[current isPrimitiveCostume] whileFalse: [
		current := current costume.
		current ifNil: [^ nil].
	].
	
	^ current! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:02'!
readMementoFixedFieldsFrom: deserializer
	| theClass fields |
	super readMementoFixedFieldsFrom: deserializer.
	myPlayer := deserializer readField: #player ifAbsent:[myPlayer].
	myCostume := deserializer readField: #costume ifAbsent:[myCostume].

	theClass := self class.
	[theClass == CPlayer] whileFalse:[
		fields := theClass serializableInstVarFields.
		fields do: [:each | | nm memento val | nm _ each name.
			 memento _ deserializer readField: nm ifAbsent:[].
			 val _ memento ifNil: [self instVarNamed: nm] ifNotNil: [memento].
			 self instVarNamed: nm put: val.
		].

		theClass := theClass superclass
	].
	! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/16/2006 12:36'!
recordingDisabled
	^ self propertyValueAt: #recording put: false! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/16/2006 12:36'!
recordingEnabled
	^ self propertyValueAt: #recording put: true! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 4/12/2006 13:59'!
releaseFromHalo
	self project halo target == self
		ifTrue: [self project halo target: nil]! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 11:56'!
removeFrozenFlag
	self removePropertyNamed: #frozen.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'MU 2/9/2006 12:39'!
removePlayerId
	self removePropertyNamed: #playerId.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 11:56'!
removeRecordingFlag
	self removePropertyNamed: #recording.
! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 17:22'!
removeSelectionHighlight
self flag: #minami.
	self removeHighlight: #selectionHighlight.! !

!CPlayer methodsFor: '*SqSquare-Core-lookup' stamp: 'mu 6/2/2006 10:07'!
resetBoardLookupScope
	self boardLookupScope: nil
		! !

!CPlayer methodsFor: '*SqSquare-Core-opening-override' stamp: 'mu 3/9/2006 16:07'!
resumeTickingScripts
	"Resume all ticking scripts for the receiver and its costume(s)."
	| aPlayer |
	aPlayer := self.
	[aPlayer == nil] whileFalse:[
		aPlayer myScripts do:[:each| (each isTickingScript and: [each isPaused not]) ifTrue:[each resumeScript]].
		aPlayer := aPlayer getCostume.
	].
! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 5/23/2006 14:27'!
rootPlayer
	| current |
	current := self.

	[current hasPlayer] whileTrue: [
		current := current player.
	].
	^ current

! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnBorderChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnDropAcceptInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnFillChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
saveOnFlagsChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnGeometryChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnGraphicChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnImageChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnLabelChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
saveOnLockInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 08:51'!
saveOnPlayerCreatedInto: dic withArgs: args
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnPlayerRemovedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnPlayerSelectedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/12/2006 15:56'!
saveOnPolygonStateChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'mu 5/31/2006 15:57'!
saveOnRemoteVerticesChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnRoundCornersChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/28/2006 14:23'!
saveOnScriptModifiedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/27/2006 14:54'!
saveOnScriptStatusChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:48'!
saveOnTextChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:26'!
saveOnTextEditorStatusChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/5/2006 14:36'!
saveOnUngroupInto: dic withArgs: args
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:47'!
saveOnUnlockInto: dic withArgs: args
! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 4/11/2006 17:28'!
saveOnVerticesChangedInto: dic withArgs: args! !

!CPlayer methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:42'!
saveProperties: propertyNames into: dic 
	propertyNames do: [:nameSymbol | 
		self saveProperty: nameSymbol into: dic 
	].! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/10/2006 11:52'!
stopRecordingWhile: aBlock
	[	
		self recordingDisabled.
		aBlock value.
	] ensure: [
		self recordingEnabled.
	]
! !

!CPlayer methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 3/17/2006 12:48'!
title
	^ self name! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 1/17/2006 15:02'!
unfreeze
	self propertyValueAt: #frozen put: false! !

!CPlayer methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 4/7/2006 14:00'!
waitTickIfOnDisplayedBoard
	self eventRecordBoard ifNotNilDo: [:b | b isHeadless ifFalse: [self waitTick]].! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 5/31/2006 15:10'!
wantsPropagateEvents
	^ self propertyValueAt: #wantsPropagateEvents ifAbsentPut: [true]! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 5/31/2006 15:10'!
wantsPropagateEvents: aBoolean
	^ self propertyValueAt: #wantsPropagateEvents put: aBoolean! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 3/16/2006 10:17'!
wantsPropagateGraphicChanged
	^true! !

!CPlayer methodsFor: '*SqSquare-Core-testing' stamp: 'mu 3/16/2006 10:16'!
wantsPropagateTextChanged
	^true! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:00'!
writeMementoFixedFieldsOn: aSerializer
	"by default, write all inst vars"
	| theClass fields |
	
	super writeFixedFieldsOn: aSerializer.
	aSerializer writeField: #player value: myPlayer.
	aSerializer writeField: #costume value: myCostume.

	theClass := self class.
	[theClass == CPlayer] whileFalse:[
		fields := theClass serializableInstVarFields.
		fields do: [:each | | nm | nm _ each name. 
			aSerializer writeField: nm value: (self instVarNamed: nm).
		].

		theClass := theClass superclass
	].! !

!CPlayer methodsFor: '*SqSquare-Core-maker' stamp: 'mu 5/18/2006 16:15'!
writeMementoRegularFields: fieldMementoProperties on: serializer 

	serializer isForSendingEvents ifTrue: [
		fieldMementoProperties at: #eventBehaviors put: self mementoEventBehaviors.
	].

	fieldMementoProperties
		keysAndValuesDo: [:k :v | serializer writeField: k value: v]! !

!CPlayer methodsFor: '*SqSquare-Core-transitions' stamp: 'minami 4/20/2006 20:33'!
zoomOutBy: steps
	| orgExtent delta |
	orgExtent := self extent.
	delta := orgExtent // steps.
	
	steps timesRepeat: [
		self extent: self extent - delta.
		self waitTick.
	].

	self close.! !

CPlayer subclass: #SqArrowPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqArrowPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="arrowDirection" toSet="arrowDirection:" changeEvent="arrowDirectionChanged">arrowDirection</field>
	<field toGet="arrowColor" toSet="arrowColor:" changeEvent="arrowColorChanged">arrowColor</field>
	<field toGet="arrowHeadRatio" toSet="arrowHeadRatio:" changeEvent="arrowHeadRatioChanged">arrowHeadRatio</field>
	<field toGet="arrowVertices" toSet="arrowVertices:" changeEvent="arrowVerticesChanged">arrowVertices</field>
</fields>'!

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowColor
	"Answer the arrowColor of the receiver"
	<bewareOf: #arrowColorChanged>
	^self propertyValueAt: #arrowColor! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowColor: aValue
	"Modify the receiver's arrowColor"
	^self propertyValueAt: #arrowColor put: aValue with: #arrowColorChanged! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowDirection
	"Answer the arrowDirection of the receiver"
	<bewareOf: #arrowDirectionChanged>
	^self propertyValueAt: #arrowDirection! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:30'!
arrowDirection: aValue
	"Modify the receiver's arrowDirection"
	^self propertyValueAt: #arrowDirection put: aValue with: #arrowDirectionChanged! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:47'!
arrowHeadRatio
	"Answer the arrowHeadRatio of the receiver"
	<bewareOf: #arrowHeadRatioChanged>
	^self propertyValueAt: #arrowHeadRatio! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:47'!
arrowHeadRatio: aValue
	"Modify the receiver's arrowHeadRatio"
	^self propertyValueAt: #arrowHeadRatio put: aValue with: #arrowHeadRatioChanged! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:50'!
arrowVertices
	"Answer the arrowVertices of the receiver"
	<bewareOf: #arrowVerticesChanged>
	^self propertyValueAt: #arrowVertices! !

!SqArrowPlayer methodsFor: 'accessing' stamp: 'minami 2/24/2006 20:50'!
arrowVertices: aValue
	"Modify the receiver's arrowVertices"
	^self propertyValueAt: #arrowVertices put: aValue with: #arrowVerticesChanged! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beDownArrow
	self arrowDirection: #down! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beLeftArrow
	self arrowDirection: #left! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beRightArrow
	self arrowDirection: #right! !

!SqArrowPlayer methodsFor: 'direction' stamp: 'minami 2/24/2006 20:30'!
beUpArrow
	self arrowDirection: #up! !

!SqArrowPlayer methodsFor: 'private' stamp: 'minami 2/24/2006 20:48'!
computeArrowVertices2: drawingBounds
	| offset arrowBounds |
	"drawingBounds printString displayAt: 0@0."
	
	offset := self drawingOffset.
	arrowBounds := (drawingBounds topLeft + offset) corner: (drawingBounds bottomRight - offset).

	self arrowDirection == #up
		ifTrue: [^ {	arrowBounds topCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #down
		ifTrue: [^ {	arrowBounds bottomCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #right
		ifTrue: [^ {	arrowBounds rightCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].

	self arrowDirection == #left
		ifTrue: [^ {	arrowBounds leftCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].
	^ nil! !

!SqArrowPlayer methodsFor: 'private' stamp: 'minami 2/24/2006 20:35'!
computeArrowVertices: drawingBounds
	| offset arrowBounds |
	"drawingBounds printString displayAt: 0@0."
	
	offset := self drawingOffset.
	arrowBounds := (drawingBounds topLeft + offset) corner: (drawingBounds bottomRight - offset).

	self arrowDirection == #up
		ifTrue: [^ {	arrowBounds topCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds bottom).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #down
		ifTrue: [^ {	arrowBounds bottomCenter. 
					arrowBounds leftCenter. 
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds center y).
					((arrowBounds center x - (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds top).
					((arrowBounds center x + (arrowBounds width // 4)) @ arrowBounds center y).
					arrowBounds rightCenter}].

	self arrowDirection == #right
		ifTrue: [^ {	arrowBounds rightCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds left @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].

	self arrowDirection == #left
		ifTrue: [^ {	arrowBounds leftCenter. 
					arrowBounds topCenter.
					(arrowBounds center x @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y - (arrowBounds height // 4))).
					(arrowBounds right @ (arrowBounds center y + (arrowBounds height // 4))).
					(arrowBounds center x @ (arrowBounds center y + (arrowBounds height // 4))).
					arrowBounds bottomCenter}].
	^ nil! !

!SqArrowPlayer methodsFor: 'drawing' stamp: 'minami 2/24/2006 20:51'!
drawArrowOn: aCanvas in: drawingBounds

	self arrowVertices ifNil: [self arrowVertices: (self computeArrowVertices: drawingBounds)].
	aCanvas drawPolygon: self arrowVertices fillStyle: self arrowColor borderWidth: 0 borderColor: self arrowColor! !

!SqArrowPlayer methodsFor: 'constants' stamp: 'minami 2/24/2006 20:35'!
drawingOffset
	^ 3@3! !

!SqArrowPlayer methodsFor: 'drawing' stamp: 'minami 2/24/2006 20:43'!
drawOn: aCanvas in: drawingBounds
	super costume drawOn: aCanvas in: drawingBounds.
	self drawArrowOn: aCanvas in: drawingBounds.
! !

!SqArrowPlayer methodsFor: 'initialize' stamp: 'minami 2/24/2006 20:50'!
initialize
	super initialize.

	self userDraw: true.
	self beRightArrow.
	self arrowHeadRatio: 0.3.
	self arrowColor: Color black.
	self arrowVertices: nil.
! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:41'!
onArrowColorChanged
	<on: arrowColorChanged>

	self invalidate.! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:42'!
onArrowDirectionChanged
	<on: arrowDirectionChanged>

	self invalidate.! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:47'!
onArrowHeadRatioChanged
	<on: arrowHeadRatioChanged>

	self invalidate.! !

!SqArrowPlayer methodsFor: 'events' stamp: 'minami 2/24/2006 20:53'!
onGeometryChanged
	<on: geometryChanged>

	self arrowVertices: nil.
	self invalidate.! !

CPlayer subclass: #SqConstraintPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqConstraintPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="connector" toSet="connector:" changeEvent="connectorChanged">connector</field>
	<field toGet="edge" toSet="edge:" changeEvent="edgeChanged">edge</field>
	<field toGet="constraintPoint" toSet="constraintPoint:" changeEvent="constraintPointChanged">constraintPoint</field>
	<field toGet="constraintType" toSet="constraintType:" changeEvent="constraintTypeChanged">constraintType</field>
</fields>'!

!SqConstraintPlayer methodsFor: 'menu' stamp: 'minami 10/31/2005 13:32'!
addConstraintMenuTo: aMenu
	| menu addMenuBlock |
	menu := CMenu new.
	menu label: 'Constraint Point'.

	(menu
		add: #free
		target: self
		action: #setTypeFree
		arguments: {}
	) checked: (self constraintType == #free).

	addMenuBlock := [:label :pointSymbol | 
			| menuItem | 
			menuItem := menu
						add: label
						target: self
						action: #setTypeFixAt:
						arguments: {pointSymbol}.
			menuItem
				checked: (self constraintType == #fix and: [self constraintPoint == pointSymbol])].
	#(#topLeft #topCenter #topRight #leftCenter #center #rightCenter #bottomLeft #bottomCenter #bottomRight)
		do: [:menuSpec | 
			addMenuBlock value: menuSpec value: menuSpec].

	aMenu
		ifNotNil: [aMenu add: 'Constraint Point' subMenu: menu]! !

!SqConstraintPlayer methodsFor: 'actions' stamp: 'minami 11/1/2005 13:04'!
computePos

	| newPos targetBounds otherBounds |

	self target ifNil: [^ nil].
	(constraintType == #fix) ifTrue: [^ self target bounds perform: self constraintPoint].

	targetBounds := self target globalBounds.
	otherBounds := self otherSide globalBounds.

	newPos := targetBounds intersectionWithLineSegmentFromCenterTo: otherBounds center.
	
	^ newPos asIntegerPoint
! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:39'!
connector
	"Answer the connector of the receiver"
	<bewareOf: #connectorChanged>
	^self propertyValueAt: #connector! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:39'!
connector: aValue
	"Modify the receiver's connector"
	^self propertyValueAt: #connector put: aValue with: #connectorChanged! !

!SqConstraintPlayer methodsFor: 'initialize' stamp: 'minami 10/26/2005 12:42'!
connector: aConnector edge: aSymbol
	self connector: aConnector.
	self edge: aSymbol.

	self startScript: #destroy when: {self connector. #close}.

	self startScript: #privUpdatePosition when: {self otherSide. #geometryChanged}.
	"updatePosition does not work, why?"! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 11:55'!
constraintPoint
	"Answer the constraintPoint of the receiver"
	<bewareOf: #constraintPointChanged>
	^self propertyValueAt: #constraintPoint! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 11:55'!
constraintPoint: aValue
	"Modify the receiver's constraintPoint"
	^self propertyValueAt: #constraintPoint put: aValue with: #constraintPointChanged! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 12:06'!
constraintType
	"Answer the constraintType of the receiver"
	<bewareOf: #constraintTypeChanged>
	^self propertyValueAt: #constraintType! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 12:06'!
constraintType: aValue
	"Modify the receiver's constraintType"
	^self propertyValueAt: #constraintType put: aValue with: #constraintTypeChanged! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:41'!
edge
	"Answer the edge of the receiver"
	<bewareOf: #edgeChanged>
	^self propertyValueAt: #edge! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 04:41'!
edge: aValue
	"Modify the receiver's edge"
	^self propertyValueAt: #edge put: aValue with: #edgeChanged! !

!SqConstraintPlayer methodsFor: 'menu' stamp: 'minami 10/31/2005 14:38'!
getConstraintMenu
	| aMenu |
	aMenu _ CMenu new.
	aMenu label: 'Constraint Menu'.
	self addConstraintMenuTo: aMenu.
	^ aMenu! !

!SqConstraintPlayer methodsFor: 'initialize' stamp: 'minami 10/31/2005 12:37'!
initialize
	super initialize.
	
	constraintType := #free. "#fix, #free"

	"if constraintType == #free, constraintPoint ignored."
	constraintPoint := #center.	"#topLeft, #topCenter, #topRight, 
								#leftCenter, #center, #rightCenter,
								#bottomLeft, #bottomCenter, #bottomRight"! !

!SqConstraintPlayer methodsFor: 'events' stamp: 'minami 2/20/2006 12:07'!
onDropAccept: obj 
	| aPlayer |
	<on: #dropAccept>

	aPlayer := self world
				findPlayerAt: self hand globalPosition
				but: [:p | (p isKindOf: SqConstraintPlayer)
						or: [p == self connector]].
	self setNewTarget: aPlayer! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'minami 10/26/2005 12:24'!
otherSide
	^ self edge == #from
		ifTrue: [self connector toTarget]
		ifFalse: [self connector fromTarget]! !

!SqConstraintPlayer methodsFor: 'actions' stamp: 'minami 10/26/2005 12:39'!
privUpdatePosition

	self updatePosition! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'mu 3/17/2006 11:49'!
setNewTarget: aPlayer
	self stopScript: #updatePosition. 
	
	self target: aPlayer.
	aPlayer ifNotNil: [
		self startScript: #updatePosition when: {self target. #geometryChanged}.
	].! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'minami 10/31/2005 13:48'!
setTypeFixAt: symbol
	self constraintType: #fix.
	self constraintPoint: symbol.! !

!SqConstraintPlayer methodsFor: 'private' stamp: 'minami 10/31/2005 13:20'!
setTypeFree
	self constraintType: #free! !

!SqConstraintPlayer methodsFor: 'initialize' stamp: 'minami 10/31/2005 12:40'!
setupCostume
	super setupCostume.

	self extent: 15@15.
	self color: Color red.
	self borderWidth: 0.

	self
		startScript: [self getConstraintMenu openAt: self hand position]
		when: {self. #yellowButtonDown}! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:03'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!SqConstraintPlayer methodsFor: 'accessing' stamp: 'minami 10/26/2005 03:03'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!SqConstraintPlayer methodsFor: 'actions' stamp: 'minami 10/26/2005 12:34'!
updatePosition
	self computePos ifNotNilDo: [:pos | self position: pos].! !

CPlayer subclass: #SqCoverPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

SqCoverPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
</fields>'!

!SqCoverPlayer methodsFor: 'actions' stamp: 'minami 4/14/2006 14:58'!
coverOver: aPlayer
	aPlayer addLast: self.
	self extent: aPlayer extent.
	self topLeft: 0@0.
	self target: aPlayer.
	aPlayer cover: self.! !

!SqCoverPlayer methodsFor: 'testing' stamp: 'minami 4/14/2006 14:45'!
isDropAcceptable
	^ false.! !

!SqCoverPlayer methodsFor: 'events' stamp: 'minami 4/14/2006 16:54'!
onDragDrop: aPlayer 
	| found pos |
	<on: dragDrop>

	pos := self globalToLocal: self hand globalPosition.

	found := self target findPlayerOf: SqSheetPlayer at: pos.

	found 
		ifNotNil: [found addPlayer: aPlayer]
		ifNil: [self target addPlayer: aPlayer]! !

!SqCoverPlayer methodsFor: 'events' stamp: 'minami 4/14/2006 14:33'!
onMouseEnter: evt
	<on: mouseEnter>

	self mouseCursor: CCursorLibrary handCursor.! !

!SqCoverPlayer methodsFor: 'events' stamp: 'minami 4/14/2006 14:53'!
onRedButtonDown: evt
	<on: redButtonDown>

	self mouseCursor: CCursorLibrary fistCursor.

	self target isHandTrailMode ifTrue: [
		self target trailStartPos: (self globalToLocal: self hand position).
		self target trailBoardView.
	]! !

!SqCoverPlayer methodsFor: 'events' stamp: 'minami 4/14/2006 14:50'!
onRedButtonMove: evt
	<on: redButtonMove>

	self target isHandTrailMode ifTrue: [
		self target trailBoardView.
	].! !

!SqCoverPlayer methodsFor: 'events' stamp: 'minami 4/14/2006 14:56'!
onRedMouseUp: evt
	<on: redButtonUp>

	self mouseCursor: CCursorLibrary handCursor.! !

!SqCoverPlayer methodsFor: 'actions' stamp: 'minami 4/14/2006 14:59'!
removeCover
	self target remove: self.
	self target cover: nil.! !

!SqCoverPlayer methodsFor: 'initialize' stamp: 'minami 4/20/2006 11:34'!
setupCostume
	super setupCostume.

	self color: Color transparent.
"	self color: (Color lightOrange alpha: 0.2)"! !

!SqCoverPlayer methodsFor: 'accessing' stamp: 'minami 4/14/2006 14:31'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!SqCoverPlayer methodsFor: 'accessing' stamp: 'minami 4/14/2006 14:31'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPlayer subclass: #SqEventRecordBoard
	instanceVariableNames: 'boardClient isHeadless isRecovering headlessBoardId eventPlayer trailStartPos isSelectionStarted selectionMode cover cursors prevCursorPoint referencingPlayers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

SqEventRecordBoard defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="isRecording" toSet="isRecording:" changeEvent="isRecordingChanged">isRecording</field>
	<field toGet="highlights" toSet="highlights:" changeEvent="highlightsChanged">highlights</field>
	<field instanceVariable="true" serializable="false" toGet="boardClient" toSet="boardClient:" color="FFFF00">boardClient</field>
	<field instanceVariable="true" toGet="isHeadless" toSet="isHeadless:">isHeadless</field>
	<field instanceVariable="true" serializable="false" toGet="isRecovering" toSet="isRecovering:" color="FFFF00">isRecovering</field>
	<field instanceVariable="true" toGet="headlessBoardId" toSet="headlessBoardId:">headlessBoardId</field>
	<field instanceVariable="true" toGet="eventPlayer" toSet="eventPlayer:">eventPlayer</field>
	<field instanceVariable="true" serializable="false" toGet="trailStartPos" toSet="trailStartPos:">trailStartPos</field>
	<field instanceVariable="true" toGet="isSelectionStarted" toSet="isSelectionStarted:">isSelectionStarted</field>
	<field instanceVariable="true" toGet="selectionMode" toSet="selectionMode:">selectionMode</field>
	<field instanceVariable="true" serializable="false" toGet="cover" toSet="cover:" color="FFFF00">cover</field>
	<field instanceVariable="true" serializable="false" toGet="cursors" toSet="cursors:" color="FFFF00">cursors</field>
	<field instanceVariable="true" serializable="false" toGet="prevCursorPoint" toSet="prevCursorPoint:" color="FFFF00">prevCursorPoint</field>
	<field instanceVariable="true" toGet="referencingPlayers" toSet="referencingPlayers:" color="0000FF">referencingPlayers</field>
</fields>'!

!SqEventRecordBoard class methodsFor: 'instance creation' stamp: 'MU 1/24/2006 17:04'!
on: aSqBoardClient 
	^ super new boardClient: aSqBoardClient; yourself! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'MU 2/9/2006 14:19'!
accessId
	self isHeadless ifTrue: [^nil].
	^ self boardClient ifNotNilDo: [:bc | bc accessId]! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 6/2/2006 09:21'!
addPlayer: aPlayer
	
	self removeCoverWhile: [self doAddPlayer: aPlayer]! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 4/3/2006 17:04'!
attachBoardPropertiesTo: aPlayer
	aPlayer scale: 1! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 6/1/2006 19:25'!
attachEventRecordBehavior: aPlayer
	| behavior key |
	behavior := self eventRecordBehaviorClass attachTo: aPlayer.
	behavior board: self.

	key _ aPlayer userDataAt: #lookupSpec. 
	key notNil ifTrue: [
		self register: aPlayer lookupKey: key.
		self project ifNotNilDo: [:proj | proj scriptManager registerObject: aPlayer at: key].
	].! !

!SqEventRecordBoard methodsFor: 'cover' stamp: 'minami 4/14/2006 15:37'!
beHandleTrailMode
	self setSelectionMode: #handleTrale! !

!SqEventRecordBoard methodsFor: 'cover' stamp: 'minami 4/14/2006 15:37'!
beNormalSelectionMode
	self setSelectionMode: #normal! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/8/2006 11:57'!
boardClient
	"Answer the boardClient of the receiver"
	^boardClient! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/9/2006 13:07'!
boardClient: aValue
	"Modify the receiver's boardClient"
	boardClient := aValue! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'MU 2/9/2006 14:20'!
boardId
	self isHeadless ifTrue: [^self headlessBoardId].
	^ self accessId ifNotNilDo: [:ac | ac boardId]! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/17/2006 13:01'!
boardName
	^ self boardClient boardName! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 6/2/2006 09:10'!
boardPanel
	| cont |
	cont _ self container .

	[cont isNil] whileFalse: [
		(cont isMemberOf: SqBoardPanel) ifTrue: [^cont].
		cont _ cont container
	].

	^cont! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 5/22/2006 16:01'!
client
	^ SqClient userId: self boardClient userId! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'mu 4/27/2006 11:46'!
close
	self release.
	super close! !

!SqEventRecordBoard methodsFor: 'actions-flap' stamp: 'mu 6/2/2006 09:13'!
closeFlap
	^self boardPanel closeFlap! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 4/14/2006 14:58'!
cover
	"Answer the cover of the receiver"
	^cover! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 4/14/2006 14:58'!
cover: aValue
	"Modify the receiver's cover"
	cover := aValue! !

!SqEventRecordBoard methodsFor: 'cursors' stamp: 'mu 5/22/2006 16:05'!
cursorAt: userSerial 
	^ self cursors
		at: userSerial asString
		ifAbsentPut: [| otherHand prof | 
			otherHand _ SqPassiveHandPlayer new.
			prof _ self boardClient getUserProfileAt: userSerial.
			otherHand setUserProfile: prof.
			self add: otherHand.
			otherHand pivot: 0 @ 0.
			otherHand]! !

!SqEventRecordBoard methodsFor: 'cursors' stamp: 'mu 6/2/2006 14:24'!
cursorPointChanged: pos of: userSerial
	| cur |

	self flag: #TODO. "Need to compute invalidation rectangle from former points"

	cur _ self cursorAt: userSerial.

	"self invalidate: self viewport. " "SLOW, too big"
	self invalidate: (Rectangle center: pos extent: 200@200).

	cur position: pos! !

!SqEventRecordBoard methodsFor: 'cursors' stamp: 'mu 5/22/2006 15:38'!
cursorStyleChanged: style of: userSerial
	| cur |
	cur _ self cursorAt: userSerial.
	cur style: style! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 4/27/2006 17:24'!
cursors
	"Answer the cursors of the receiver"
	cursors ifNil: [cursors _ Dictionary new].
	^cursors! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 4/26/2006 15:52'!
cursors: aValue
	"Modify the receiver's cursors"
	cursors := aValue! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 6/2/2006 09:20'!
doAddPlayer: aPlayer
	| tfm targetInstance |
	(self isIn: aPlayer) ifTrue: [^ aPlayer signal: #dropReject].
	aPlayer isHandle ifTrue: [^ aPlayer close].

	aPlayer isDropAcceptable ifFalse: [^ aPlayer signal: #dropReject].

	tfm := self globalToLocal composedWithLocal: aPlayer localToGlobal.
	aPlayer transform: tfm.

	self add: aPlayer.

"	self isRecording ifFalse: [^ self]."


	targetInstance := (aPlayer isKindOf: CPartPrecursor)
							ifTrue: [aPlayer signal: #dropAccept with: self. "see: CPartPrecursor >> onDropped"
									self waitTick.
									aPlayer instance]
							ifFalse: [aPlayer].

	targetInstance hasPlayerId ifFalse: [
		targetInstance playerId: SqUid new.
		self attachEventRecordBehavior: targetInstance.
		self recordCreateEventFor: targetInstance.
		self isHeadless ifFalse: [self waitTick]. 
		self recordDefaultStatus: targetInstance.
		self attachBoardPropertiesTo: targetInstance.
		targetInstance attacheAllContentsTo: self
	].

	targetInstance signal: #dropAccept with: self.

! !

!SqEventRecordBoard methodsFor: 'drawing' stamp: 'mu 5/15/2006 16:50'!
drawOn: aCanvas in: drawingBounds
	super drawOn: aCanvas in: drawingBounds.

	self highlights do: [:h | 
		h drawOn: aCanvas in: drawingBounds.
	].
	
	! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/8/2006 11:52'!
eventPlayer
	eventPlayer ifNil: [eventPlayer _ SqEventPlayer on: self].
	^eventPlayer! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/8/2006 11:49'!
eventPlayer: aValue
	"Modify the receiver's eventPlayer"
	eventPlayer := aValue! !

!SqEventRecordBoard methodsFor: 'defaults' stamp: 'minami 1/19/2006 12:23'!
eventRecordBehaviorClass
	^ SqEventRecordBehavior! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 5/19/2006 10:42'!
eventRecordBoard
	^self! !

!SqEventRecordBoard methodsFor: 'setting extent' stamp: 'mu 3/17/2006 14:38'!
extent: newExtent 
	| smallBounds |
	super extent: newExtent.
	smallBounds _ self bounds insetBy: 30.
	self elements
		do: [:each | (bounds containsPoint: each position)
				ifFalse: [each
						position: (each position adhereTo: smallBounds)]]! !

!SqEventRecordBoard methodsFor: 'actions-flap' stamp: 'mu 6/2/2006 11:51'!
flap
	^self boardPanel ifNotNilDo: [:p | p flap]! !

!SqEventRecordBoard methodsFor: 'highlight' stamp: 'mu 5/22/2006 18:30'!
freezePlayer: pId from: userSerial
	| highlight |
	player := self findPlayerByUid: pId.
	player ifNil: [^ nil].

	player freeze.

	highlight _ SqSelectionHighlight new.
	highlight target: player.

	self highlights removeKey: userSerial ifAbsent: [].
	self highlights at: userSerial put: highlight.

	self invalidate.! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 4/14/2006 15:00'!
hasCover
	^self cover notNil! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/9/2006 17:02'!
hasMoreEventsToPlay
	eventPlayer ifNil: [^false].
	^eventPlayer hasMoreEventsToPlay! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/6/2006 17:03'!
headlessBoardId
	"Answer the headlessBoardId of the receiver"
	^headlessBoardId! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'MU 2/6/2006 17:03'!
headlessBoardId: aValue
	"Modify the receiver's headlessBoardId"
	headlessBoardId := aValue! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 2/8/2006 14:33'!
hideHalo
	self project halo target ifNotNil:[self project halo target: nil].! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 1/18/2006 16:23'!
highlights
	"Answer the highlights of the receiver"
	<bewareOf: #highlightsChanged>
	^self propertyValueAt: #highlights! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 1/18/2006 16:23'!
highlights: aValue
	"Modify the receiver's highlights"
	^self propertyValueAt: #highlights put: aValue with: #highlightsChanged! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'mu 5/22/2006 15:22'!
imageId
	self isHeadless ifTrue: [^nil].
	^ self accessId ifNotNilDo: [:ac | ac imageId]! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'mu 5/18/2006 12:05'!
initialize
	super initialize.
	self userDraw: true.

	self stopScript: #onGeometryChanged.
	isRecording := true.

	highlights := Dictionary new.

	selectionMode := #normal.

	isHeadless := false.
	isSelectionStarted := false.

	referencingPlayers _ Dictionary new.

	self resetTrailStartPos.! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/16/2006 13:41'!
isBoard
	^true! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 3/9/2006 15:39'!
isDropAcceptable
	^ false.! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 4/13/2006 14:46'!
isHandTrailMode
	^ selectionMode == #handTrail! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/6/2006 17:00'!
isHeadless
	isHeadless ifNil: [isHeadless _ false].
	^isHeadless! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/6/2006 17:00'!
isHeadless: aValue
	"Modify the receiver's isHeadless"
	isHeadless := aValue! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 4/13/2006 14:46'!
isNormalSelectionMode
	^ selectionMode == #normal! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 12/20/2005 11:32'!
isRecording
	"Answer the isRecording of the receiver"
	<bewareOf: #isRecordingChanged>
	^self propertyValueAt: #isRecording! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'minami 12/20/2005 11:32'!
isRecording: aValue
	"Modify the receiver's isRecording"
	^self propertyValueAt: #isRecording put: aValue with: #isRecordingChanged! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/9/2006 17:06'!
isRecovering
	"Answer the isRecovering of the receiver"
	isRecovering ifNil: [isRecovering _ false].
	^isRecovering! !

!SqEventRecordBoard methodsFor: 'testing' stamp: 'MU 2/9/2006 16:26'!
isRecovering: aValue
	"Modify the receiver's isRecovering"
	isRecovering := aValue! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
isSelectionStarted
	"Answer the isSelectionStarted of the receiver"
	^isSelectionStarted! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
isSelectionStarted: aValue
	"Modify the receiver's isSelectionStarted"
	isSelectionStarted := aValue! !

!SqEventRecordBoard methodsFor: 'lookup' stamp: 'mu 5/18/2006 12:20'!
lookupScope
	^self! !

!SqEventRecordBoard methodsFor: 'lookup' stamp: 'mu 5/18/2006 12:22'!
lookupSpecFor: anObject
	| spec |
	anObject isBehavior ifTrue: [^anObject name "see lookupBehavior:"].
	anObject isPlayer ifFalse: [^self error: 'non-player references not supported yet'].
	spec := anObject userDataAt: #lookupSpec.
	spec ifNil: [
		spec := UUID new asString36.
		anObject userDataAt: #lookupSpec put: spec.
		self referencingPlayers at: spec put: anObject.
	].
	^spec
! !

!SqEventRecordBoard methodsFor: 'lookup' stamp: 'mu 6/1/2006 21:52'!
lookup: aLookupSpec 
	| found |
	found _ self referencingPlayers
				at: aLookupSpec
				ifAbsent: [[self project scriptManager lookup: aLookupSpec]
						on: SqLookupFailureWarning
						do: [:ex | ex return: nil]].
	^ found
		ifNil: [(SqLookupFailureWarning with: aLookupSpec) signal]! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/29/2006 19:59'!
moveBoardView: deltaPoint

	self scroller horizontalPos: (self scroller horizontalPos + deltaPoint x) asInteger.
	self scroller verticalPos: (self scroller verticalPos + deltaPoint y) asInteger.
! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 5/24/2006 17:09'!
onDragDrop: aPlayer
	<on: dragDrop>

	aPlayer isTileLike ifTrue: [
		aPlayer dropAt: aPlayer globalPosition in: self world.
		^ self
	].

	self addPlayer: aPlayer.
	aPlayer unfreeze.! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 4/6/2006 12:21'!
onKeyDown: evt
	<on: keyDown>
	
	evt shiftPressed ifTrue: [
		self mouseCursor: Cursor normal
	].! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'mu 4/26/2006 15:56'!
onKeyUp: evt
	<on: keyUp>

	self setPreferredCursorBy: evt.! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 4/13/2006 14:58'!
onMouseDown: evt
	| draggee |
	<on: mouseDown>

	self isHandTrailMode ifTrue: [^ self].

	draggee := self findDraggablePlayerAt: self cursorPoint.

	draggee ifNotNilDo: [:d |
		d isFrozen ifTrue: [^ self].
		d onDrag
	].

	self removeKeyboardFocus.
	self hideHalo! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'mu 4/26/2006 15:56'!
onMouseEnter: evt
	<on: mouseEnter>

	self setPreferredCursorBy: evt! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'mu 5/8/2006 17:53'!
onMouseMove: evt
	<on: mouseMove>

	self setPreferredCursorBy: evt.
! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 4/13/2006 14:47'!
onRedButtonDown: evt
	<on: redButtonDown>

	evt shiftPressed ifTrue: [
		self mouseCursor: Cursor normal.
		^ self startSelection: evt.
	].

	self isHandTrailMode ifTrue: [
		self trailStartPos: (self globalToLocal: self hand position).
		self trailBoardView.
	]! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'minami 4/13/2006 14:48'!
onRedButtonMove: evt
	<on: redButtonMove>

	self isHandTrailMode ifTrue: [
		self trailBoardView.
	].! !

!SqEventRecordBoard methodsFor: 'events' stamp: 'mu 4/26/2006 15:57'!
onRedButtonUp: evt
	<on: redButtonUp>

	self isSelectionStarted ifTrue: [self stopSelection].

	self setPreferredCursorBy: evt.
	self resetTrailStartPos! !

!SqEventRecordBoard methodsFor: 'actions-flap' stamp: 'mu 6/2/2006 09:13'!
openFlap
	^self boardPanel openFlap! !

!SqEventRecordBoard methodsFor: 'actions-flap' stamp: 'mu 6/2/2006 12:23'!
openFlapWithScriptor: scriptor 
	self flap
		ifNotNilDo: [:f | 
			f openFlap.
			f add: scriptor.
			f width: 300.
			self invalidate]! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 6/2/2006 09:08'!
panel
	! !

!SqEventRecordBoard methodsFor: 'event playing' stamp: 'mu 4/28/2006 11:12'!
play
	eventPlayer ifNil: [^self].
	self eventPlayer play.

	! !

!SqEventRecordBoard methodsFor: 'accessing players' stamp: 'mu 5/17/2006 17:16'!
players
	^self elements select: [:each | each hasPlayerId]! !

!SqEventRecordBoard methodsFor: 'accessing players' stamp: 'mu 5/17/2006 17:17'!
playersEventRecordBehaviors
	^self players asArray inject: Set new into: [:sum :each |
		sum add: each eventRecordBehavior; yourself
	]! !

!SqEventRecordBoard methodsFor: 'accessing players' stamp: 'mu 5/17/2006 17:16'!
playersScriptors
	^self players asArray inject: Set new into: [:sum :each |
		sum addAll: each scriptors; yourself
	]! !

!SqEventRecordBoard methodsFor: 'event playing' stamp: 'MU 2/8/2006 16:40'!
playReverse
	self eventPlayer playReverse! !

!SqEventRecordBoard methodsFor: 'snapshot' stamp: 'minami 5/29/2006 16:33'!
postBuildBoard
	self allElementsDo: [:aPlayer | 
		aPlayer stopRecordingWhile: [aPlayer postBuildBoard]
		
	].! !

!SqEventRecordBoard methodsFor: 'copying' stamp: 'minami 1/16/2006 11:26'!
postCopy
	super postCopy.
Transcript cr; show: thisContext printString.! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 4/27/2006 16:22'!
prevCursorPoint
	"Answer the prevCursorPoint of the receiver"
	^prevCursorPoint! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 4/27/2006 16:22'!
prevCursorPoint: aValue
	"Modify the receiver's prevCursorPoint"
	prevCursorPoint := aValue! !

!SqEventRecordBoard methodsFor: 'printing' stamp: 'mu 6/1/2006 19:03'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	referencingPlayers ifNotNilDo: [:ep | aStream cr; nextPutAll: ('referencingPlayers-> ', referencingPlayers asString)].
	eventPlayer ifNotNilDo: [:ep | aStream cr; nextPutAll: ('last ev-> ', ep lastEvent asString)].
	aStream nextPutAll: ')'! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'mu 3/17/2006 11:21'!
recordCreateEventFor: aPlayer
	| event  |
	event := SqPlayerEventFactory
				createEvent: #playerCreated
				target: aPlayer
				accessId: self accessId
				args: #().
	self recordEvent: event.! !

!SqEventRecordBoard methodsFor: 'adding' stamp: 'minami 5/22/2006 16:24'!
recordDefaultStatus: aPlayer
	| aBehavior |
	aBehavior := aPlayer eventRecordBehavior.

	aBehavior recordEvent: #flagsChanged.
	aBehavior recordEvent: #fillChanged.
	aBehavior recordEvent: #geometryChanged.
	aBehavior recordEvent: #borderChanged.
	aBehavior recordEvent: #textChanged.
	aBehavior recordEvent: #graphicChanged.
! !

!SqEventRecordBoard methodsFor: 'sending events' stamp: 'MU 2/13/2006 13:28'!
recordEvent: eventRecord
	self isRecovering ifTrue: [^self].
	self boardClient ifNotNilDo: [:bc |  bc recordEvent: eventRecord]! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 5/18/2006 12:05'!
referencingPlayers
	"Answer the referencingPlayers of the receiver"
	^referencingPlayers! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 5/18/2006 12:05'!
referencingPlayers: aValue
	"Modify the receiver's referencingPlayers"
	referencingPlayers := aValue! !

!SqEventRecordBoard methodsFor: 'lookup' stamp: 'mu 5/18/2006 12:05'!
register: obj lookupKey: key 
	^ self referencingPlayers at: key put: obj! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'mu 5/23/2006 17:45'!
release

	eventPlayer ifNotNilDo: [:evp | evp destroy].
	boardClient ifNotNilDo: [:bc | bc destroy].
	highlights ifNotNilDo: [:hi | hi do: [:each | each destroy]].
	cursors ifNotNilDo: [:cu | cu do: [:each | each destroy]].

	isRecording _ isRecovering _ isHeadless _ false.
	highlights _ boardClient _  headlessBoardId _ eventPlayer _ cursors _ nil! !

!SqEventRecordBoard methodsFor: 'cover' stamp: 'minami 4/14/2006 15:21'!
removeCoverWhile: aBlock
	self hasCover ifFalse: [^ aBlock value].

	[	
		self cover removeCover.
		 ^ aBlock value.
	] ensure: [
		SqCoverPlayer new coverOver: self
	].
	! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 2/8/2006 14:32'!
removeKeyboardFocus
	self world hand keyboardFocus ifNotNil:[self world hand keyboardFocus: nil].! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 4/13/2006 15:09'!
removeUnhandleCover! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/29/2006 20:23'!
resetTrailStartPos
	self trailStartPos: nil! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'MU 2/14/2006 15:05'!
scrollBy: deltaPoint
	| scroller |
	scroller _ self scroller.
	scroller ifNil: [^nil].
	scroller horizontalPos: scroller horizontalPos + deltaPoint x.
	scroller verticalPos: scroller verticalPos + deltaPoint y.
	^scroller! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'mu 4/20/2006 15:40'!
scroller
	| cont |
	cont := self container.
	[cont isNil
		or: [cont isMemberOf: SqBoardWindow]
		or: [cont isMemberOf: SqBoardPanel]]
		whileFalse: [cont := cont container].

	^ ((cont isMemberOf: SqBoardWindow) or: [cont isMemberOf: SqBoardPanel])
		ifTrue: [cont]! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 2/15/2006 14:24'!
scrollTo: newPosition
	| scroller |
	scroller _ self scroller.
	scroller ifNil: [^self].
	scroller horizontalPos: newPosition x.
	scroller verticalPos: newPosition y
	! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 4/13/2006 14:45'!
selectionMode
	"Answer the selectionMode of the receiver"
	^selectionMode! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 4/13/2006 14:45'!
selectionMode: aValue
	"Modify the receiver's selectionMode"
	selectionMode := aValue! !

!SqEventRecordBoard methodsFor: 'cursors' stamp: 'mu 6/1/2006 16:32'!
sendCursorPointChanged: point
	| pos |
	pos _ point.

	prevCursorPoint = pos ifTrue: [^self].
	prevCursorPoint _ pos.

	self boardClient
		ifNotNilDo: [:cli | 
		cli sendCursorPointChanged: pos].

	self flag: #FORDEMO.
	10 atRandom = 1 ifTrue: [SqClient playAll.
	SqAudioChatUserList allInstancesDo: [:e | e startTileTicking]].! !

!SqEventRecordBoard methodsFor: 'cursors' stamp: 'mu 5/15/2006 17:22'!
sendCursorStyleChanged: style
	self boardClient
		ifNotNilDo: [:cli | 
		cli sendCursorStyleChanged: style]! !

!SqEventRecordBoard methodsFor: 'setting extent' stamp: 'mu 3/17/2006 14:20'!
setExtent: newExtent
	self boardClient ifNil: [^self].
	self extent: newExtent.
	self boardClient setExtent: newExtent.
	! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'mu 4/26/2006 15:56'!
setPreferredCursorBy: evt
	| draggee |
	evt shiftPressed ifTrue: [^ self mouseCursor: Cursor normal].
	self isHandTrailMode ifFalse: [^ self mouseCursor: Cursor normal].


"
	draggee := self findDraggablePlayerAt: self cursorPoint.

	draggee 
		ifNil: [self mouseCursor: CCursorLibrary handCursor.]
		ifNotNil: [self mouseCursor: Cursor normal]
"
	self mouseCursor: CCursorLibrary handCursor.! !

!SqEventRecordBoard methodsFor: 'cover' stamp: 'minami 4/14/2006 15:05'!
setSelectionMode: aSymbol
	self selectionMode: aSymbol.

	(self isHandTrailMode and: [self hasCover not]) 
		ifTrue: [SqCoverPlayer new coverOver: self].

	(self isNormalSelectionMode and: [self hasCover]) 
		ifTrue: [self cover removeCover].! !

!SqEventRecordBoard methodsFor: 'initialize' stamp: 'mu 3/16/2006 17:01'!
setupCostume
	super setupCostume.

	self clipping: true.
	self borderStyle: #raised.
	self borderWidth: 0.

	self color := Color r:0.937 g: 0.937 b: 0.937.
	"self borderStyle: #inner."

	self extent: SqSettings defaultBoardExtent! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 12/27/2005 15:13'!
smallForm
	^ self makeIcon: self smallFormExtent! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 12/27/2005 16:56'!
smallFormExtent
	^ SqUtil smallFormExtent: self! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 2/23/2006 11:54'!
smallFormExtent: reduction
	^ SqUtil smallFormExtent: self reduction: reduction! !

!SqEventRecordBoard methodsFor: 'util' stamp: 'minami 2/23/2006 11:54'!
smallForm: reduction
	^ self makeIcon: (self smallFormExtent: reduction)! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 4/7/2006 15:13'!
startSelection: evt 
	| sp |
	sp := SqSelectionPlayer new
		addResizeHandle;
		extent: 10@10;
		center: evt position;
		yourself.
	self add: sp.
	self isHeadless ifFalse: [self waitTick].

	self hand attach: sp resizeHandle
! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'MU 2/17/2006 13:34'!
stepScrollToward: aPlayer
	aPlayer ifNil: [^false].
	(aPlayer isOnBoard: self) ifFalse: [^false].

	self stepScrollTo: (aPlayer onBoardPosition: aPlayer position) by: 7.
	^true
! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 2/16/2006 09:44'!
stepScrollToward: aPlayer by: step
	aPlayer ifNil: [^self].
	self stepScrollTo: (aPlayer onBoardPosition: aPlayer position) by: step
! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'minami 2/15/2006 14:55'!
stepScrollTo: targetPosition
	self stepScrollTo: targetPosition by: 7! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'mu 5/15/2006 16:56'!
stepScrollTo: targetPosition by: step
	| scroller vpExtent distPos delta |
	(scroller := self scroller) ifNil: [^ self].

	vpExtent := self viewport extent.

	distPos := ((targetPosition x - (vpExtent x // 2)) @ (targetPosition y - (vpExtent y // 2))) asIntegerPoint.
	delta := (distPos - scroller currentPos) // step.

	step timesRepeat: [
		scroller currentPos: (scroller currentPos + delta).
		self isHeadless ifFalse: [self waitTick]. 
	].
	scroller currentPos: distPos
! !

!SqEventRecordBoard methodsFor: 'event playing' stamp: 'mu 4/28/2006 11:12'!
stop
	self eventPlayer stop.

	! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/31/2006 12:15'!
stopSelection
	self isSelectionStarted: false! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:16'!
title
	^ self boardName! !

!SqEventRecordBoard methodsFor: 'private' stamp: 'minami 3/29/2006 20:25'!
trailBoardView
	| handPos delta |
	self trailStartPos ifNil: [^ self].

	self mouseCursor: CCursorLibrary fistCursor.
	handPos := self globalToLocal: self hand position.
	delta := self trailStartPos - handPos.
	self moveBoardView: delta.
! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
trailStartPos
	"Answer the trailStartPos of the receiver"
	^trailStartPos! !

!SqEventRecordBoard methodsFor: 'accessing' stamp: 'minami 3/31/2006 12:14'!
trailStartPos: aValue
	"Modify the receiver's trailStartPos"
	trailStartPos := aValue! !

!SqEventRecordBoard methodsFor: 'highlight' stamp: 'mu 5/22/2006 15:31'!
unfreezePlayer: pId from: userSerial

	player := self findPlayerByUid: pId.
	player ifNil: [^ nil].

	player unfreeze.
	self highlights removeKey: userSerial ifAbsent: [].

	self invalidate.! !

!SqEventRecordBoard methodsFor: 'lookup' stamp: 'mu 6/1/2006 19:14'!
unregister: obj lookupKey: key 
	^ self referencingPlayers removeKey: key ifAbsent:[]! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'mu 5/22/2006 15:10'!
userId
	self isHeadless ifTrue: [^nil].
	^ self boardClient ifNotNilDo: [:bc | bc userId] ! !

!SqEventRecordBoard methodsFor: 'accessing id' stamp: 'mu 5/22/2006 15:23'!
userSerial
	self isHeadless ifTrue: [^nil].
	^ self boardClient ifNotNilDo: [:bc | bc userSerial] ! !

!SqEventRecordBoard methodsFor: 'scrolling' stamp: 'mu 5/15/2006 16:56'!
viewport
	| scrollPane |
	scrollPane _ self container ifNotNilDo: [:con | con container].
	^ scrollPane ifNotNilDo: [:sc | 
		| b |
		b _ sc bounds.
		b translateBy: b topLeft negated].! !

!SqEventRecordBoard methodsFor: 'serializing' stamp: 'MU 2/15/2006 15:20'!
writeFieldsOn: aSerializer
	boardClient _ nil.
	super writeFieldsOn: aSerializer! !

CPlayer subclass: #SqLevelIndicator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqLevelIndicator defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="level" toSet="level:" changeEvent="levelChanged">level</field>
	<field toGet="backgroundColor" toSet="backgroundColor:" changeEvent="backgroundColorChanged">backgroundColor</field>
</fields>'!

!SqLevelIndicator class methodsFor: 'examples' stamp: 'minami 3/7/2006 11:50'!
ex01
"
SqLevelIndicator ex01
"
	| indicator |
	indicator := SqLevelIndicator openInHand.
	0 to: 1 by: 0.02 do: [:i |
		indicator level: i.
		indicator waitTick.
	].

	1 to: 0 by: -0.02 do: [:i |
		indicator level: i.
		indicator waitTick.
	].! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:42'!
backgroundColor
	"Answer the backgroundColor of the receiver"
	<bewareOf: #backgroundColorChanged>
	^self propertyValueAt: #backgroundColor! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:42'!
backgroundColor: aValue
	"Modify the receiver's backgroundColor"
	^self propertyValueAt: #backgroundColor put: aValue with: #backgroundColorChanged! !

!SqLevelIndicator methodsFor: 'drawing' stamp: 'minami 3/7/2006 11:46'!
drawOn: aCanvas in: drawingBounds
	| bw w x r |
	bw := self borderWidth.
	aCanvas
		frameAndFillRectangle: drawingBounds 
		fillColor: self color 
		borderWidth: bw 
		borderColor: self borderColor.

	w := ((drawingBounds width - (bw * 2)) * (((1 - level) min: 1) max: 0)) asInteger.
	x := drawingBounds topRight x - w.
	r := x @ (drawingBounds topLeft y + bw) corner: drawingBounds bottomRight - bw.

	aCanvas fillRectangle: r color: self backgroundColor! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/16/2006 07:47'!
initialize
	super initialize.
	self userDraw: true.
	
	level := 0.
! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:04'!
level
	"Answer the level of the receiver"
	<bewareOf: #levelChanged>
	^self propertyValueAt: #level! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:04'!
level: aValue
	"Modify the receiver's level"
	^self propertyValueAt: #level put: aValue with: #levelChanged! !

!SqLevelIndicator methodsFor: 'events' stamp: 'minami 3/7/2006 11:12'!
onLevelChanged
	<on: levelChanged>

	self invalidate! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:28'!
reset
	self level: 0! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/27/2006 06:46'!
setupCostume
	super setupCostume.

	self borderWidth: 1.
	self borderColor: Color white.
	self color: Color yellow.
	self backgroundColor: Color veryLightGray..

! !

CPlayer subclass: #SqTabbedPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqTabbedPanel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
	<field toGet="activeContent" toSet="activeContent:" changeEvent="activeContentChanged">activeContent</field>
</fields>'!

!SqTabbedPanel methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:21'!
activeContent
	"Answer the activeContent of the receiver"
	<bewareOf: #activeContentChanged>
	^self propertyValueAt: #activeContent! !

!SqTabbedPanel methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:21'!
activeContent: aValue
	"Modify the receiver's activeContent"
	^self propertyValueAt: #activeContent put: aValue with: #activeContentChanged! !

!SqTabbedPanel methodsFor: 'actions' stamp: 'minami 3/17/2006 12:05'!
addContent: aPlayer
	self contents add: aPlayer.

	self signal: #contentAdded with: aPlayer! !

!SqTabbedPanel methodsFor: 'initialize' stamp: 'mu 4/4/2006 17:28'!
close
	self activeContent ifNotNilDo: [:con | con close].
	self activeContent: nil.

	self contents do: [:aPlayer |
		aPlayer close.
	].
	self contents: OrderedCollection new.

	super close.! !

!SqTabbedPanel methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:02'!
contents
	"Answer the contents of the receiver"
	<bewareOf: #contentsChanged>
	^self propertyValueAt: #contents! !

!SqTabbedPanel methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:02'!
contents: aValue
	"Modify the receiver's contents"
	^self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!SqTabbedPanel methodsFor: 'initialize' stamp: 'mu 4/20/2006 15:48'!
defaultCostume
	^ SqTabbedPanelCostume ! !

!SqTabbedPanel methodsFor: 'initialize' stamp: 'minami 3/20/2006 11:22'!
initialize
	super initialize.
	
	activeContent := nil.
	contents := OrderedCollection new.
! !

!SqTabbedPanel methodsFor: 'initialize' stamp: 'mu 4/27/2006 11:43'!
release
	self activeContent ifNotNilDo: [:a | a release].
	self contents do: [:aPlayer |
		aPlayer release.
	].! !

!SqTabbedPanel methodsFor: 'actions' stamp: 'minami 5/17/2006 16:42'!
removeActiveContent
	self activeContent: nil.
! !

CPlayer subclass: #SqTestPlayer
	instanceVariableNames: 'instVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Tests'!

SqTestPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="instVar" toSet="instVar:">instVar</field>
</fields>'!

!SqTestPlayer methodsFor: 'initialization' stamp: 'mu 4/21/2006 12:06'!
initialize
	self color: Color red.
	self extent: 100@50.! !

!SqTestPlayer methodsFor: 'accessing' stamp: 'mu 3/7/2006 10:37'!
instVar
	"Answer the instVar of the receiver"
	^instVar! !

!SqTestPlayer methodsFor: 'accessing' stamp: 'mu 3/7/2006 10:37'!
instVar: aValue
	"Modify the receiver's instVar"
	instVar := aValue! !

!SqTestPlayer methodsFor: 'stepping' stamp: 'MU 2/14/2006 14:31'!
moveBy: anInteger
	self position: self position + anInteger! !

!SqTestPlayer methodsFor: 'stepping' stamp: 'MU 2/14/2006 14:28'!
start
	
	self startTicking: #moveBy: withArguments: #(1) at: 100! !

CPlayer subclass: #SqToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqToolBar class
	instanceVariableNames: 'imageDic'!

SqToolBar subclass: #SqSimpleToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqSimpleToolBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="toolList" toSet="toolList:" changeEvent="toolListChanged">toolList</field>
</fields>'!

!SqSimpleToolBar class methodsFor: 'gui spec' stamp: 'minami 5/23/2006 19:54'!
buttonsSpec
	"name -> {actionSelector. image. description}"
	^ {
		"#example -> {#doExample. self exampleImage. 'do something' translated}"
	}! !

!SqSimpleToolBar methodsFor: 'intialize' stamp: 'minami 5/23/2006 19:55'!
buildToolButtons
	| spec buttons |
	spec _ self class buttonsSpec.
	buttons _ OrderedCollection new.
	spec
		do: [:each | 
			| val button | 
			val _ each value.
			button _ self makeButtonLabelForm: val second description: val last.
			button value: val first.
			button on: #fire notify: self. 
			buttons add: button].
	^ buttons! !

!SqSimpleToolBar methodsFor: 'intialize' stamp: 'minami 5/23/2006 19:55'!
buildToolList
	toolList := CButtonList new.
	toolList layout: CTableLayout new.
	toolList layout listDirection: #leftToRight.
	toolList hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	toolList layout cellInset: 2.
	toolList addAll: self buildToolButtons.

	self add: toolList! !

!SqSimpleToolBar methodsFor: 'intialize' stamp: 'minami 5/23/2006 19:55'!
setupCostume
	super setupCostume.

	self buildToolList.
! !

!SqSimpleToolBar methodsFor: 'defaults' stamp: 'minami 5/23/2006 20:17'!
targetSelector
	^ #activeContent! !

!SqSimpleToolBar methodsFor: 'accessing' stamp: 'minami 5/23/2006 19:55'!
toolList
	"Answer the toolList of the receiver"
	<bewareOf: #toolListChanged>
	^self propertyValueAt: #toolList! !

!SqSimpleToolBar methodsFor: 'accessing' stamp: 'minami 5/23/2006 19:55'!
toolList: aValue
	"Modify the receiver's toolList"
	^self propertyValueAt: #toolList put: aValue with: #toolListChanged! !

!SqSimpleToolBar methodsFor: 'events' stamp: 'minami 5/23/2006 20:21'!
valueWithEvent: ev
	self target ifNil: [^self].
	(self target perform: self targetSelector) ifNotNilDo: [:b | b perform: ev sender value].! !

SqToolBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
</fields>'!

!SqToolBar class methodsFor: 'accessing' stamp: 'mu 5/12/2006 16:06'!
imageAt: symbol
	^ self imageDic at: symbol ifAbsent: []! !

!SqToolBar class methodsFor: 'accessing' stamp: 'mu 5/12/2006 16:06'!
imageAt: symbol ifAbsentPut: aBlock
	^ self imageDic at: symbol ifAbsentPut: aBlock! !

!SqToolBar class methodsFor: 'accessing' stamp: 'mu 5/12/2006 16:06'!
imageAt: symbol ifAbsent: aBlock
	^ self imageDic at: symbol ifAbsent: aBlock! !

!SqToolBar class methodsFor: 'accessing' stamp: 'mu 5/12/2006 16:06'!
imageAt: symbol put: image
	^ self imageDic at: symbol put: image! !

!SqToolBar class methodsFor: 'accessing' stamp: 'mu 5/12/2006 16:05'!
imageDic
	imageDic ifNil: [imageDic _ IdentityDictionary new].
	^ imageDic! !

!SqToolBar class methodsFor: 'class initialization' stamp: 'mu 5/12/2006 16:05'!
initialize
"
	SqToolBar initialize.
"
	super initialize.
	imageDic := nil.


	self allSubclassesDo: [:sb | sb initialize].! !

!SqToolBar class methodsFor: 'instance creation' stamp: 'minami 4/13/2006 11:57'!
on: aTarget
	^ self new target: aTarget; yourself! !

!SqToolBar methodsFor: 'defaults' stamp: 'mu 5/10/2006 17:36'!
defaultBaseColor
	^self project widgetLibrary baseColor! !

!SqToolBar methodsFor: 'defaults' stamp: 'minami 4/17/2006 14:31'!
defaultButtonExtent
	^ 32@32! !

!SqToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 10:55'!
defaultCostume
	^CHolder! !

!SqToolBar methodsFor: 'defaults' stamp: 'minami 4/13/2006 16:03'!
defaultExtent
	^ 200@30! !

!SqToolBar methodsFor: 'defaults' stamp: 'mu 5/10/2006 17:36'!
defaultFrameColor
	^self project widgetLibrary frameColor! !

!SqToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 11:29'!
initialize
	super initialize.

	items := Dictionary new.! !

!SqToolBar methodsFor: 'util' stamp: 'minami 4/17/2006 14:49'!
makeButtonLabelForm: aForm description: descriptionString
	| button |
	button := CToolBarButton new.
	button extent: self defaultButtonExtent.
	button hResizing: #rigid; vResizing: #rigid.

	button image: aForm.

	descriptionString isEmptyOrNil ifFalse: [button balloonHelp: descriptionString].

	^ button! !

!SqToolBar methodsFor: 'util' stamp: 'minami 4/17/2006 14:48'!
makeButtonLabelText: labelText description: descriptionString
	| button |
	button := CToolBarButton new.
	button extent: self defaultButtonExtent.
	button hResizing: #rigid; vResizing: #rigid.

	button label: labelText.

	descriptionString isEmptyOrNil ifFalse: [button balloonHelp: descriptionString].

	^ button! !

!SqToolBar methodsFor: 'util' stamp: 'minami 4/13/2006 12:01'!
makeButtonLabel: labelTextOrForm description: descriptionString
	| button |
	button := CToolBarButton new.
	button extent: self defaultButtonExtent.
	button hResizing: #rigid; vResizing: #rigid.

	(labelTextOrForm isKindOf: String) ifTrue: [button label: labelTextOrForm].
	(labelTextOrForm isKindOf: Form) ifTrue: [button image: labelTextOrForm].		

	descriptionString isEmptyOrNil ifFalse: [button balloonHelp: descriptionString].

	^ button! !

!SqToolBar methodsFor: 'intialize' stamp: 'mu 5/10/2006 17:36'!
setupCostume
	super setupCostume.
	self fillStyle: #solid.
	self fillColors: (Array with: (Color r: 1.0 g: 1.0 b: 1.0) with: (self defaultBaseColor)).
	self borderWidth: 1.
	self roundCorners: true.
	self dropShadowEnabled: true.
	self borderColor: (self defaultFrameColor).
	self borderStyle: #simple.
	self fillStyle: #solid.

	layout := CTableLayout new.
	layout listDirection: #leftToRight.
	layout wrapDirection: #topToBottom.
	layout hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	layout layoutInset: 4.
	layout cellInset: 2.


	self extent: self defaultExtent! !

!SqToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 11:57'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!SqToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 11:57'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!SqToolBar methodsFor: 'color and fill' stamp: 'minami 4/13/2006 10:55'!
windowColor: aColor
	super windowColor: aColor.
	self elements do:[:each| each windowColor: aColor].
! !

!CLabel methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/16/2006 17:15'!
isLabel
	^true! !

TMessageDecoder2 subclass: #SqEventDecoder
	instanceVariableNames: 'forStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

SqEventDecoder class
	instanceVariableNames: 'codeMap'!

!SqEventDecoder class methodsFor: 'accessing' stamp: 'mu 5/19/2006 12:04'!
codeMap
	codeMap ifNil: [self initCodeMap].
	^codeMap! !

!SqEventDecoder class methodsFor: 'class initialization' stamp: 'mu 5/19/2006 15:35'!
collectionCodeSpec
	^#(
		(Dictionary				decodeDictionary			90)
		(IdentityDictionary				decodeIdentityDictionary			91)
	) 
	! !

!SqEventDecoder class methodsFor: 'utilities' stamp: 'mu 5/19/2006 17:01'!
defineEventDecodeMethods
	"SqEventDecoder defineEventDecodeMethods"
	self eventCodeSpec
		do: [:each | SqEventDecoder
				compile: ('{1}
	^self basicDecodeEvent: {2} new.' format: {each second. each first})
				classified: 'decoding-events']! !

!SqEventDecoder class methodsFor: 'class initialization' stamp: 'mu 5/19/2006 16:39'!
eventCodeSpec
	^#(
		(SqPlayerCreatedEvent				decodePlayerCreatedEvent			101)
		(SqPlayerRemovedEvent				decodePlayerRemovedEvent			102)
		(SqPlayerSelectedEvent				decodePlayerSelectedEvent			103)

		(SqPlayerLockEvent				decodePlayerLockEvent			104)
		(SqPlayerUnlockEvent				decodePlayerUnlockEvent			105)

		(SqBorderChangedEvent	decodeBorderChangedEvent			106)
		(SqDropAcceptEvent				decodeDropAcceptEvent			107)
		(SqFillChangedEvent				decodeFillChangedEvent			108)
		(SqFlagsChangedEvent				decodeFlagsChangedEvent			109)
		(SqGeometryChangedEvent				decodeGeometryChangedEvent			110)
		(SqGraphicChangedEvent				decodeGraphicChangedEvent			111)
		(SqImageChangedEvent				decodeImageChangedEvent			112)
		

		(SqPolygonStateChangedEvent				decodePolygonStateChangedEvent			113)
		(SqRoundCornersChangedEvent				decodeRoundCornersChangedEvent			114)
		(SqVerticesChangedEvent				decodeVerticesChangedEvent			115)
		
		(SqUngroupEvent				decodeUngroupEvent			116)
		
		(SqLabelChangedEvent				decodeLabelChangedEvent			117)
		(SqTextChangedEvent				decodeTextChangedEvent			118)
		(SqTextEditorStatusChangedEvent				decodeTextEditorStatusChangedEvent			119)

		(SqGenericCommand				decodeGenericCommand			120)

		(SqScriptModifiedEvent				decodeScriptModifiedEvent			121)
		(SqScriptStatusChangedEvent				decodeScriptStatusChangedEvent			122)

		(SqCursorPointChangedCommand				decodeCursorPointChangedCommand			123)
		(SqCursorStyleChangedCommand				decodeCursorStyleChangedCommand			124)

	) ! !

!SqEventDecoder class methodsFor: 'class initialization' stamp: 'mu 5/19/2006 15:34'!
initCodeMap
	"SqEventDecoder initCodeMap"
	codeMap _ Array new: 256.
	CodeMap
		ifNotNilDo: [:map | map
				keysAndValuesDo: [:k :v | codeMap at: k put: v]].

	{self primitiveCodeSpec. self collectionCodeSpec. self eventCodeSpec}
		do: [:eachSpec | eachSpec
				do: [:spec | 
					| code sele | 
					code _ spec third.
					sele _ spec second.
					codeMap at: code put: sele]]! !

!SqEventDecoder class methodsFor: 'class initialization' stamp: 'minami 5/19/2006 14:59'!
initialize
	super initialize.
	self initCodeMap! !

!SqEventDecoder class methodsFor: 'class initialization' stamp: 'mu 5/21/2006 19:19'!
primitiveCodeSpec
	^#(
		(SqUid				decodeSqUid			80)
		(SqAccessId				decodeSqAccessId			81)
		(SqPackedBytes				decodeSqPackedBytes			82)
		(TimeStamp				decodeTimeStamp			83)
		(Form				decodeForm			84)
		(ColorForm			decodeColorForm			85)
	) ! !

!SqEventDecoder methodsFor: 'decoding' stamp: 'mu 6/5/2006 20:51'!
basicDecodeEventOf: eventClass

	| event values |
	event _ eventClass new.

	self forStore ifTrue: [
		event eventId: (self decodeNext).
		event timeStamp: (self decodeNext).
	].

	event targetId: (self decodeNext).
	event accessId: (self decodeNext).
	
	values _ self decodeNext.
	event setArrayArguments: values.
	^event! !

!SqEventDecoder methodsFor: 'decoding' stamp: 'mu 6/5/2006 20:51'!
basicDecodeEvent: event

	self forStore ifTrue: [
		event eventId: (self decodeNext).
		event timeStamp: (self decodeNext).
	].

	event targetId: (self decodeNext).
	event accessId: (self decodeNext).
	event arguments: (self decodeNext).
	
	^event
	! !

!SqEventDecoder methodsFor: 'accessing' stamp: 'mu 5/19/2006 11:49'!
codeMap
	^self class codeMap! !

!SqEventDecoder methodsFor: 'decoding' stamp: 'mu 5/19/2006 11:58'!
decodeArgs: aStream
	^self decodeArgs: aStream in: Processor activeIsland! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeBorderChangedEvent
	^self basicDecodeEvent: SqBorderChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-primitives' stamp: 'mu 5/19/2006 12:24'!
decodeColor
	| value |
	value _ stream nextUInt32.
	^Color colorFromPixelValue: value depth: 32! !

!SqEventDecoder methodsFor: 'decoding-primitives' stamp: 'mu 5/19/2006 16:20'!
decodeColorForm
	| size bytes |
	size := self readUnsigned.
	bytes _ stream next: size.
	^ColorForm fromCompactBytes: bytes uncompressOnDemand! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/21/2006 19:27'!
decodeCursorPointChangedCommand
	| ev |
	ev _ SqCursorPointChangedCommand new.
	ev accessId: self decodeNext.
	ev point: self decodeNext.
	^ev! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/21/2006 19:27'!
decodeCursorStyleChangedCommand
	| ev |
	ev _ SqCursorStyleChangedCommand new.
	ev accessId: self decodeNext.
	ev style: self decodeNext.
	^ev! !

!SqEventDecoder methodsFor: 'decoding-collections' stamp: 'mu 5/19/2006 16:29'!
decodeDictionary
	| sz obj |
	sz := self readUnsigned.
	obj := Dictionary new: sz.
	1 to: sz do:[:i| obj at: self decodeNext put: self decodeNext].
	^obj! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 6/5/2006 21:51'!
decodeDropAcceptEvent
	| event |
	event _ SqDropAcceptEvent new.
	self forStore ifTrue: [
		event eventId: (self decodeNext).
	].
	event targetId: (self decodeNext).
	event accessId: (self decodeNext).
	event distPlayer: self decodeNext.
	event targetPosition: self decodeNext.
	^event! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/23/2006 14:23'!
decodeFillChangedEvent
	
	| event |
	event _ self basicDecodeEventOf: SqFillChangedEvent.
	event alpha: self decodeNext.
	^event! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeFlagsChangedEvent
	^self basicDecodeEvent: SqFlagsChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-primitives' stamp: 'mu 5/19/2006 16:20'!
decodeForm
	| size bytes |
	size := self readUnsigned.
	bytes _ stream next: size.
	^Form fromCompactBytes: bytes uncompressOnDemand! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/21/2006 19:32'!
decodeGenericCommand
	| event |
	event _ self basicDecodeEvent: SqGenericCommand new.
	event selector: self decodeNext.
	^event! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/31/2006 14:43'!
decodeGeometryChangedEvent
	
	^self basicDecodeEventOf: SqGeometryChangedEvent! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeGraphicChangedEvent
	^self basicDecodeEvent: SqGraphicChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-collections' stamp: 'mu 5/19/2006 16:38'!
decodeIdentityDictionary
	| sz obj |
	sz := self readUnsigned.
	obj := IdentityDictionary new: sz.
	1 to: sz do:[:i| obj at: self decodeNext put: self decodeNext].
	^obj! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeImageChangedEvent
	^self basicDecodeEvent: SqImageChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeLabelChangedEvent
	^self basicDecodeEvent: SqLabelChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding' stamp: 'mu 5/19/2006 11:50'!
decodeNext
	"Decode the object"
	code := self readUnsigned.
	^self perform: (self codeMap at: code)! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodePlayerCreatedEvent
	^self basicDecodeEvent: SqPlayerCreatedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 6/5/2006 21:51'!
decodePlayerLockEvent
	| event |
	event _ SqPlayerLockEvent new.
	self forStore ifTrue: [
		event eventId: (self decodeNext).
	].
	event targetId: (self decodeNext).
	event accessId: (self decodeNext).
	^event! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodePlayerRemovedEvent
	^self basicDecodeEvent: SqPlayerRemovedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodePlayerSelectedEvent
	^self basicDecodeEvent: SqPlayerSelectedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 6/5/2006 21:51'!
decodePlayerUnlockEvent
	| event |
	event _ SqPlayerUnlockEvent new.
	self forStore ifTrue: [
		event eventId: (self decodeNext).
	].
	event targetId: (self decodeNext).
	event accessId: (self decodeNext).
	^event! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodePolygonStateChangedEvent
	^self basicDecodeEvent: SqPolygonStateChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeRoundCornersChangedEvent
	^self basicDecodeEvent: SqRoundCornersChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeScriptModifiedEvent
	^self basicDecodeEvent: SqScriptModifiedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeScriptStatusChangedEvent
	^self basicDecodeEvent: SqScriptStatusChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-primitives' stamp: 'mu 5/22/2006 18:14'!
decodeSqAccessId
	| bytes |
	bytes _ stream next: SqAccessId defaultSize.
	^SqAccessId fromBytes: bytes! !

!SqEventDecoder methodsFor: 'decoding-primitives' stamp: 'mu 5/19/2006 16:26'!
decodeSqPackedBytes
	| size |
	size := self readUnsigned.
	^SqPackedBytes fromBytes: (stream next: size)! !

!SqEventDecoder methodsFor: 'decoding-primitives' stamp: 'mu 5/19/2006 15:46'!
decodeSqUid
	"assuming the size is default 6"
	| bytes |
	bytes _ stream next: 6.
	^SqUid fromBytes: bytes! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 6/6/2006 15:48'!
decodeTextChangedEvent
	| event values |
	event _ SqTextChangedEvent new.
	self forStore
		ifTrue: [event eventId: self decodeNext.
			event timeStamp: self decodeNext].
	event targetId: self decodeNext.
	event accessId: self decodeNext.
	values _ self decodeNext.
	values isCollection
		ifTrue: [event setArrayArguments: values]
		ifFalse: [event textEnabled: false].
	^ event! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeTextEditorStatusChangedEvent
	^self basicDecodeEvent: SqTextEditorStatusChangedEvent new.! !

!SqEventDecoder methodsFor: 'decoding-primitives' stamp: 'mu 5/19/2006 15:48'!
decodeTimeStamp
	| value |
	value := self readUnsigned.
	^TimeStamp fromSeconds: value! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 5/19/2006 17:01'!
decodeUngroupEvent
	^self basicDecodeEvent: SqUngroupEvent new.! !

!SqEventDecoder methodsFor: 'decoding-events' stamp: 'mu 6/5/2006 21:52'!
decodeVerticesChangedEvent
	| event values |
	event _ SqVerticesChangedEvent new.
	self forStore ifTrue: [
		event eventId: (self decodeNext).
	].
	event targetId: (self decodeNext).
	event accessId: (self decodeNext).

	values _ self decodeNext.
	event vertices: values.
	^event! !

!SqEventDecoder methodsFor: 'decoding' stamp: 'mu 5/19/2006 12:18'!
decode: data 
	self setStream: data readStream.
	^self decodeNext
	! !

!SqEventDecoder methodsFor: 'accessing' stamp: 'mu 6/5/2006 20:50'!
forStore
	forStore ifNil: [forStore _ false].
	^forStore! !

!SqEventDecoder methodsFor: 'accessing' stamp: 'mu 6/5/2006 20:50'!
forStore: aBoolean
	forStore _ aBoolean! !

!SqEventDecoder methodsFor: 'decoding' stamp: 'mu 5/19/2006 12:16'!
setStream: aStream 
	stream _ aStream! !

!Dictionary methodsFor: '*SqSquare-Core-lookup' stamp: 'mu 6/2/2006 16:30'!
lookupSpecFor: anObject
	| spec |
	anObject isBehavior ifTrue: [^anObject name "see lookupBehavior:"].
	anObject isPlayer ifFalse: [^self error: 'non-player references not supported yet'].
	spec := anObject userDataAt: #lookupSpec.
	spec ifNil: [
		spec := UUID new asString36.
		anObject userDataAt: #lookupSpec put: spec.
		self at: spec put: anObject.
	].
	^spec! !

RmtTcpService subclass: #SqTcpService
	instanceVariableNames: 'onAccepted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqTcpService methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:34'!
onAccepted
	onAccepted ifNil: [onAccepted _ [:acc | ]].
	^onAccepted! !

!SqTcpService methodsFor: 'accessing' stamp: 'mu 12/28/2005 23:34'!
onAccepted: aBlock
	onAccepted _ aBlock! !

!SqTcpService methodsFor: 'conversation' stamp: 'MU 1/20/2006 19:23'!
serve: aSocket 
	| newAcceptor times |
	newAcceptor := self acceptorClass new.
	newAcceptor isAcceptor
		ifFalse: [self error: newAcceptor asString , 'is not an Acceptor'].
	acceptors add: newAcceptor.
	newAcceptor on: aSocket.
	
	times _ 0.
	[times < 3 and: [newAcceptor accessId isNil]] whileTrue: [
		(Delay forSeconds: 1) wait.
		times _ times + 1.
	].
	newAcceptor accessId ifNil: [^newAcceptor close].

	self onAccepted value: newAcceptor.
	! !

!SqTcpService methodsFor: 'actions' stamp: 'minami 1/13/2006 11:50'!
try: tryBlock times: anInteger while: whileBlock
	| times |
	times _ 0.
	[times < anInteger] whileTrue: [
		whileBlock value ifFalse: [^ true].

		tryBlock value.
		(Delay forSeconds: 1) wait.
	].

	^ false! !

!ScriptEvent methodsFor: '*SqSquare-Core-testing' stamp: 'minami 4/27/2006 12:26'!
isSignaledByTickMessage
	^ self signaler == #tick! !

!ScriptEvent methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 4/27/2006 16:10'!
signaler
	^ signaler! !

!ScriptEvent methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 4/27/2006 16:10'!
signaler: aSymbol
	signaler := aSymbol! !

CEllipsePlayer subclass: #SqHandlePlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Player'!

SqHandlePlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="startPos" toSet="startPos:" changeEvent="startPosChanged">startPos</field>
</fields>'!

!SqHandlePlayer methodsFor: 'private' stamp: 'minami 4/7/2006 16:03'!
computeBounds: targetOrigin with: selfOrigin
	| rect |
	rect := targetOrigin.
	top := rect topLeft y min: rect bottomRight y.
	bottom := rect topLeft y max: rect bottomRight y.
	left := rect topLeft x min: rect bottomRight x.
	right := rect topLeft x max: rect bottomRight x.

	^ (left @ top) corner: (right @ bottom)! !

!SqHandlePlayer methodsFor: 'initialize' stamp: 'minami 4/6/2006 14:48'!
initialize
	super initialize.
! !

!SqHandlePlayer methodsFor: 'testing' stamp: 'minami 4/6/2006 15:21'!
isDropAcceptable
	^ false.! !

!SqHandlePlayer methodsFor: 'testing' stamp: 'minami 4/6/2006 15:40'!
isHandle
	^ true! !

!SqHandlePlayer methodsFor: 'events' stamp: 'minami 4/7/2006 15:39'!
mouseLeave: evt
	<on: mouseLeave>

	self target ifNotNilDo: [:t |
		t forcusToSelectedPlayers.
	].

	self target: nil.
	self close.! !

!SqHandlePlayer methodsFor: 'events' stamp: 'minami 4/18/2006 12:00'!
onGeometryChanged
	| newBounds |
	
	<on: geometryChanged>

	self target ifNil: [^ self].

	newBounds := self target container globalToLocal: (self startPos rect: self globalPosition).
	^ self target bounds: newBounds.
! !

!SqHandlePlayer methodsFor: 'initialize' stamp: 'minami 4/6/2006 14:48'!
setupCostume
	super setupCostume.

	self color: Color yellow.! !

!SqHandlePlayer methodsFor: 'accessing' stamp: 'minami 4/17/2006 17:26'!
startPos
	"Answer the startPos of the receiver"
	<bewareOf: #startPosChanged>
	^self propertyValueAt: #startPos! !

!SqHandlePlayer methodsFor: 'accessing' stamp: 'minami 4/17/2006 17:26'!
startPos: aValue
	"Modify the receiver's startPos"
	^self propertyValueAt: #startPos put: aValue with: #startPosChanged! !

!SqHandlePlayer methodsFor: 'accessing' stamp: 'minami 4/6/2006 14:30'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!SqHandlePlayer methodsFor: 'accessing' stamp: 'minami 4/6/2006 14:30'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

Notification subclass: #SqBoardEntryNotification
	instanceVariableNames: 'entryParams'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Exceptions'!

!SqBoardEntryNotification methodsFor: 'exceptionDescription' stamp: 'mu 4/20/2006 14:39'!
defaultAction
	"entryParams inspect."
	^nil! !

!SqBoardEntryNotification methodsFor: 'accessing' stamp: 'mu 4/20/2006 11:58'!
entryParams
	entryParams ifNil: [entryParams _ Dictionary new].
	^entryParams! !

!SqBoardEntryNotification methodsFor: 'accessing' stamp: 'mu 4/20/2006 11:58'!
entryParams: aDictionary
	entryParams _ aDictionary! !

CObjectMakerSerializer subclass: #SqPlayerSerializer
	instanceVariableNames: 'isForSendingEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqPlayerSerializer methodsFor: 'testing' stamp: 'mu 5/18/2006 16:13'!
isForSendingEvents
	isForSendingEvents ifNil: [isForSendingEvents _ true].
	^isForSendingEvents! !

!SqPlayerSerializer methodsFor: 'testing' stamp: 'mu 5/18/2006 16:13'!
isForSendingEvents: aBoolean
	isForSendingEvents _ aBoolean! !

!SqPlayerSerializer methodsFor: 'private-writing' stamp: 'mu 3/2/2006 15:28'!
writeContentsOf: anObject
	"Write the contents of the given object"
	anObject writeMementoFieldsOn: self! !

CProjectShell subclass: #SqProjectShell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Project'!

SqProjectShell defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqProjectShell methodsFor: 'initialize' stamp: 'minami 1/20/2006 12:21'!
newProject
	myIsland := CProjectIsland new.
	myIsland scheduler: (myIsland new: ScriptScheduler).
	myIsland project: (myProject := myIsland new: SqEToysProject).
	myProject newProject.! !

!ScriptMessageSend methodsFor: '*SqSquare-Core-accessing-override' stamp: 'mu 6/2/2006 17:27'!
pauseScript
	"Stop notifications from event sources"
	self isPaused ifTrue:[^self].
	eventSpec ifNil:[^self].
	1 to: eventSpec size by: 2 do:[:i|
		(eventSpec at: i) on: (eventSpec at: i+1) unNotify: self.
	].
	paused := true.
	receiver signal: #scriptStatusChanged with: selector with: #paused.! !

!ScriptMessageSend methodsFor: '*SqSquare-Core-accessing-override' stamp: 'minami 5/9/2006 16:38'!
resumeScript
	"Resume notifications from event sources"
	self isPaused ifFalse:[^self].
	eventSpec ifNil:[^self].
	1 to: eventSpec size by: 2 do:[:i|
		(eventSpec at: i) on: (eventSpec at: i+1) notify: self.
	].
	paused := false.
	receiver signal: #scriptStatusChanged with: selector with: #resumed! !

!ScriptMessageSend methodsFor: '*SqSquare-Core-accessing-override' stamp: 'minami 5/9/2006 16:38'!
terminateScript
	eventSpec ifNotNil:[
		1 to: eventSpec size by: 2 do:[:i|
			(eventSpec at: i) on: (eventSpec at: i+1) unNotify: self.
		].
		eventSpec := nil].
	receiver privateRemoveScript: self.
	receiver signal: #scriptStatusChanged with: selector with: #terminated.! !

!EToyScriptManager methodsFor: '*SqSquare-Core-lookup-override' stamp: 'mu 6/1/2006 16:09'!
lookup: aLookupSpec
	"Lookup object from aLookupSpec. See lookupSpecFor:"

	^registeredObjects at: aLookupSpec ifAbsent: [(SqLookupFailureWarning with: aLookupSpec) signal]
! !

!EToyScriptManager methodsFor: '*SqSquare-Core-registration' stamp: 'mu 5/16/2006 15:27'!
registerObject: obj at: lookupSpec
	^registeredObjects at: lookupSpec put: obj! !

!EToyScriptManager methodsFor: '*SqSquare-Core-lookup' stamp: 'MU 2/20/2006 17:06'!
uniClassAt: uniClassID 
	^ self allUniClassInstances
		detect: [:each | each class classVersionID = uniClassID]
		ifNone: []! !

AbInitializer subclass: #SqInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqInitializer class methodsFor: 'private' stamp: 'mu 3/27/2006 16:15'!
systemShutDown: quitting

	quitting ifFalse: [^ self].

	
! !

!SqInitializer class methodsFor: 'private' stamp: 'mu 5/24/2006 12:22'!
systemStartUp: resuming

	resuming ifFalse: [^ self].

	SqSettings configure.
	SqPlayerEventFactory initialize.

	SqExternalConnection purgeAll.
	SqSettings isClientOnly ifTrue: [SqUtil prepareForClient].
	SqSettings isServer ifTrue: [SqUtil prepareForServer].

	SqSettings isDevelopment ifTrue: [SqUtil initializeAfterLoad].

	
! !

!CCostume methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/6/2006 17:02'!
postBuildWith: aMaker
	"Now that the player is fully loaded, make sure we're initialized correctly"
	self autoStartScripts.
"	self setupCostume."
	"For now, call #makeDefaultCostume so that we keep compatibility"
		self makeDefaultCostume.
	self signalChanged: #playerChanged from: nil to: myPlayer.! !

!CCostume methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/6/2006 17:03'!
readFieldsFrom: deSerializer
	"By default, costumes only remember their player since they can be perfectly recreated after the player came back in. Note that the process is a little tricky since the player may not have been fully loaded yet and therefore we cannot initialize the receiver quite yet. This only happens in #postBuildWith: which is invoked once everything is loaded"
	myPlayer := deSerializer readField: #player ifAbsent:[myPlayer].
	myPlayer privateChangeCostumeTo: self.

	self initialize.
	transform := deSerializer readField: #transform ifAbsent:[transform].
	extent := deSerializer readField: #extent ifAbsent:[extent].

	myCostume := deSerializer readField: #costume ifAbsent:[myCostume].

! !

!CCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:50'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostume methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/6/2006 17:03'!
writeFieldsOn: aSerializer
	"By default, costumes only remember their player since they can be perfectly recreated after the player came back in"
	aSerializer writeField: #player value: player.
	aSerializer writeField: #transform value: transform.
	aSerializer writeField: #extent value: extent.

	aSerializer writeField: #costume value: myCostume.! !

!CCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:49'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CCostume subclass: #SqTabbedPanelCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqTabbedPanelCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="tabPane" toSet="tabPane:" changeEvent="tabPaneChanged">tabPane</field>
	<field toGet="contentHolder" toSet="contentHolder:" changeEvent="contentHolderChanged">contentHolder</field>
	<field toGet="activeContent" toSet="activeContent:" changeEvent="activeContentChanged">activeContent</field>
</fields>'!

!SqTabbedPanelCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:22'!
activeContent
	"Answer the activeContent of the receiver"
	<bewareOf: #activeContentChanged>
	^self propertyValueAt: #activeContent! !

!SqTabbedPanelCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:22'!
activeContent: aValue
	"Modify the receiver's activeContent"
	^self propertyValueAt: #activeContent put: aValue with: #activeContentChanged! !

!SqTabbedPanelCostume methodsFor: 'private' stamp: 'minami 3/17/2006 11:58'!
buildContentHolder
	| aHolder |
	aHolder := CPlayer new.

	aHolder hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aHolder color: self defaultContentHolderColor.


	^ aHolder
! !

!SqTabbedPanelCostume methodsFor: 'private' stamp: 'minami 3/17/2006 14:25'!
buildTabPane
	| aPane |
	aPane := CPlayer new.

	aPane hResizing: #shrinkWrap.
	aPane height: 20.
	aPane layout: CTableLayout new.
	aPane layout listDirection: #leftToRight.

	aPane color: self defaultTabPaneColor.

	^ aPane
! !

!SqTabbedPanelCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
contentHolder
	"Answer the contentHolder of the receiver"
	<bewareOf: #contentHolderChanged>
	^self propertyValueAt: #contentHolder! !

!SqTabbedPanelCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
contentHolder: aValue
	"Modify the receiver's contentHolder"
	^self propertyValueAt: #contentHolder put: aValue with: #contentHolderChanged! !

!SqTabbedPanelCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 11:25'!
defaultContentHolderColor
	^ Color lightGray! !

!SqTabbedPanelCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 14:56'!
defaultMenuPaneColor
	^ Color lightRed! !

!SqTabbedPanelCostume methodsFor: 'initialize' stamp: 'mu 4/20/2006 15:48'!
defaultPlayer
	^ SqTabbedPanel! !

!SqTabbedPanelCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 11:46'!
defaultTabPaneColor
	^ Color lightOrange! !

!SqTabbedPanelCostume methodsFor: 'initialize' stamp: 'minami 3/17/2006 14:52'!
initialize
	super initialize.

	self define: #contentHolder as: self buildContentHolder.
	self define: #tabPane as: self buildTabPane.! !

!SqTabbedPanelCostume methodsFor: 'events' stamp: 'minami 3/20/2006 11:22'!
onActiveContentChanged
	<on: activeContentChanged in: player>

	self activeContent == player activeContent ifTrue: [^ self].

	self activeContent ifNotNil: [
		self contentHolder remove: self activeContent.
	].
	self activeContent: player activeContent.
	self contentHolder addLast: self activeContent.! !

!SqTabbedPanelCostume methodsFor: 'events' stamp: 'minami 3/17/2006 12:47'!
onPlayerContentAdded: addedPlayer
	| aButton |
	<on: contentAdded in: player>

	aButton := SqTabButton new 
				content: addedPlayer;
				holder: player;
				label: addedPlayer title;
				yourself.
	self tabPane add: aButton! !

!SqTabbedPanelCostume methodsFor: 'initialize' stamp: 'minami 3/17/2006 14:28'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.
	self layout wrapDirection: #topToBottom.
	self layout listCentering: #leftToRight.

	self addLast: self tabPane.
	self addLast: self contentHolder.
! !

!SqTabbedPanelCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
tabPane
	"Answer the tabPane of the receiver"
	<bewareOf: #tabPaneChanged>
	^self propertyValueAt: #tabPane! !

!SqTabbedPanelCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 11:12'!
tabPane: aValue
	"Modify the receiver's tabPane"
	^self propertyValueAt: #tabPane put: aValue with: #tabPaneChanged! !

!CCostumeTextHolder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:52'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostumeTextHolder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:52'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CProjectMorph subclass: #SqProjectMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Project'!

!SqProjectMorph methodsFor: 'initialization' stamp: 'minami 1/20/2006 12:17'!
newProject: worldMaker
	| world |
	island := CProjectIsland new.
	island scheduler: (island new: ScriptScheduler).
	island project: (project := island new: SqEToysProject).
	world := island new: worldMaker.
	((worldMaker includesBehavior: CPanel) and:[world window == nil]) ifTrue:[
		world window: self.
	].
	project newProjectWith: world.
	self setExtentFromWorld.! !

!CEventBehavior methodsFor: '*SqSquare-Core-testing' stamp: 'mu 5/17/2006 17:15'!
isEventRecordBehavior
	^false! !

CEventBehavior subclass: #SqEventRecordBehavior
	instanceVariableNames: 'prevEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

SqEventRecordBehavior defineFields: '<?xml  version="1.0" ?>
<fields>
	<field serializable="false" toGet="board" toSet="board:" changeEvent="boardChanged" color="FFFF00">board</field>
	<field toGet="targetId" toSet="targetId:" changeEvent="targetIdChanged">targetId</field>
	<field instanceVariable="true" serializable="false" toGet="prevEvent" toSet="prevEvent:" color="FFFF00">prevEvent</field>
</fields>'!

!SqEventRecordBehavior methodsFor: 'initialize' stamp: 'mu 6/1/2006 19:23'!
attachTo: anObject
	super attachTo: anObject.
	self targetId: anObject playerId.
! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 12/16/2005 15:21'!
board
	"Answer the board of the receiver"
	<bewareOf: #boardChanged>
	^self propertyValueAt: #board! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 12/16/2005 15:21'!
board: aValue
	"Modify the receiver's board"
	^self propertyValueAt: #board put: aValue with: #boardChanged! !

!SqEventRecordBehavior methodsFor: 'testing' stamp: 'mu 3/16/2006 13:15'!
canOmitEventTyped: eventType
	prevEvent ifNil: [^false].
	^(prevEvent type == eventType
			and: [prevEvent millisecondsFromCurrent < SqSettings omitEventThreshold])
		! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/16/2006 13:15'!
client
	^ SqClient userId: self board userId! !

!SqEventRecordBehavior methodsFor: 'initialize' stamp: 'mu 6/1/2006 19:29'!
detach
	| key |
	key _ target userDataAt: #lookupSpec. 
	key notNil ifTrue: [
		self board ifNotNilDo: [:b | b unregister: target lookupKey: key].
	].
	super detach! !

!SqEventRecordBehavior methodsFor: 'testing' stamp: 'mu 5/29/2006 13:35'!
isEventRecordBehavior
	^true! !

!SqEventRecordBehavior methodsFor: 'events - polygon' stamp: 'minami 4/27/2006 12:40'!
onArrowStyleChanged
	<on: arrowStyleChanged in: target>

	self recordEvent: #polygonStateChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'minami 4/27/2006 12:32'!
onBorderChanged: aScriptEvent
	<on: borderChanged in: target>

	aScriptEvent isSignaledByTickMessage ifTrue: [^ self].
	self recordEvent: #borderChanged! !

!SqEventRecordBehavior methodsFor: 'events - polygon' stamp: 'minami 4/27/2006 12:40'!
onClosedChanged
	<on: closedChanged in: target>

	self recordEvent: #polygonStateChanged! !

!SqEventRecordBehavior methodsFor: 'events - drag and drop' stamp: 'minami 2/9/2006 12:02'!
onDragEnter: evt
	<on: dragEnter in: target>
	
	evt hand dragContents == self target ifFalse: [^ self].
	self recordEvent: #lock.
! !

!SqEventRecordBehavior methodsFor: 'events - drag and drop' stamp: 'minami 4/20/2006 17:12'!
onDragReject: evt
	<on: dropReject in: target>
	
	self recordEvent: #unlock.
! !

!SqEventRecordBehavior methodsFor: 'events - drag and drop' stamp: 'minami 5/26/2006 12:03'!
onDropAccept: aPlayer
	<on: dropAccept in: target>

	self recordEvent: #unlock.

	(aPlayer isBoard) ifTrue: [
		self recordEvent: #dropAccept.
		^ self
	].

	((aPlayer isComplexPlayer) and: [aPlayer hasPlayerId]) ifTrue: [
		self recordEvent: #dropAccept with: aPlayer.
		^ self.
	].

	self recordEvent: #playerRemoved.
	self target detachBoardProperties.! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'mu 5/23/2006 14:25'!
onFillChanged: aScriptEvent
	<on: fillChanged in: target>

	aScriptEvent isSignaledByTickMessage ifTrue: [^ self].
	(self canOmitEventTyped: #fillChanged) ifTrue: [^ self].

	self recordEvent: #fillChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'minami 4/27/2006 12:33'!
onFlagsChanged: aScriptEvent
	<on: flagsChanged in: target>

	aScriptEvent isSignaledByTickMessage ifTrue: [^ self].
	self recordEvent: #flagsChanged.
! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'mu 5/23/2006 12:12'!
onGeometryChanged: aScriptEvent
	<on: geometryChanged in: target >

	aScriptEvent isSignaledByTickMessage ifTrue: [^ self].
	(self canOmitEventTyped: #geometryChanged) ifTrue: [^ self].

	self recordEvent: #geometryChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'mu 5/23/2006 12:12'!
onGraphicChanged: aScriptEvent
	<on: graphicChanged in: target>

	aScriptEvent isSignaledByTickMessage ifTrue: [^ self].
	(self target wantsPropagateGraphicChanged) ifFalse: [^ self].
	(self canOmitEventTyped: #graphicChanged) ifTrue: [^ self].
	self recordEvent: #graphicChanged! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/7/2006 19:31'!
onHaloDismiss
	<on: haloDismiss in: target>

	self recordEvent: #unlock.
	self recordEvent: #playerRemoved.
	self target removePlayerId.
	self detach.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/14/2006 11:50'!
onHaloDrag
	<on: haloDrag in: target>
	self recordEvent: #lock.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/14/2006 11:54'!
onHaloDragFinished
	<on: haloDragFinished in: target>	
	self recordEvent: #unlock.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 5/19/2006 10:39'!
onHaloDup
	| newPlayer |
	<on: haloDup in: target>	
"
Transcript cr; show: self target hash printString.
Transcript cr; show: self target project halo target hash printString.
"

	newPlayer := self target project halo target.
	newPlayer detachBoardProperties.! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 2/14/2006 11:50'!
onHaloGrab
	<on: haloGrab in: target>
	self recordEvent: #lock.
! !

!SqEventRecordBehavior methodsFor: 'events - halo' stamp: 'minami 1/19/2006 17:01'!
onHaloGrabFinished
	<on: haloGrabFinished in: target>	
	self recordEvent: #unlock.
! !

!SqEventRecordBehavior methodsFor: 'events - button' stamp: 'minami 2/17/2006 15:02'!
onImageChanged
"
	<on: imageChanged in: target>
	self recordEvent: #imageChanged.
"! !

!SqEventRecordBehavior methodsFor: 'events - button' stamp: 'minami 5/17/2006 14:14'!
onLabelChanged
	<on: labelChanged in: target>
	self recordEvent: #labelChanged.
! !

!SqEventRecordBehavior methodsFor: 'events - polygon' stamp: 'mu 5/31/2006 15:45'!
onRemoteVerticesChanged
	<on: remoteVerticesChanged in: target>

	self recordEvent: #remoteVerticesChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'minami 4/27/2006 12:34'!
onRoundCornersChanged: aScriptEvent
	<on: roundCornersChanged in: target>

	aScriptEvent isSignaledByTickMessage ifTrue: [^ self].
	self recordEvent: #roundCornersChanged! !

!SqEventRecordBehavior methodsFor: 'events - other' stamp: 'mu 5/16/2006 14:54'!
onScriptModified: selectorSymbol
	| scriptSource statusSymbol |

	<on: scriptModified in: target>

	scriptSource := target class sourceCodeAt: selectorSymbol ifAbsent: [].
	statusSymbol := scriptSource ifNil: [#removed] ifNotNil: [#compiled].

	self 
		recordEvent: #scriptModified 
		withArguments: {selectorSymbol. statusSymbol. scriptSource. target}
	! !

!SqEventRecordBehavior methodsFor: 'events - other' stamp: 'mu 6/2/2006 17:29'!
onScriptStatusChanged: selectorSymbol with: statusSymbol
	| col |

	<on: scriptStatusChanged in: target>

	target ifNil: [^ self].

	col := target scriptors.
	(col isNil or: [col isEmpty]) ifTrue: [^ self].
	col detect: [:scriptorTile | scriptorTile selector == selectorSymbol] ifNone: [^ self].

	self recordEvent: #scriptStatusChanged with: selectorSymbol with: statusSymbol

	! !

!SqEventRecordBehavior methodsFor: 'events - polygon' stamp: 'minami 4/27/2006 12:40'!
onSmoothCurveChanged
	<on: smoothCurveChanged in: target>

	self recordEvent: #polygonStateChanged! !

!SqEventRecordBehavior methodsFor: 'events - aspect' stamp: 'mu 5/29/2006 15:48'!
onTextChanged: aScriptEvent
	<on: textChanged in: target>

	aScriptEvent isSignaledByTickMessage ifTrue: [^ self].
	(self target wantsPropagateTextChanged) ifFalse: [^ self].

	self recordEvent: #textChanged.
	! !

!SqEventRecordBehavior methodsFor: 'events - text editor' stamp: 'minami 5/17/2006 14:33'!
onTextEditorStatusChanged
	<on: textEditorStatusChanged in: target>
	self recordEvent: #textEditorStatusChanged.
! !

!SqEventRecordBehavior methodsFor: 'events - other' stamp: 'minami 4/5/2006 14:30'!
onUngroup
	<on: ungroup in: target>
	self recordEvent: #ungroup! !

!SqEventRecordBehavior methodsFor: 'events - other' stamp: 'minami 4/20/2006 17:10'!
onUnlock
	<on: unlock in: target>
	self recordEvent: #unlock! !

!SqEventRecordBehavior methodsFor: 'events - polygon' stamp: 'minami 4/27/2006 12:41'!
onVerticesChanged
	<on: verticesChanged in: target>

	self recordEvent: #verticesChanged! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/9/2006 11:24'!
prevEvent
	"Answer the prevEvent of the receiver"
	^prevEvent! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'mu 3/9/2006 11:24'!
prevEvent: aValue
	"Modify the receiver's prevEvent"
	prevEvent := aValue! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'mu 5/29/2006 15:28'!
recordEvent: evtSymbol 
	^self recordEvent: evtSymbol withArguments: #()! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'mu 5/31/2006 15:11'!
recordEvent: evtSymbol withArguments: args 
	| tar bo evt |

	bo _ self board ifNil: [^ self].
"	bo isRecording ifFalse: [^ self]."

	tar _ self target ifNil: [^ self].
	tar isRecording ifFalse: [^ self].
	tar wantsPropagateEvents ifFalse: [^ self].

	tar container ifNil: [^ self].
	((tar container == bo) 
		or: [tar container isComplexPlayer] 
		or:[{#playerRemoved. 
			#dropAccept. 
			#lock. 
			#unlock } includes: evtSymbol]) ifFalse: [^ self].

	evt := SqPlayerEventFactory
				createEvent: evtSymbol
				target: tar
				accessId: bo accessId
				args: args.

	bo recordEvent: evt.
	prevEvent _ evt setMillisecondsStamp.

	bo signal: #contentsChanged.

	^evt
! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'mu 5/29/2006 15:28'!
recordEvent: evtSymbol with: arg1
	^self recordEvent: evtSymbol withArguments: {arg1}! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'mu 5/29/2006 15:28'!
recordEvent: evtSymbol with: arg1 with: arg2
	^self recordEvent: evtSymbol withArguments: {arg1. arg2}! !

!SqEventRecordBehavior methodsFor: 'recording' stamp: 'mu 5/29/2006 15:28'!
recordEvent: evtSymbol with: arg1 with: arg2 with: arg3
	^self recordEvent: evtSymbol withArguments: {arg1. arg2. arg3}! !

!SqEventRecordBehavior methodsFor: 'initialize' stamp: 'mu 4/27/2006 11:23'!
release
	self detach.
	self destroy.
	board _ targetId _ nil.
	super release! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 2/27/2006 15:34'!
targetId
	"Answer the targetId of the receiver"
	<bewareOf: #targetIdChanged>
	^self propertyValueAt: #targetId! !

!SqEventRecordBehavior methodsFor: 'accessing' stamp: 'minami 3/17/2006 10:53'!
targetId: aValue
	"Modify the receiver's targetId"

	^self propertyValueAt: #targetId put: aValue with: #targetIdChanged! !

RmtConnector subclass: #SqConnector
	instanceVariableNames: 'accessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqConnector class methodsFor: 'instance creation' stamp: 'MU 1/20/2006 19:48'!
connect: ipAddressOrHost port: portNumber accessId: id
	| inst |
	inst _ self new.
	inst accessId: id.
	^inst connect: ipAddressOrHost port: portNumber 
	! !

!SqConnector class methodsFor: 'instance creation' stamp: 'mu 12/28/2005 18:57'!
with: connectedSocket
	^self new with: connectedSocket! !

!SqConnector methodsFor: 'accessing' stamp: 'MU 1/20/2006 19:39'!
accessId
	^accessId! !

!SqConnector methodsFor: 'accessing' stamp: 'MU 1/20/2006 19:39'!
accessId: id
	^accessId _ id! !

!SqConnector methodsFor: 'converting' stamp: 'mu 12/28/2005 20:11'!
asAcceptor
	^SqAcceptor with: self socket! !

!SqConnector methodsFor: 'factory' stamp: 'minami 1/12/2006 12:17'!
messageClass
	^SqMessage! !

!SqConnector methodsFor: 'sending' stamp: 'minami 1/13/2006 14:11'!
negotiate: aSqAccessId
	| msg msgData |
	msg _ self messageClass typed: #negotiate on: aSqAccessId encoder: #default.
	msgData _ msg rawData.
	self basicSendData: msgData.
	self flush.
	^nil
! !

!SqConnector methodsFor: 'private' stamp: 'MU 1/20/2006 19:52'!
onConnected
	self negotiate: self accessId.
	super onConnected! !

!SqConnector methodsFor: 'initialize-release' stamp: 'minami 1/12/2006 17:10'!
with: aSocket
	socketStream _ self createSocketStream: aSocket.
	self negotiate
		ifTrue: [self prepareHeartbeatProcess]
		ifFalse: [self close.
			RmtNetworkError signal: 'Negotiation failed' tagged: #negotiationFailed]! !

!CButton methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 2/17/2006 09:06'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.
	self loadProperties: #(label image) from: dic 
	! !

!CButton methodsFor: '*SqSquare-Core-load/save' stamp: 'MU 2/16/2006 16:43'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(label image) into: dic 
	! !

CButton subclass: #SqLinkTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Link'!

SqLinkTile defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="targetId" toSet="targetId:" changeEvent="targetIdChanged">targetId</field>
</fields>'!

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/17/2006 10:55'!
board
	| cont |
	cont := self eventRecordBoard.
	^ cont! !

!SqLinkTile methodsFor: 'initialize' stamp: 'MU 2/15/2006 14:41'!
initialize	
	super initialize.

	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.

	
	! !

!SqLinkTile methodsFor: 'actions' stamp: 'MU 2/17/2006 13:41'!
jump
	| moved |
	self board ifNil: [^ self].
	self board isBoard ifFalse: [^ self].
	moved := self board stepScrollToward: self target.
	moved
		ifTrue: [self target
				stopRecordingWhile: [self target flash.
					self target waitTick]]
		ifFalse: [self notifyBadLink]! !

!SqLinkTile methodsFor: 'load/save' stamp: 'MU 2/16/2006 17:04'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.
	self loadProperties: #(targetId) from: dic ! !

!SqLinkTile methodsFor: 'actions' stamp: 'MU 2/17/2006 13:39'!
notifyBadLink
	^self inform: 'bad link!!'! !

!SqLinkTile methodsFor: 'events' stamp: 'MU 2/15/2006 15:39'!
onFire
	"Fire this button"
	<on: fire>
	Beeper beep.
	self jump.! !

!SqLinkTile methodsFor: 'events' stamp: 'mu 3/10/2006 12:18'!
onGeometryChanged
	<on: geometryChanged in: value>
	self image: self target icon.

! !

!SqLinkTile methodsFor: 'events' stamp: 'minami 2/17/2006 14:54'!
onGraphicChanged
	<on: graphicChanged in: value>

	self image: self target icon.! !

!SqLinkTile methodsFor: 'events' stamp: 'MU 2/14/2006 15:42'!
onNameChanged
	<on: nameChanged in: value>

	self name: self target name.

! !

!SqLinkTile methodsFor: 'opening' stamp: 'MU 2/17/2006 13:22'!
openInHand
	super openInHand.
	self postOpen! !

!SqLinkTile methodsFor: 'opening' stamp: 'mu 6/2/2006 14:45'!
postOpen
	self borderColor: Color red.
	
	self label: self target name.
	self target isLabel ifFalse: [self image: self target icon].

	self balloonHelp: 'Link to: ', self target name.

	Beeper beep.

	! !

!SqLinkTile methodsFor: 'private' stamp: 'mu 5/17/2006 13:49'!
retrieveTarget
	
	^value _ self board findPlayerByUid: self targetId! !

!SqLinkTile methodsFor: 'load/save' stamp: 'MU 2/16/2006 16:57'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.
	self saveProperties: #(targetId) into: dic ! !

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/16/2006 17:03'!
target
	value ifNil: [self retrieveTarget].
	^value! !

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/15/2006 15:02'!
targetId
	"Answer the targetId of the receiver"
	<bewareOf: #targetIdChanged>
	^self propertyValueAt: #targetId! !

!SqLinkTile methodsFor: 'accessing' stamp: 'MU 2/15/2006 15:02'!
targetId: aValue
	"Modify the receiver's targetId"
	^self propertyValueAt: #targetId put: aValue with: #targetIdChanged! !

!SqLinkTile methodsFor: 'testing' stamp: 'mu 3/16/2006 10:17'!
wantsPropagateGraphicChanged
	^false! !

!SqLinkTile methodsFor: 'testing' stamp: 'mu 3/16/2006 10:16'!
wantsPropagateTextChanged
	^false! !

!SqLinkTile methodsFor: 'serializing' stamp: 'MU 2/15/2006 15:08'!
writeFieldsOn: aSerializer
	value _ nil.
	super writeFieldsOn: aSerializer! !

!SqLinkTile methodsFor: 'serializing' stamp: 'mu 3/7/2006 12:10'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CButton subclass: #SqTabButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Widget'!

SqTabButton defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="content" toSet="content:" changeEvent="contentChanged">content</field>
	<field toGet="holder" toSet="holder:" changeEvent="holderChanged">holder</field>
</fields>'!

!SqTabButton methodsFor: 'menu' stamp: 'minami 5/17/2006 15:17'!
addMenuOn: aMenu! !

!SqTabButton methodsFor: 'menu' stamp: 'minami 5/17/2006 15:17'!
buildMenu
	| aMenu |
	aMenu := CMenu new.
	self addMenuOn: aMenu.
	^aMenu ! !

!SqTabButton methodsFor: 'initialize' stamp: 'mu 4/4/2006 17:17'!
close
	content _ holder _ nil.
	super close.! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:09'!
content
	"Answer the content of the receiver"
	<bewareOf: #contentChanged>
	^self propertyValueAt: #content! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:09'!
content: aValue
	"Modify the receiver's content"
	^self propertyValueAt: #content put: aValue with: #contentChanged! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:20'!
holder
	"Answer the holder of the receiver"
	<bewareOf: #holderChanged>
	^self propertyValueAt: #holder! !

!SqTabButton methodsFor: 'accessing' stamp: 'minami 3/17/2006 12:20'!
holder: aValue
	"Modify the receiver's holder"
	^self propertyValueAt: #holder put: aValue with: #holderChanged! !

!SqTabButton methodsFor: 'events' stamp: 'minami 3/22/2006 20:18'!
onFired
	<on: fire>

	self holder setActiveContent: self content.
! !

!SqTabButton methodsFor: 'events' stamp: 'minami 5/17/2006 15:14'!
onYellowButtonUp
	| aMenu |
	<on: yellowButtonUp>

	aMenu := self buildMenu.
	aMenu menuItems isEmpty ifTrue: [^ self].
	aMenu open! !

!SqTabButton methodsFor: 'initialize' stamp: 'mu 4/4/2006 17:17'!
release
	self close.! !

!SqTabButton methodsFor: 'private' stamp: 'minami 3/22/2006 19:49'!
setActiveState
	self color: Color white darker.
	self borderColor: Color red.
	self borderWidth: 3.	! !

!SqTabButton methodsFor: 'private' stamp: 'minami 3/22/2006 19:49'!
setNormalState
	self color: Color veryLightGray.
	self borderColor: Color transparent.
	self borderWidth: 1.
	! !

!SqTabButton methodsFor: 'initialize' stamp: 'minami 3/22/2006 19:47'!
setupCostume
	super setupCostume.

	self setNormalState.! !

!CLayoutPolicy methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:56'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

RmtBasicMessage subclass: #SqMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

SqMessage class
	instanceVariableNames: 'encoderNumberArray typeNumberArray'!

!SqMessage class methodsFor: 'accessing' stamp: 'mu 5/21/2006 22:25'!
encoderNumberArray
	encoderNumberArray ifNil: [encoderNumberArray _ super encoderNumberArray , {#compactBytes}].
	^encoderNumberArray! !

!SqMessage class methodsFor: 'class initialization' stamp: 'mu 5/21/2006 22:25'!
initialize
	super initialize.
	typeNumberArray _ nil.
	encoderNumberArray _ nil! !

!SqMessage class methodsFor: 'encoding/decoding' stamp: 'mu 5/21/2006 22:19'!
stream: anObject by: encoder
	encoder == #compactBytes ifTrue: [^anObject asCompactBytes].
	^super stream: anObject by: encoder! !

!SqMessage class methodsFor: 'accessing' stamp: 'minami 1/18/2006 15:53'!
typeNumberArray
	"SqMessage typeNumberArray"
	typeNumberArray ifNil: [typeNumberArray _ super typeNumberArray , {#negotiate}].
	^typeNumberArray! !

!SqMessage class methodsFor: 'encoding/decoding' stamp: 'mu 5/21/2006 22:08'!
unstream: bytes by: encoder
	encoder == #compactBytes ifTrue: [^SqEvent fromCompactBytes: bytes].
	^super unstream: bytes by: encoder! !

EToysProject subclass: #SqEToysProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Project'!

SqEToysProject defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqEToysProject methodsFor: 'initialize' stamp: 'minami 3/9/2006 10:51'!
initialize
	super initialize.
	halo userDraw: true.
	halo visible: false.! !

!SqEToysProject methodsFor: 'initialize' stamp: 'minami 2/16/2006 08:34'!
newProject
true ifTrue: [^ super newProject].
	^self newProjectWith: SqEventRecordBoard new.! !

!String methodsFor: '*SqSquare-Core-converting' stamp: 'mu 5/9/2006 13:12'!
asSqUid
	^SqUid fromString: self! !

!String methodsFor: '*SqSquare-Core-converting' stamp: 'mu 5/9/2006 14:46'!
asUUID
	"Obsolete"
	self deprecated: 'use SqUid'.

	^UUID fromString: self! !

!String methodsFor: '*SqSquare-Core' stamp: 'mu 4/14/2006 11:53'!
translated0
	"just a flag to write translation file later"
	^self translated! !

AbUtil subclass: #SqUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

SqUtil class
	instanceVariableNames: 'changerBytes'!

!SqUtil class methodsFor: 'logging' stamp: 'MU 1/31/2006 19:06'!
basicLogError: anError 
	| file |
	[file := FileStream forceNewFileNamed: (anError class name, '.' , self shortImageName , '.' , Time primMillisecondClock asString , '.' , anError identityHash asString , '.log') asFileName.
	Smalltalk timeStamp: file.
	file cr; nextPutAll: anError description asString.
	(thisContext sender sender sender stackOfSize: 30)
		do: [:ctx | 
			file cr.
			ctx printOn: file]]
		ensure: [file
				ifNotNil: [file close]]! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:56'!
byteArrayFromObject: anObject 
"
	SqUtil byteArrayFromObject: #(1 3 5) 
		>> a ByteArray(8 0 0 0 3 4 0 0 0 1 4 0 0 0 3 4 0 0 0 5)
"

	| refStream |
	refStream := ReferenceStream on: (RWBinaryOrTextStream on: (ByteArray new: 4000)).
	refStream nextPut: anObject.
	^ refStream byteStream contents.! !

!SqUtil class methodsFor: 'developing' stamp: 'mu 4/27/2006 11:50'!
clearDanglingBoardCompositePanels
	"SqUtil clearDanglingBoardCompositePanels"

	"You should think why those instances remain"

	SqBoardCompositePanel allInstances do: [:e | e destroy]! !

!SqUtil class methodsFor: 'cursor' stamp: 'mu 5/15/2006 15:36'!
cursorFormWithInitials: initialsString color: corsorColor form: originalCursor
	| canvas form |

	self flag: #TODO. "Forms should be cached for performance"

	canvas _ FormCanvas extent: 80@80 depth: Display depth. "assuming max cursor size 80x80"
	canvas drawImage: originalCursor at: 0@0.
	canvas drawString: initialsString at: 0@20.
	form _ canvas form replaceColor: Color black withColor: corsorColor; yourself.
	form _ form replaceColor: Color white withColor: Color transparent; yourself.
	form _ form contentsOfColor.
	form offset: originalCursor offset.
	^ form! !

!SqUtil class methodsFor: 'cursor' stamp: 'mu 5/8/2006 16:54'!
cursorOfName: aSymbol
	((CCursorLibrary class organization listAtCategoryNamed: 'cursors') includes: aSymbol) ifTrue: [
		^ CCursorLibrary perform: aSymbol
	].

	((Cursor class organization listAtCategoryNamed: 'constants') includes: aSymbol) ifTrue: [
		^ Cursor perform: aSymbol
	].

	^ Cursor normal! !

!SqUtil class methodsFor: 'defining fields' stamp: 'mu 6/1/2006 11:53'!
defineExtraFieldsToSystemClasses
	"SqUtil defineExtraFieldsToSystemClasses"

	self defineExtraFields: #('playerId' 'frozen' 'recording' 'boardLookupScope') to: CPlayer.
	
	self addInstanceVariableNamed: 'signaler' to: #ScriptEvent.
	self addInstanceVariableNamed: 'signaler' to: #TScriptEvent.

	self defineExtraFields: #('handles') to: CPolygonPlayer.
	CPolygonPlayer compileAll.

 
	self defineExtraInstanceVariables: #('userProfile' 'baloonTarget') to: CHandPlayer.
	self defineExtraFields: #('showHardwareCursor') to: CHandPlayer.

	CHandPlayer compile: 'showHardwareCursor
	<bewareOf: #showHardwareCursorChanged>
	^self propertyValueAt: #showHardwareCursor ifAbsent: [false]
		' classified: 'accessing'  
	! !

!SqUtil class methodsFor: 'defining fields' stamp: 'MU 2/9/2006 12:02'!
defineExtraFields: fields to: aClass 
	| existingFields |
	existingFields := aClass classFields
				collect: [:e | e name].
	fields
		do: [:each | (existingFields includes: each)
				ifFalse: [aClass addField: each]]! !

!SqUtil class methodsFor: 'defining fields' stamp: 'mu 5/10/2006 16:21'!
defineExtraInstanceVariables: fields to: aClass 
	| existingFields |
	existingFields := aClass classFields
				collect: [:e | e name].
	fields
		do: [:each | (existingFields includes: each)
				ifFalse: [| field | 
					field := CFieldDefinition new.
					field name: each asSymbol.
					field beInstanceVariable.
					aClass addField: field]]! !

!SqUtil class methodsFor: 'bounds' stamp: 'minami 3/30/2006 04:15'!
ellipseBoundsFromUser
" 
	SqUtil ellipseBoundsFromUser
"
	| originRect gridPoint |
	gridPoint := 1 @ 1.
	originRect := Cursor origin showWhile: [
		((Sensor cursorPoint grid: gridPoint) extent: 0 @ 0)
			newRectFrom: [:f | (Sensor cursorPoint grid: gridPoint) extent: 0 @ 0]].

	^ Cursor corner showWhile: [
		| delay rect buttonStart buttonNow originForm newRect |
		delay := Delay forMilliseconds: 10.
		buttonStart := buttonNow := Sensor anyButtonPressed.
		rect := originRect.
		originForm := Form fromDisplay: ActiveWorld bounds.
		
		[buttonNow == buttonStart] whileTrue: [
			delay wait.
			buttonNow := Sensor anyButtonPressed.
			newRect := rect origin corner: (Sensor cursorPoint grid: gridPoint).
			newRect = rect ifFalse: [
				originForm display.
				Display getCanvas
							fillOval: newRect
							color: Color transparent
							borderWidth: 2
							borderColor: Color gray.
							rect := newRect
			].
		].
		originForm display.

		"pay the price for reading the sensor directly ; get this party started "
		Smalltalk isMorphic ifTrue: [
			World activeHand
						newMouseFocus: nil;
					 	showTemporaryCursor: nil;
			 			flushEvents.
		].
		Sensor processEvent: Sensor createMouseEvent.
		rect.
	].! !

!SqUtil class methodsFor: 'logging' stamp: 'MU 2/7/2006 18:42'!
excludeErrorBlock
	^[:err |
		err name = #RmtNetworkError and: [err tag = #connectFailed]
	]! !

!SqUtil class methodsFor: 'class initialization' stamp: 'MU 2/9/2006 11:50'!
initialize
	self initializeAfterLoad! !

!SqUtil class methodsFor: 'class initialization' stamp: 'mu 5/24/2006 12:18'!
initializeAfterLoad
	"SqUtil initializeAfterLoad"
	changerBytes _ #() asByteArray.

	self defineExtraFieldsToSystemClasses.

	SqToolBar initialize.
	CCursorLibrary initialize.	"hack??"

	! !

!SqUtil class methodsFor: 'bounds' stamp: 'minami 3/30/2006 04:15'!
lineBoundsFromUser
" 
	SqUtil lineBoundsFromUser
"
	| originRect gridPoint |
	gridPoint := 1 @ 1.
	originRect := Cursor crossHair showWhile: [
		((Sensor cursorPoint grid: gridPoint) extent: 0 @ 0)
			newRectFrom: [:f | (Sensor cursorPoint grid: gridPoint) extent: 0 @ 0]].

	^ Cursor crossHair showWhile: [
		| delay rect buttonStart buttonNow originForm newRect |
		delay := Delay forMilliseconds: 10.
		buttonStart := buttonNow := Sensor anyButtonPressed.
		rect := originRect.
		originForm := Form fromDisplay: ActiveWorld bounds.
		
		[buttonNow == buttonStart] whileTrue: [
			delay wait.
			buttonNow := Sensor anyButtonPressed.
			newRect := rect origin corner: (Sensor cursorPoint grid: gridPoint).
			newRect = rect ifFalse: [
				originForm display.
				Display getCanvas
							line: newRect origin
							to: newRect corner
							width: 2
							color: Color gray.
							rect := newRect
			].
		].
		originForm display.

		"pay the price for reading the sensor directly ; get this party started "
		Smalltalk isMorphic ifTrue: [
			World activeHand
						newMouseFocus: nil;
					 	showTemporaryCursor: nil;
			 			flushEvents.
		].
		Sensor processEvent: Sensor createMouseEvent.
		rect.
	].! !

!SqUtil class methodsFor: 'logging' stamp: 'MU 2/7/2006 18:41'!
logError: anError 
	SqSettings isDebugging ifFalse: [^ self].
	(self excludeErrorBlock value: anError) ifTrue: [^self].
	[self basicLogError: anError]
		on: Error
		do: [:ex | self basicLogError: ex]! !

!SqUtil class methodsFor: 'cursor' stamp: 'mu 5/8/2006 16:23'!
nameOfCursor: aCursor

	(Cursor class organization listAtCategoryNamed: 'constants') do: [:selector |
		(Cursor perform: selector) = aCursor ifTrue: [^ selector].
	].

	(CCursorLibrary class organization listAtCategoryNamed: 'cursors') do: [:selector |
		(CCursorLibrary perform: selector) = aCursor ifTrue: [^ selector].
	].

	^ #unknown! !

!SqUtil class methodsFor: 'pen' stamp: 'minami 3/30/2006 15:27'!
newFromPenColor: lineColor width: lineWidth

"
	| p |
	p := SqUtil newFromPenColor: Color red width: 4.
	p openInHand.
"
	| aPen locuses lastPoint locus players group |
	aPen := Pen new.
	aPen color: 0.
	locuses := OrderedCollection new.
	lastPoint := nil.
	locus := nil.

	Cursor marker showWhile: [
		[Sensor yellowButtonPressed] whileFalse: [
			aPen place: Sensor cursorPoint.
			locus isNil ifTrue: [locus := OrderedCollection new: 100].

			[Sensor redButtonPressed] whileTrue: [
				| cursorPoint |
				cursorPoint := Sensor cursorPoint.
				aPen goto: cursorPoint.
				(lastPoint isNil or: [(lastPoint dist: cursorPoint) > 3]) 
					ifTrue: [locus add: cursorPoint].
				lastPoint := cursorPoint.
			].

			locus isEmptyOrNil ifFalse: [
				locuses add: locus.
				locus := nil.
			].
		].
	].
	Sensor waitNoButton.
	Display restore.

	players := OrderedCollection new: locuses size.
	locuses do: [:eachLocus |
		| pp |
		pp := CPolygonPlayer new  
				vertices: eachLocus;
				color: lineColor;
				borderWidth: lineWidth;
				closed: false;
				yourself.
		players add: pp.
	].

	"(players size = 1) ifTrue: [^ players first]."

	group := SqPolygonGroupingPlayer new 
				color: Color transparent; 
				lineColor: lineColor;
				lineWidth: lineWidth;
				yourself.
	group addPlayers: players.
	
	^ group

! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:56'!
objectFromByteArray: aByteArray
"
	SqUtil objectFromByteArray: #(8 0 0 0 3 4 0 0 0 1 4 0 0 0 3 4 0 0 0 5) asByteArray
		>> #(1 3 5)
"

	| anObject refStream |
	refStream := ReferenceStream on: (RWBinaryOrTextStream with: aByteArray) reset.
	anObject := refStream next.
	refStream close.
	^ anObject! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:39'!
objectFromString: aString
"
	SqUtil objectFromString: 'CAAAAAMEAAAAAQQAAAADBAAAAAU='
		>> #(1 3 5)
"

	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := ReferenceStream on: byteStr.
	^oStr next! !

!SqUtil class methodsFor: 'start up/shut down' stamp: 'mu 6/5/2006 13:20'!
prepareForBrowserPlugin
	"SqUtil prepareForBrowserPlugin"

	self prepareForClient.

	(ActiveWorld allMorphs select: [:each | each isKindOf: SystemWindow]) do: [:each | each delete].

	DisplayScreen depth: 16 width: 800 height: 600 fullscreen: false.

	Preferences setPreference: #automaticWorldMenu toValue: false. 
	Preferences setPreference: #warnIfNoChangesFile toValue: false.
	Preferences setPreference: #warnIfNoSourcesFile toValue: false.

	SmalltalkImage current saveAsBrowserPlugin! !

!SqUtil class methodsFor: 'start up/shut down' stamp: 'mu 5/26/2006 16:02'!
prepareForClient
	"SqUtil prepareForClient"
	"shutdown any server related objects"

	Smalltalk at: #SqSnapshotDaemon ifPresent:[:p | p default stop].
	Smalltalk at: #SqBoardThumbnailCache ifPresent:[:p | p default stop].
	Smalltalk at: #SqConnectionTrimmer ifPresent:[:p | p default stop].

	Smalltalk at: #SqServer ifPresent:[:p | p default stop].
	Smalltalk at: #SqRpcDispatcher ifPresent:[:p | p stop].

	Smalltalk at: #SqClient ifPresent:[:p | p closeAll].

	Smalltalk at: #ElServer ifPresent:[:p | p stopAll].

	Smalltalk at: #SqAudioChatServerFacade ifPresent:[:p | p default stop].
	Smalltalk at: #SqAudioChatMaintainer ifPresent:[:p | p default stop].

	Smalltalk at: #SqServicePublisher ifPresent:[:p | p stopPublish].
 
! !

!SqUtil class methodsFor: 'start up/shut down' stamp: 'mu 5/26/2006 16:21'!
prepareForServer
	"SqUtil prepareForServer"
	"start any server related objects"

	Smalltalk at: #SqSquareDB ifPresent:[:p | p createDb].

	Smalltalk at: #SqSnapshotDaemon ifPresent:[:p | p default start].
	Smalltalk at: #SqBoardThumbnailCache ifPresent:[:p | p default initialize; start].
	Smalltalk at: #SqConnectionTrimmer ifPresent:[:p | p default start].

	Smalltalk at: #SqServer ifPresent:[:p | 
			p default bootstrapAll; start
	].
	
	Smalltalk at: #SqRpcDispatcher ifPresent:[:p | p start].

	Smalltalk at: #SqAudioChatServerFacade ifPresent:[:p | p default start].
	Smalltalk at: #SqAudioChatMaintainer ifPresent:[:p | p default start].

	Smalltalk at: #SqServicePublisher ifPresent:[:p | p startPublish].	


	! !

!SqUtil class methodsFor: 'bounds' stamp: 'minami 3/30/2006 04:16'!
rectangleBoundsFromUser
"
	SqUtil rectangleBoundsFromUser
"
	^ Rectangle fromUser! !

!SqUtil class methodsFor: 'events' stamp: 'mu 4/6/2006 15:22'!
renumber: eventCollection from: fromIndex 
	1
		to: eventCollection size
		do: [:idx | 
			| ev | 
			ev := eventCollection at: idx.
			ev eventId: fromIndex + idx].
	^ eventCollection! !

!SqUtil class methodsFor: 'extent' stamp: 'minami 2/23/2006 11:50'!
smallFormExtent: aPlayer
	^ self smallFormExtent: aPlayer reduction: 3! !

!SqUtil class methodsFor: 'extent' stamp: 'minami 2/23/2006 11:50'!
smallFormExtent: aPlayer reduction: anInteger
	^ (aPlayer extent // anInteger) asIntegerPoint.! !

!SqUtil class methodsFor: 'start up/shut down' stamp: 'mu 4/21/2006 16:35'!
startWebServer
	KomSeasideJ startOn: 9092.
	! !

!SqUtil class methodsFor: 'serialize/deserialize' stamp: 'minami 7/27/2005 01:38'!
stringFromObject: anObject 
"
	SqUtil stringFromObject: #(1 3 5)
		>> 'CAAAAAMEAAAAAQQAAAADBAAAAAU='
"

	| file con |
	file := RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	file binary.
	(ReferenceStream on: file)
		nextPut: anObject.
	con := Base64MimeConverter mimeEncode: file reset.
	file close.
	^ con contents! !

!SqUtil class methodsFor: 'developing' stamp: 'mu 4/27/2006 11:33'!
terminateScriptProcesses
	"SqUtil terminateScriptProcesses"
	ScriptProcess allInstances do: [:e | e terminate]! !

!SqUtil class methodsFor: 'thumbnail' stamp: 'mu 6/6/2006 08:10'!
thumbnailOf: aPlayer
	| form |
	form _ aPlayer makeIcon: ((aPlayer extent min: (800@600)) // 5).
	^form
	! !

!SqUtil class methodsFor: 'thumbnail' stamp: 'mu 6/2/2006 09:51'!
thumbnailPNGFileFromForm: aForm
	| form str bytes file |
	form _ aForm.
	form ifNil: [^nil].
	str _ (RWBinaryOrTextStream on: (ByteArray new: 2048)).
	PNGReadWriter putForm: form onStream: str.
	bytes _ str contents.
	
	file _ WAFile new.
	file contents: bytes.
	file contentType: 'image/png'.
	^file
	! !

!SqUtil class methodsFor: 'thumbnail' stamp: 'mu 6/6/2006 13:04'!
thumbnailPNGFileOf: aPlayer
	| form |
	form _ self thumbnailOf: aPlayer.
	^self thumbnailPNGFileFromForm: form
	! !

!SqUtil class methodsFor: 'changing class' stamp: 'mu 3/13/2006 14:49'!
toByteArray: aByteArraySubInstance
	
	^aByteArraySubInstance primitiveChangeClassTo: changerBytes! !

!CObjectMaker methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 1/19/2006 16:50'!
parts: aCollection
	parts _ aCollection! !

CObjectMaker subclass: #SqPlayerMaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqPlayerMaker class methodsFor: 'actions' stamp: 'mu 5/17/2006 14:51'!
fromParts: parts
	| maker |
	maker _ self new parts: parts.
	^maker next.! !

!SqPlayerMaker methodsFor: 'private-defaults' stamp: 'mu 3/2/2006 16:04'!
newDeserializer
	^SqPlayerDeserializer new! !

!CTextEditor methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:38'!
loadOnPlayerCreatedFrom: dic withArgs: args
	super loadOnPlayerCreatedFrom: dic withArgs: args.

	self loadProperties: #(#allowEditing) from: dic ! !

!CTextEditor methodsFor: '*SqSquare-Core-events-override' stamp: 'minami 5/17/2006 14:25'!
onAllowEditingChanged
	| scripts |
	<on: allowEditingChanged>
	scripts := #(
		onMouseDown: onMouseMove: onMouseUp:
		onKeyboardFocusEnter
		onKeyDown: onKeyStroke:
		onMouseEnter onMouseLeave
	).
	scripts do:[:each|
		allowEditing 
			ifTrue:[self resumeScript: each]
			ifFalse:[self pauseScript: each]].
	self setTextCursor.

	self signal: #textEditorStatusChanged with: #allowEditing! !

!CTextEditor methodsFor: '*SqSquare-Core-load/save' stamp: 'minami 5/17/2006 14:39'!
saveOnPlayerCreatedInto: dic withArgs: args
	super saveOnPlayerCreatedInto: dic withArgs: args.

	self saveProperties: #(#allowEditing) into: dic 
	! !

AbSettings subclass: #SqSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:25'!
audioChatPort
	^ self 
		at: #audioChatPort
		ifAbsentPut: [10002]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:25'!
audioChatServerHost
	^ self 
		at: #audioChatServerHost
		ifAbsentPut: ['localhost']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
audioChatServerHost: hostOrIP
	"SqSettings audioChatServerHost: 'qwerty'"
	^ self at: #audioChatServerHost put: hostOrIP asString! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
audioCommandPort
	^ self 
		at: #audioChatCommand
		ifAbsentPut: [10001]! !

!SqSettings class methodsFor: 'setting access' stamp: 'minami 1/16/2006 16:26'!
compressThreshold 
	^ 1024! !

!SqSettings class methodsFor: 'private' stamp: 'minami 6/8/2006 15:23'!
createConfiguration

	| config fs |
	config := '
serverHost=127.0.0.1
audioChatServerHost=127.0.0.1
isDebugging=true
isServer=false
isClientOnly=true
playerSerializer=NotODF.
showCursors=true
'.

	[
		fs := FileDirectory default forceNewFileNamed: self defaultConfigurationFilename.
		fs nextPutAll: config.
	] ensure: [fs close]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 6/8/2006 08:25'!
defaultBoardExtent
	^ self 
		at: #defaultBoardExtent
		ifAbsentPut: [1024 @ 768]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 6/8/2006 08:25'!
defaultBoardExtent: extent
	"SqSettings defaultBoardExtent: 1024@768"
	^ self at: #defaultBoardExtent put: extent! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
eventListenPort
	^ self
		at: #eventListenPort
		ifAbsentPut: [8484]! !

!SqSettings class methodsFor: 'class initialization' stamp: 'mu 3/27/2006 16:54'!
initialize
	super initialize.

	(FileDirectory default fileExists: self defaultConfigurationFilename) ifFalse: [
		self createConfiguration.
	].! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 4/24/2006 17:42'!
isBrowserPlugin
	^ self
		at: #isBrowserPlugin
		ifAbsentPut: [false]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 4/24/2006 17:42'!
isBrowserPlugin: aBoolean
	^ self at: #isBrowserPlugin put: aBoolean == true! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 5/24/2006 12:25'!
isClientOnly
	"
	SqSettings isClientOnly
	"
	"self isDeployment ifTrue: [^ (Smalltalk includesKey: #SqServer) not]."


	"for developing"
	^ self
		at: #isClientOnly
		ifAbsentPut: [true]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:26'!
isClientOnly: aBoolean
"
	SqSettings isClientOnly: true.
	SqSettings isClientOnly: false
"

	self deprecated: 'isClient is set automatically'.

	^ self at: #isClientOnly put: aBoolean! !

!SqSettings class methodsFor: 'setting access' stamp: 'minami 6/9/2006 14:30'!
isDebugging
"
	SqSettings isDebugging
"

	^ self
		at: #isDebugging
		ifAbsentPut: [false]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:45'!
isDebugging: aBoolean
"
	SqSettings isDebugging: false
"
	SqDebug isDebugging: aBoolean.

	^ self at: #isDebugging put: aBoolean! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 5/24/2006 12:22'!
isDeployment
"
	SqSettings isDeployment
"

	^self isDevelopment not! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 5/24/2006 12:22'!
isDevelopment

	^(Preferences warnIfNoChangesFile and: [Preferences warnIfNoSourcesFile])


! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 4/19/2006 11:36'!
isServer
"
	SqSettings isServer
"

	^ self
		at: #isServer
		ifAbsentPut: [false]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
isServer: aBoolean
"
	SqSettings isServer: false
"

	^ self at: #isServer put: aBoolean! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 4/7/2006 15:11'!
oldSnapshotsNumber
	
"
	SqSettings oldSnapshotsNumber
"
	^ self
		at: #oldSnapshotsNumber
		ifAbsentPut: [10]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 4/7/2006 15:13'!
oldSnapshotsNumber: number
"
	SqSettings oldSnapshotsNumber: 60
"

	^ self at: #oldSnapshotsNumber put: (number max: 3)! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
omitEventThreshold
	"recommends 30-100"
"
	SqSettings omitEventThreshold
"

	^ self
		at: #omitEventThreshold
		ifAbsentPut: [60]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
omitEventThreshold: milliseconds
"
	SqSettings omitEventThreshold: 60
"

	^ self at: #omitEventThreshold put: milliseconds! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
playerSerializer
	^ self
		at: #playerSerializer
		ifAbsentPut: [#default "#ODF"]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
playerSerializer: aSymbol
"
	SqSettings playerSerializer: #ODF.
	SqSettings playerSerializer: #NotODF.
"

	^ self at: #playerSerializer put: aSymbol! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
rpcListenPort
	^ self
		at: #rpcListenPort
		ifAbsentPut: [8483]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
serverHost
	^ self
		at: #serverHost
		ifAbsentPut: ['localhost']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
serverHost: hostOrIP
	"SqSettings serverHost: 'qwerty'"
	^ self at: #serverHost put: hostOrIP asString! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 6/8/2006 08:25'!
showCursors
	^ self
		at: #showCursors
		ifAbsentPut: [true]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 4/26/2006 16:42'!
showCursors: aBoolean
	^ self at: #showCursors put: aBoolean == true! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
showReleaseNotes
	^ self
		at: #showReleaseNotes
		ifAbsentPut: [true]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
showReleaseNotes: aBoolean
	^ self at: #showReleaseNotes put: aBoolean! !

!SqSettings class methodsFor: 'accessing' stamp: 'MU 2/6/2006 16:47'!
snapshotDirectory
	| dir |
	dir _ FileDirectory default directoryNamed: self snapshotDirectoryName.
	dir assureExistence.
	^dir! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
snapshotDirectoryName
	^ self
		at: #snapshotDirectoryName
		ifAbsentPut: ['board snapshots']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
snapshotDirectoryName: aString
	^ self
		at: #snapshotDirectoryName
		put: aString! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 4/21/2006 16:19'!
useDiscovery
	^ self
		at: #useDiscovery
		ifAbsentPut: [false]! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/31/2006 11:40'!
useDiscovery: aBoolean
	^ self at: #useDiscovery put: aBoolean == true! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
userId
	^ self
		at: #userId
		ifAbsentPut: ['test']! !

!SqSettings class methodsFor: 'setting access' stamp: 'mu 3/27/2006 17:27'!
userId: aString
	^ self at: #userId put: aString asString! !

Warning subclass: #SqLookupFailureWarning
	instanceVariableNames: 'lookupSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Util'!

!SqLookupFailureWarning class methodsFor: 'instance creation' stamp: 'mu 6/1/2006 15:57'!
with: lookupSpec
	^self new lookupSpec: lookupSpec! !

!SqLookupFailureWarning methodsFor: 'exceptionDescription' stamp: 'mu 6/2/2006 14:00'!
defaultAction
	self description displayForDebug: 20.
	^CPlayer new name: 'aPlayer (not me!!) lookup is ', self lookupSpec asString; yourself! !

!SqLookupFailureWarning methodsFor: 'exceptionDescription' stamp: 'mu 6/1/2006 16:04'!
description
	^super description, ' lookupSpec: ', self lookupSpec asString! !

!SqLookupFailureWarning methodsFor: 'accessing' stamp: 'mu 6/1/2006 15:56'!
lookupSpec
	^lookupSpec! !

!SqLookupFailureWarning methodsFor: 'accessing' stamp: 'mu 6/1/2006 15:56'!
lookupSpec: spec
	lookupSpec _ spec! !

Warning subclass: #SqWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Exceptions'!

!SqWarning class methodsFor: 'actions' stamp: 'MU 1/31/2006 19:05'!
warnLog: aMessage
	"SqWarning warnLog: 'this is a test'"
	[self signal: aMessage] on: Exception do: [:ex | ex log]! !

AbDebug subclass: #SqDebug
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqDebug class methodsFor: 'accessing' stamp: 'mu 3/27/2006 17:44'!
isDebugging: aBoolean
	aBoolean ifTrue: [AbDebug current: SqDebug] ifFalse: [AbDebug current: nil].
	super isDebugging: aBoolean! !

ODFEtoysReferences subclass: #SqEtoysReferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

SqEtoysReferences class
	instanceVariableNames: 'default'!

!SqEtoysReferences class methodsFor: 'instance creation' stamp: 'mu 5/16/2006 15:56'!
default
	^default ifNil: [default _ self new]! !

!SqEtoysReferences class methodsFor: 'class initialization' stamp: 'mu 5/16/2006 15:56'!
initialize
	"SqEtoysReferences initialize"
	default _ nil! !

!SqEtoysReferences methodsFor: 'accessing' stamp: 'mu 5/18/2006 16:27'!
objectAt: playerId put: obj
	^ objects at: playerId put: obj! !

!CMessageRowInViewer methodsFor: '*SqSquare-Core-scriptors-override' stamp: 'mu 6/2/2006 12:04'!
finishDraggingTile: aTile
	"The dragging of a tile torn off from the receiver."

	 | scriptor |
	"might be existing script"
	target scriptors do: [:oldScriptor | oldScriptor selector == aTile selector
		ifTrue: [oldScriptor openCenteredAt: hand position.
			^ aTile destroy]].

	"make new script"
	scriptor _ CScriptorTile new.
	scriptor receiver: target.
	scriptor chooseNewName.
	aTile selector == #emptyScript
		ifTrue:
			[aTile destroy]
		ifFalse:
			[scriptor statements add: aTile.
			(aTile elements detect: [:m | m isKindOf: CReceiverTileCostume] ifNone: [nil])
				ifNotNilDo:
					[:rcvrTile | rcvrTile  applyImplicitSelf].
			scriptor costume neutralizeBordersOf: aTile].

	scriptor receiver isOnAnyBoard ifTrue: [^scriptor attachToBoardFlap].
	scriptor dropAt: hand position in: self project world.
	scriptor openAt: self hand position.

	
! !

Error subclass: #SqError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Exceptions'!

SqError subclass: #SqOtherUserLoggedIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Exceptions'!

SqError subclass: #SqOutOfRange
	instanceVariableNames: 'range start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Exceptions'!

!SqOutOfRange class methodsFor: 'instance creation' stamp: 'MU 2/23/2006 14:56'!
from: start to: end actualFrom: originalStart to: originalEnd 
	^ self
		from: start
		to: end
		range: (Interval from: originalStart to: originalEnd)! !

!SqOutOfRange class methodsFor: 'instance creation' stamp: 'MU 2/23/2006 13:54'!
from: start to: end range: range 
	^ self new start: start;
		 end: end;
		 range: range;
		 yourself! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
end
	^end! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
end: index
	end _ index! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
range
	^range! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:16'!
range: interval
	range _ interval! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
start
	^start! !

!SqOutOfRange methodsFor: 'accessing' stamp: 'MU 2/7/2006 19:15'!
start: index
	start _ index! !

!CWindowCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:58'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CWindowCostume methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:58'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

!CPartPrecursor methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 4/24/2006 15:58'!
instance
	^ self propertyValueAt: #instance.
! !

!CPartPrecursor methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 4/24/2006 15:48'!
instance: aPlayer
	self propertyValueAt: #instance put: aPlayer.
! !

!CPartPrecursor methodsFor: '*SqSquare-Core-event-override' stamp: 'minami 4/24/2006 15:42'!
onDropped
	"Invoked when the receiver has been dropped in a container.  Create the actual object and transform the receiver into that objec.t"

	| theNewInstance |
	<on: dropAccept>
	(container == nil or: [partDescription == nil]) ifTrue: [^ self].  "Both have been seen..."
	theNewInstance _ partDescription newInstanceIn: container.
	container elements replace: self with: theNewInstance.
	theNewInstance position: self position. "keep scale"

	self instance: theNewInstance.

	self destroy "is necessary for terminating scripts etc?  probably not"! !

!Exception methodsFor: '*SqSquare-Core-logging' stamp: 'minami 1/17/2006 10:39'!
log
	SqUtil logError: self! !

!CObjectPart methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/27/2006 17:22'!
storeDataOn: aDataStream 
	| cntInstVars |
	cntInstVars := self writtenVarNames size.
	aDataStream beginInstance: self class size: cntInstVars.

	self writtenVarNames
		do: [:nm | 
			| rawValue | 
			rawValue := self instVarNamed: nm.
			self
				storeVariable: rawValue
				named: nm
				on: aDataStream]! !

!CObjectPart methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/1/2006 15:44'!
storeVariable: rawValue named: nm on: aDataStream 

	self flag: #todo. "can we omit some fields?"
	"nm = 'partMaker' ifTrue: [aDataStream nextPut: partMaker name]."

	aDataStream nextPut: rawValue! !

!CObjectPart methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/27/2006 17:20'!
writtenVarNames
	^self class  allInstVarNames! !

TMessageEncoder2 subclass: #SqEventEncoder
	instanceVariableNames: 'forStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

SqEventEncoder class
	instanceVariableNames: 'typeMap'!

!SqEventEncoder class methodsFor: 'class initialization' stamp: 'mu 5/19/2006 15:05'!
collectionTypeSpec
	^#(
		(Dictionary				encodeDictionary:			90)
		(IdentityDictionary				encodeIdentityDictionary:			91)
	) ! !

!SqEventEncoder class methodsFor: 'utilities' stamp: 'mu 5/19/2006 14:54'!
defineEventEncodeMethods
	"SqEventEncoder defineEventEncodeMethods"
	self eventTypeSpec
		do: [:each | SqEventEncoder
				compile: ('{1} anEvent
	stream nextPut: {2}.
	^self basicEncodeEvent: anEvent.' format: {each second. each third})
				classified: 'encoding-events']! !

!SqEventEncoder class methodsFor: 'class initialization' stamp: 'mu 5/19/2006 11:37'!
eventTypeSpec
	^#(
		(SqPlayerCreatedEvent				encodePlayerCreatedEvent:			101)
		(SqPlayerRemovedEvent				encodePlayerRemovedEvent:			102)
		(SqPlayerSelectedEvent				encodePlayerSelectedEvent:			103)

		(SqPlayerLockEvent				encodePlayerLockEvent:			104)
		(SqPlayerUnlockEvent				encodePlayerUnlockEvent:			105)

		(SqBorderChangedEvent	encodeBorderChangedEvent:			106)
		(SqDropAcceptEvent				encodeDropAcceptEvent:			107)
		(SqFillChangedEvent				encodeFillChangedEvent:			108)
		(SqFlagsChangedEvent				encodeFlagsChangedEvent:			109)
		(SqGeometryChangedEvent				encodeGeometryChangedEvent:			110)
		(SqGraphicChangedEvent				encodeGraphicChangedEvent:			111)
		(SqImageChangedEvent				encodeImageChangedEvent:			112)
		

		(SqPolygonStateChangedEvent				encodePolygonStateChangedEvent:			113)
		(SqRoundCornersChangedEvent				encodeRoundCornersChangedEvent:			114)
		(SqVerticesChangedEvent				encodeVerticesChangedEvent:			115)
		
		(SqUngroupEvent				encodeUngroupEvent:			116)
		
		(SqLabelChangedEvent				encodeLabelChangedEvent:			117)
		(SqTextChangedEvent				encodeTextChangedEvent:			118)
		(SqTextEditorStatusChangedEvent				encodeTextEditorStatusChangedEvent:			119)

		(SqGenericCommand				encodeGenericCommand:			120)

		(SqScriptModifiedEvent				encodeScriptModifiedEvent:			121)
		(SqScriptStatusChangedEvent				encodeScriptStatusChangedEvent:			122)

		(SqCursorPointChangedCommand				encodeCursorPointChangedCommand:			123)
		(SqCursorStyleChangedCommand				encodeCursorStyleChangedCommand:			124)

	) ! !

!SqEventEncoder class methodsFor: 'class initialization' stamp: 'mu 5/19/2006 11:05'!
initialize
	super initialize.
	self initTypeMap! !

!SqEventEncoder class methodsFor: 'class initialization' stamp: 'mu 5/19/2006 15:23'!
initTypeMap
	"SqEventEncoder initTypeMap"
	typeMap _ IdentityDictionary new.
	TypeMap
		ifNotNilDo: [:map | map
				keysAndValuesDo: [:k :v | typeMap at: k put: v]].

	{self primitiveTypeSpec. self collectionTypeSpec. self eventTypeSpec}
		do: [:eachSpec | eachSpec
				do: [:spec | 
					| cls | 
					cls _ Smalltalk classNamed: spec first.
					cls
						ifNotNil: [| sele | 
							sele _ spec second.
							"theCode := spec third."
							typeMap at: cls put: sele]]]! !

!SqEventEncoder class methodsFor: 'class initialization' stamp: 'mu 5/21/2006 19:17'!
primitiveTypeSpec
	^#(
		(SqUid				encodeSqUid:			80)
		(SqAccessId				encodeSqAccessId:			81)
		(SqPackedBytes				encodeSqPackedBytes:			82) "to be deleted - we can use Form, ColorForm"
		(TimeStamp				encodeTimeStamp:			83)
		(Form				encodeForm:			84)
		(ColorForm			encodeColorForm:			85)
	) ! !

!SqEventEncoder class methodsFor: 'accessing' stamp: 'mu 5/19/2006 12:04'!
typeMap
	typeMap ifNil: [self initTypeMap].
	^typeMap! !

!SqEventEncoder methodsFor: 'encoding' stamp: 'mu 6/5/2006 20:48'!
basicEncodeEvent: anEvent.
	self forStore ifTrue: [
		self encode: anEvent eventId.
		self encode: anEvent timeStamp.
	].
	self encode: anEvent targetId.
	self encode: anEvent accessId.
	self encode: anEvent arguments
	! !

!SqEventEncoder methodsFor: 'encoding' stamp: 'mu 6/5/2006 21:01'!
basicEncodeStaticEvent: anEvent
	self forStore ifTrue: [
		self encode: anEvent eventId.
		self encode: anEvent timeStamp.
	].
	self encode: anEvent targetId.
	self encode: anEvent accessId.
	self encode: anEvent argumentsAsArray
	! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeBorderChangedEvent: anEvent
	stream nextPut: 106.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-primitives' stamp: 'minami 6/5/2006 16:00'!
encodeColorForm: form
	| bytes |
	stream nextPut: 85.
	bytes _ form asCompactBytes compressIfMoreThan: SqSettings compressThreshold.
	self writeUnsigned: bytes size.
	stream nextPutAll: bytes! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/21/2006 19:23'!
encodeCursorPointChangedCommand: anEvent
	stream nextPut: 123.
	self encode: anEvent accessId.
	self encode: anEvent point.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/21/2006 19:26'!
encodeCursorStyleChangedCommand: anEvent
	stream nextPut: 124.
	self encode: anEvent accessId.
	self encode: anEvent style.! !

!SqEventEncoder methodsFor: 'encoding-collections' stamp: 'mu 5/19/2006 16:32'!
encodeDictionary: dict
	stream nextPut: 90.
	self writeUnsigned: dict size.
	dict keysAndValuesDo: [:k :v |
		self encode: k.
		self encode: v
	]! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 6/5/2006 21:49'!
encodeDropAcceptEvent: anEvent
	stream nextPut: 107.
	self forStore ifTrue: [self encode: anEvent eventId].
	self encode: anEvent targetId.
	self encode: anEvent accessId.
	self encode: anEvent distPlayer.
	self encode: anEvent targetPosition.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/23/2006 14:30'!
encodeFillChangedEvent: anEvent
	stream nextPut: 108.
	self basicEncodeStaticEvent: anEvent.
	self encode: anEvent alpha.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeFlagsChangedEvent: anEvent
	stream nextPut: 109.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-primitives' stamp: 'mu 5/21/2006 19:18'!
encodeForm: form
	| bytes |
	stream nextPut: 84.
	bytes _ form asCompactBytes compressIfMoreThan: SqSettings compressThreshold.
	self writeUnsigned: bytes size.
	stream nextPutAll: bytes! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/21/2006 19:31'!
encodeGenericCommand: anEvent
	stream nextPut: 120.
	self basicEncodeEvent: anEvent.
	self encode: anEvent selector.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/23/2006 14:30'!
encodeGeometryChangedEvent: anEvent
	stream nextPut: 110.
	self basicEncodeStaticEvent: anEvent


	! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeGraphicChangedEvent: anEvent
	stream nextPut: 111.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-collections' stamp: 'mu 5/19/2006 16:32'!
encodeIdentityDictionary: dict
	stream nextPut: 91.
	self writeUnsigned: dict size.
	dict keysAndValuesDo: [:k :v |
		self encode: k.
		self encode: v
	]! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeImageChangedEvent: anEvent
	stream nextPut: 112.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeLabelChangedEvent: anEvent
	stream nextPut: 117.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodePlayerCreatedEvent: anEvent
	stream nextPut: 101.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 6/5/2006 21:49'!
encodePlayerLockEvent: anEvent
	stream nextPut: 104.
	self forStore ifTrue: [self encode: anEvent eventId].
	self encode: anEvent targetId.
	self encode: anEvent accessId.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodePlayerRemovedEvent: anEvent
	stream nextPut: 102.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodePlayerSelectedEvent: anEvent
	stream nextPut: 103.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 6/5/2006 21:49'!
encodePlayerUnlockEvent: anEvent
	stream nextPut: 105.
	self forStore ifTrue: [self encode: anEvent eventId].
	self encode: anEvent targetId.
	self encode: anEvent accessId.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodePolygonStateChangedEvent: anEvent
	stream nextPut: 113.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeRoundCornersChangedEvent: anEvent
	stream nextPut: 114.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeScriptModifiedEvent: anEvent
	stream nextPut: 121.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeScriptStatusChangedEvent: anEvent
	stream nextPut: 122.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-primitives' stamp: 'mu 5/21/2006 19:18'!
encodeSqAccessId: aid
	stream nextPut: 81.
	stream nextPutAll: aid.! !

!SqEventEncoder methodsFor: 'encoding-primitives' stamp: 'mu 5/21/2006 19:18'!
encodeSqPackedBytes: packedBytes
	"to be deleted"
	stream nextPut: 82.
	self writeUnsigned: packedBytes size.
	stream nextPutAll: packedBytes! !

!SqEventEncoder methodsFor: 'encoding-primitives' stamp: 'mu 5/19/2006 15:38'!
encodeSqUid: uid
	stream nextPut: 80.
	stream nextPutAll: uid.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 6/6/2006 15:48'!
encodeTextChangedEvent: anEvent 
	stream nextPut: 118.
	self forStore
		ifTrue: [self encode: anEvent eventId.
			self encode: anEvent timeStamp].
	self encode: anEvent targetId.
	self encode: anEvent accessId.
	anEvent textEnabled
		ifTrue: [self encode: anEvent argumentsAsArray]
		ifFalse: [self encode: false]! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeTextEditorStatusChangedEvent: anEvent
	stream nextPut: 119.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-primitives' stamp: 'mu 5/21/2006 19:18'!
encodeTimeStamp: timeStamp
	stream nextPut: 83.
	self writeUnsigned: timeStamp asSeconds! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 5/19/2006 14:54'!
encodeUngroupEvent: anEvent
	stream nextPut: 116.
	^self basicEncodeEvent: anEvent.! !

!SqEventEncoder methodsFor: 'encoding-events' stamp: 'mu 6/5/2006 21:50'!
encodeVerticesChangedEvent: anEvent
	stream nextPut: 115.
	self forStore ifTrue: [self encode: anEvent eventId].
	self encode: anEvent targetId.
	self encode: anEvent accessId.
	self encode: (anEvent vertices collect: [:e | e asIntegerPoint]).! !

!SqEventEncoder methodsFor: 'encoding' stamp: 'mu 5/19/2006 11:39'!
encode: anObject
	"Encode the object"
	^self perform: (self typeMap at: anObject class ifAbsent:[#encodeObject:]) with: anObject! !

!SqEventEncoder methodsFor: 'accessing' stamp: 'mu 6/5/2006 20:48'!
forStore
	forStore ifNil: [forStore _ false].
	^forStore! !

!SqEventEncoder methodsFor: 'accessing' stamp: 'mu 6/5/2006 20:48'!
forStore: aBoolean
	forStore _ aBoolean! !

!SqEventEncoder methodsFor: 'accessing' stamp: 'mu 5/19/2006 11:02'!
typeMap
	^self class typeMap! !

!CMatrixTransform methodsFor: '*SqSquare-Core-objects from disk' stamp: 'MU 1/19/2006 17:10'!
byteSize
	^self basicSize * self bytesPerBasicElement! !

!CMatrixTransform methodsFor: '*SqSquare-Core-objects from disk' stamp: 'MU 1/19/2006 17:11'!
bytesPerBasicElement
	"Answer the number of bytes that each of my basic elements requires.
	In other words:
		self basicSize * self bytesPerBasicElement
	should equal the space required on disk by my variable sized representation."
	^4! !

!CMatrixTransform methodsFor: '*SqSquare-Core-objects from disk' stamp: 'MU 1/19/2006 17:11'!
restoreEndianness
	"This word object was just read in from a stream.  It was stored in Big Endian (Mac) format.  Swap each pair of bytes (16-bit word), if the current machine is Little Endian.
	Why is this the right thing to do?  We are using memory as a byteStream.  High and low bytes are reversed in each 16-bit word, but the stream of words ascends through memory.  Different from a Bitmap."

	| w b1 b2 b3 b4 |
	SmalltalkImage current  isLittleEndian ifTrue: [
		1 to: self basicSize do: [:i |
			w _ self basicAt: i.
			b1 _ w digitAt: 1.
			b2 _ w digitAt: 2.
			b3 _ w digitAt: 3.
			b4 _ w digitAt: 4.
			w _ (b1 << 24) + (b2 << 16) + (b3 << 8) + b4.
			self basicAt: i put: w.
		]
	].

! !

!StrikeFontSet methodsFor: '*SqSquare-Core' stamp: 'mu 3/6/2006 17:00'!
maxAscii

	^ fontArray first maxAscii
! !

!StrikeFontSet methodsFor: '*SqSquare-Core' stamp: 'mu 3/6/2006 17:01'!
minAscii

	^ fontArray first minAscii
! !

!CObject class methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/2/2006 17:12'!
fromCompactBytes: bytes
	| rawBytes parts |
	rawBytes _ bytes uncompressOnDemand.
	parts _ RmtStreamer unstream: rawBytes by: #default.
	^SqPlayerMaker fromParts: parts.
	! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:02'!
instVarFields
	"CObject instVarFields"
	^self classFields select: [:e | e isInstanceVariable]! !

!CObject class methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/20/2006 17:05'!
objectForDataStream: refStrm 
	self isUniClass
		ifTrue: [| dp | 
			dp := DiskProxy
						global: self originalTheNonMetaClassName
						selector: #uniClassFromOriginal:
						args: {{self originalTheNonMetaClassName. self classVersionID}}. 
			refStrm replace: self with: dp.
			^ dp]
		ifFalse: [^ super objectForDataStream: refStrm]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:03'!
regularFields
	"CObject regularFields"
	^self classFields select: [:e | e isRegularField]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:09'!
serializableInstVarFieldNames
	^self serializableInstVarFields collect: [:each | each name]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:03'!
serializableInstVarFields
	"CObject serializableInstVarFields"
	^self instVarFields select: [:e | e isSerializable]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:09'!
serializableRegularFieldNames
	^self serializableRegularFields collect: [:each | each name]! !

!CObject class methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 3/2/2006 14:04'!
serializableRegularFields
	"CObject serializableRegularFields"
	^self regularFields select: [:e | e isSerializable]! !

!CObject class methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/27/2006 16:02'!
uniClassFromOriginal: args 
	"{clsName clsId}"
	| clsName baseClass clsId existingUniClass |
	clsName := args first.
	baseClass := Smalltalk at: clsName asSymbol.
	clsId := args second.
	existingUniClass := baseClass findUniClass: clsId.
	existingUniClass
		ifNil: [| newUniClass | 
			newUniClass := baseClass newUniClass.
			newUniClass classVersionID: clsId.
			^ newUniClass].
	^ existingUniClass! !

!CObject methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/10/2006 16:11'!
asCompactBytes
	| parts |
	parts _ SqPlayerSerializer serialize: self.
	"parts inspect."
	^(RmtStreamer stream: parts by: #default) compressIfMoreThan: SqSettings compressThreshold
	! !

!CObject methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/17/2006 17:46'!
basicSetMyProperties: props
	myProperties _ props! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:31'!
enabledPropertyNames
	^ self propertyNames
		collect: [:e | e asLowercase]
		thenSelect: [:e | e endsWith: 'enabled']! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 15:45'!
enabledPropertyNamesFor: anSqEvent
	"override"
	^self enabledPropertyNames union: anSqEvent defaultEnabledPropertyNames! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 5/18/2006 16:01'!
justLoaded
	"do nothing by default"! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:00'!
loadProperty: propName to: newValue 
	self perform: (propName , ':') asSymbol with: newValue forReceive! !

!CObject methodsFor: '*SqSquare-Core-scripting' stamp: 'mu 5/18/2006 16:21'!
lookupRootDocument
	^nil! !

!CObject methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 6/1/2006 22:13'!
lookupSpec
	^self userDataAt: #lookupSpec! !

!CObject methodsFor: '*SqSquare-Core-scripting-override' stamp: 'mu 6/2/2006 16:28'!
lookupSpecFor: anObject
	"Answer a literal that can later be used to lookup anObject. See lookup:"
	self lookupScope ifNil: [SqWarning warnLog: 'No lookupScope?'. ^self ensureBoardLookupScope lookupSpecFor: anObject].
	^self lookupScope lookupSpecFor: anObject! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 14:57'!
mementoOtherProperties
	| props |
	props _ IdentityDictionary new.
	self mementoOtherPropertyKeys
		do: [:eachKey | props
				at: eachKey
				put: (self propertyValueAt: eachKey)].
	^ props! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 5/18/2006 17:03'!
mementoOtherPropertyKeys
	^#(scriptors #userData)! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 15:02'!
mementoRegularFieldKeys
	| theClass keys |
	theClass _ self class.
	keys _ Set new.
	[theClass == CProtoObject]
		whileFalse: [keys addAll: (theClass serializableRegularFields collect: [:e | e name]).
			theClass _ theClass superclass].
	^ keys! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/10/2006 14:55'!
mementoRegularFields
	| theClass props |
	theClass _ self class.
	props _ IdentityDictionary new.
	[theClass == CProtoObject]
		whileFalse: [theClass serializableRegularFields
				do: [:each | 
					| nm | 
					nm _ each name.
					props
						at: nm
						put: (self propertyValueAt: nm)].
			theClass _ theClass superclass].
	^props! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:38'!
nonNilProperties
	^ self properties
		select: [:each | (self getField: each) notNil]! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:38'!
nonNilPropertyNames
	^ self nonNilProperties
		collect: [:each | each name]! !

!CObject methodsFor: '*SqSquare-Core-accessing' stamp: 'MU 2/20/2006 16:44'!
objectId
	"TODO: use uuid?"
	^self identityHash! !

!CObject methodsFor: '*SqSquare-Core-serializing-override' stamp: 'mu 3/9/2006 16:04'!
postBuildWith: aMaker 
	"Do any necessary post-construction activity"
	myScripts
		ifNotNil: [myScripts
				do: [:each | each isPaused
						ifFalse: [each resumeScript]]]! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 5/18/2006 15:58'!
prepareToBeSaved
	"do nothing by default"! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:37'!
properties
	^ (self definedFields
		select: [:e | e isRegularField
				and: [e isSerializable]])
		! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:37'!
propertyNames
	"Returns all - override it for performance"
	^ self properties
		collect: [:each | each name]! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'mu 5/31/2006 12:55'!
propertyNamesFor: anSqEvent
	"override"
	^(self propertyNames union: anSqEvent defaultPropertyNames) asSortedCollection asArray! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 5/18/2006 16:01'!
readMementoFieldsFrom: deserializer
	"Entry of SqPlayerDeserializer"
	self readMementoFixedFieldsFrom: deserializer.
	self readMementoPropertiesFrom: deserializer.

	self justLoaded

	! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/27/2006 14:53'!
readMementoFixedFieldsFrom: deserializer
	| memento |
	memento := deserializer readField: #scripts.
	memento ifNotNil: [myScripts := memento]
	 ! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 15:17'!
readMementoOtherProperties: mementoOtherProperties on: deserializer 

	mementoOtherProperties
		at: #scriptors
		put: (self
				scriptorsFromMemento: (mementoOtherProperties at: #scriptors)).

	mementoOtherProperties
		keysAndValuesDo: [:k :v | self propertyValueAt: k put: v]! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 15:13'!
readMementoPropertiesFrom: deserializer
	| mementoRegularFields mementoOtherProperties |
	mementoRegularFields _ IdentityDictionary new.
	self mementoRegularFieldKeys
		do: [:each | 
			| memento | 
			memento _ deserializer readField: each.
			mementoRegularFields at: each put: memento].
	self readMementoRegularFields: mementoRegularFields on: deserializer.

	mementoOtherProperties _ IdentityDictionary new.
	self mementoOtherPropertyKeys
		do: [:each | 
			| memento | 
			memento _ deserializer readField: each.
			mementoOtherProperties at: each put: memento].
	self readMementoOtherProperties: mementoOtherProperties on: deserializer! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 15:14'!
readMementoRegularFields: mementoRegularFields on: deserializer 

	mementoRegularFields
		keysAndValuesDo: [:k :v | self propertyValueAt: k put: v]! !

!CObject methodsFor: '*SqSquare-Core-scripting' stamp: 'mu 5/11/2006 12:04'!
recompileScriptNode: aMethodNode
	"I'm already uniclass, so omit becomeUniClass"

	| newMethod |
	newMethod _ aMethodNode generate: #(0 0 0 0).
	self class addSelectorSilently: aMethodNode selector withMethod: newMethod.
	self synchronousSignal: #scriptModified with: aMethodNode selector with: aMethodNode.
	^ aMethodNode selector! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 16:10'!
saveProperty: propName into: dictionary 
	| val |
	val _ self perform: propName.
	dictionary at: propName put: val forSend.
	^val! !

!CObject methodsFor: '*SqSquare-Core-scripting' stamp: 'mu 5/18/2006 16:21'!
scriptorFromSource: aSourceString 
	| tile |
	tile _ ODFCScriptBuilder player: self source: aSourceString on: self lookupRootDocument.
	^tile ! !

!CObject methodsFor: '*SqSquare-Core-maker-helper' stamp: 'mu 3/7/2006 14:29'!
scriptorsFromMemento: scriptorsMem 
	^ scriptorsMem
		ifNotNilDo: [:mem | 
			| tiles | 
			tiles _ mem
						collect: [:each | self scriptorFromSource: each].
			tiles do: [:each | self recompileScriptNode: each asParseNode].
			tiles]! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 15:46'!
wantsReturnEnabledPropertyNames
	^false! !

!CObject methodsFor: '*SqSquare-Core-properties' stamp: 'MU 2/16/2006 14:52'!
wantsReturnPropertyNames
	^false! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 5/18/2006 15:57'!
writeMementoFieldsOn: serializer
	"Entry of SqPlayerSerializer"
	self prepareToBeSaved.
	self writeMementoFixedFieldsOn: serializer.
	self writeMementoPropertiesOn: serializer! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 12:22'!
writeMementoFixedFieldsOn: serializer
	serializer writeField: #scripts value: myScripts.! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 6/2/2006 10:34'!
writeMementoOtherProperties: otherProperties on: serializer 
	otherProperties
		at: #scriptors
		put: (self scriptors
				collect: [:each | 
					| str | 
					str _ each asParseNode asString.
					str]).
	otherProperties
		keysAndValuesDo: [:k :v | serializer writeField: k value: v]! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:56'!
writeMementoPropertiesOn: aSerializer 
	"By default, write all serializable regular fields + other properties"
	
	self writeMementoRegularFields: self mementoRegularFields on: aSerializer.
	self writeMementoOtherProperties: self mementoOtherProperties on: aSerializer! !

!CObject methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/10/2006 14:39'!
writeMementoRegularFields: fieldMementoProperties on: serializer 
	"By default, writes all fields, - override -"

	fieldMementoProperties
		keysAndValuesDo: [:k :v | serializer writeField: k value: v]! !

CObject subclass: #SqSelectionHighlight
	instanceVariableNames: 'highlightColor color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Board'!

SqSelectionHighlight defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field instanceVariable="true" toGet="highlightColor" toSet="highlightColor:">highlightColor</field>
	<field instanceVariable="true" toGet="color" toSet="color:">color</field>
</fields>'!

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:28'!
color
	"Answer the color of the receiver"
	^color! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:28'!
color: aValue
	"Modify the receiver's color"
	color := aValue! !

!SqSelectionHighlight methodsFor: 'defaults' stamp: 'minami 1/19/2006 10:31'!
defaultHighlightColor
	^Color red! !

!SqSelectionHighlight methodsFor: 'drawing' stamp: 'minami 1/18/2006 17:44'!
drawOn: aCanvas in: drawingBounds
	| c vExtent hExtent b |
	c _ self color.
	vExtent _ 2@20.
	hExtent _ 20@2.
	b := self targetBounds.

	aCanvas fillRectangle: (b topLeft extent: vExtent) color: c.
	aCanvas fillRectangle: (b topLeft extent: hExtent) color: c.

	aCanvas fillRectangle: (b topRight - (2@0) extent: vExtent) color: c.
	aCanvas fillRectangle: (b topRight - (20@0) extent: hExtent) color: c.

	aCanvas fillRectangle: (b bottomLeft - (0@20) extent: vExtent) color: c.
	aCanvas fillRectangle: (b bottomLeft - (0@2) extent: hExtent) color: c.

	aCanvas fillRectangle: (b bottomRight - (2@20) extent: vExtent) color: c.
	aCanvas fillRectangle: (b bottomRight - (20@2) extent: hExtent) color: c.
! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:31'!
highlightColor
	highlightColor ifNil: [highlightColor _ self defaultHighlightColor].
	^highlightColor! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:28'!
highlightColor: aValue
	"Modify the receiver's highlightColor"
	highlightColor := aValue! !

!SqSelectionHighlight methodsFor: 'initializing' stamp: 'minami 4/13/2006 14:43'!
initialize
	super initialize.
	
	self color: self highlightColor.
	! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/19/2006 10:32'!
lighterColor
	^self color alpha: 0.5! !

!SqSelectionHighlight methodsFor: 'events' stamp: 'minami 1/19/2006 10:32'!
onTick
	<ticking: 1>

	self color: (
		self color = self highlightColor
			ifTrue:[self lighterColor]
			ifFalse:[self highlightColor]).
! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/18/2006 11:02'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!SqSelectionHighlight methodsFor: 'private' stamp: 'minami 1/18/2006 16:54'!
targetBounds
	^ self target bounds expandBy: 3! !

!SqSelectionHighlight methodsFor: 'accessing' stamp: 'minami 1/18/2006 11:02'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CObject subclass: #SqTestDef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Tests'!

SqTestDef defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="a" toSet="a:" changeEvent="aChanged">a</field>
	<field toGet="b" toSet="b:" changeEvent="bChanged">b</field>
	<field toGet="c" toSet="c:" changeEvent="cChanged">c</field>
	<field toGet="v" toSet="v:" changeEvent="vChanged">v</field>
</fields>'!

!SqTestDef class methodsFor: 'adding fields' stamp: 'MU 2/9/2006 11:44'!
example1
	"self example1"
	[#('a' 'b' 'c' )
		do: [:each | self addField: each]] on: Error do: [:ex]! !

!SqTestDef class methodsFor: 'adding fields' stamp: 'MU 2/9/2006 12:00'!
example2
	"self example2"
	| existingFields fields |
	existingFields _ self classFields collect: [:e | e name].
	fields _ #('a' 'b' 'c').

	fields do: [:each | 
		(existingFields includes: each) ifFalse: [self addField: each]]	
	! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
a
	"Answer the a of the receiver"
	<bewareOf: #aChanged>
	^self propertyValueAt: #a! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
a: aValue
	"Modify the receiver's a"
	^self propertyValueAt: #a put: aValue with: #aChanged! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
b
	"Answer the b of the receiver"
	<bewareOf: #bChanged>
	^self propertyValueAt: #b! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
b: aValue
	"Modify the receiver's b"
	^self propertyValueAt: #b put: aValue with: #bChanged! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
c
	"Answer the c of the receiver"
	<bewareOf: #cChanged>
	^self propertyValueAt: #c! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
c: aValue
	"Modify the receiver's c"
	^self propertyValueAt: #c put: aValue with: #cChanged! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
v
	"Answer the v of the receiver"
	<bewareOf: #vChanged>
	^self propertyValueAt: #v! !

!SqTestDef methodsFor: 'accessing' stamp: 'MU 2/9/2006 12:00'!
v: aValue
	"Modify the receiver's v"
	^self propertyValueAt: #v put: aValue with: #vChanged! !

!TScriptEvent methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 6/1/2006 11:53'!
signaler
	^ signaler! !

!TScriptEvent methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 6/1/2006 11:53'!
signaler: aSymbol
	signaler := aSymbol! !

RmtAcceptor subclass: #SqAcceptor
	instanceVariableNames: 'handler accessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

SqAcceptor class
	instanceVariableNames: 'handler'!

!SqAcceptor class methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:34'!
handler
	handler ifNil: [handler _ [:msg | ]].
	^handler ! !

!SqAcceptor class methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:30'!
handler: aBlock
	handler _ aBlock! !

!SqAcceptor methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:13'!
accessId
	^accessId! !

!SqAcceptor methodsFor: 'accessing' stamp: 'minami 1/13/2006 14:13'!
accessId: aSqAccessId
	accessId _ aSqAccessId! !

!SqAcceptor methodsFor: 'converting' stamp: 'mu 12/28/2005 20:11'!
asConnector
	^SqConnector with: self socket! !

!SqAcceptor methodsFor: 'accessing' stamp: 'minami 1/28/2006 09:09'!
boardId
	^ self accessId boardId! !

!SqAcceptor methodsFor: 'receiving' stamp: 'mu 3/13/2006 11:44'!
handleReceived: messageObject
	messageObject displayForDebug: 2.
	^self handler value: messageObject! !

!SqAcceptor methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:34'!
handler
	handler ifNil: [handler _ self class handler].
	^handler! !

!SqAcceptor methodsFor: 'accessing' stamp: 'mu 12/28/2005 19:34'!
handler: aBlock
	handler _ aBlock! !

!SqAcceptor methodsFor: 'initialize-release' stamp: 'mu 12/28/2005 18:30'!
initialize
	super initialize.
	handler _ [:msg | ]! !

!SqAcceptor methodsFor: 'factory' stamp: 'minami 1/12/2006 12:17'!
messageClass
	^SqMessage! !

!SqAcceptor methodsFor: 'receiving' stamp: 'mu 3/17/2006 12:36'!
process: message 
	message type == #negotiate
		ifTrue: [^ self accessId: message restoreObject].
	super process: message! !

!CProjectBuilder methodsFor: '*SqSquare-Core-halo-menu' stamp: 'minami 4/12/2006 16:42'!
addCustomeMenuItems: target to: aMenu
	target addCustomeMenuItemsTo: aMenu! !

!CProjectBuilder methodsFor: '*SqSquare-Core-halo-menu-override' stamp: 'minami 4/12/2006 16:42'!
getHaloMenu: haloTarget
	"Create and answer a halo menu for the given halo target"

	| menu aMenu item |
	menu := CMenu new.
	menu label: (haloTarget name truncateTo: 30).
	item := menu add: 'inspect' target: haloTarget action: #inspect.
	item balloonHelp: 'Inspect this object'.
	aMenu := self getSaveCostumeMenu: haloTarget.
	aMenu ifNotNil:[menu add: 'save costume for' subMenu: aMenu].
	"aMenu := haloTarget getMessageMenu.
	aMenu label: nil.
	menu add: 'messages' subMenu: aMenu.
	menu addSeparator."

	item := menu add: 'tile for player' target: self
		action: #getTileForPlayer: argument: haloTarget.
	item balloonHelp: 'Hand me a tile for this object'.
	item := menu add: 'tile for value' target: self
		action: #getTileForValue: argument: haloTarget.
	item balloonHelp:'Hand me a tile for this object''s value'.
	item := menu add: 'grab me' target: self 
		action: #grabObject: argument: haloTarget.
	item balloonHelp:'Grab this object'.
	item := menu add: 'repaint' target: CPainter
		action: #openOnTarget: argument: haloTarget.
	item balloonHelp:'Repaint this object''s graphic'.
	menu addSeparator.

	menu add: 'send to back' target: self 
		action: #sendToBack: argument: haloTarget.
	menu add: 'come to front' target: self 
		action: #sendToFront: argument: haloTarget.

	self addEmbeddingItems: haloTarget to: menu.
	"CStack addStackItems: haloTarget to: menu."
	menu addSeparator.

	"self addFactoryItemsTo: menu."
	self addLayoutMenuItems: haloTarget to: menu.
	menu add: 'edit scripts' target: haloTarget action: #openScriptEditor.
	menu addSeparator.
	menu add: 'how to build this' target: haloTarget action: #openHowToBuild.
	item _ menu add: 'add to parts bin' target: haloTarget action: #addToPartsBin.
	item balloonHelp: 'Add this object to the parts bin.  The effect will be that you can drag fresh copies of it out of any parts bin at any time in the future.  The item will initially appear in the "unclassified" category, but you can subsequently move it anywhere you wish.'.
	menu addSeparator.
	menu add: '[debug] explore' target: haloTarget action: #explore.
	Smalltalk at: #CHeartbeat ifPresent: [:heartbeat |
		menu add: '[debug] events' target: heartbeat
			action: #openHeartbeatOn: argument: haloTarget].
	self addDebugItems: haloTarget to: menu.

	menu menuItems addAll: ((haloMenuItems collect:[ :each | 
		| newItem |  
		newItem := each copy.  "should be shallowCopy, but properties are not shallowCopied yet"
		newItem action: (newItem action shallowCopy arguments: {haloTarget.}).
		newItem]) sort: [ :a :b | a label <= b label ]).

	self addCustomeMenuItems: haloTarget to: menu.

	^menu! !

!CProjectBuilder methodsFor: '*SqSquare-Core-override' stamp: 'mu 3/2/2006 10:19'!
initialize
	super initialize.
	self allProjects: CCollection new.
	projectShell := self projectShellClass new.
	projectList := self newProjectList.
	self newProject.
	worldMenu := CMenuBar new. "will be clobbered immediately"
	self startScript: #installWorldMenu.! !

CProjectBuilder subclass: #SqProjectBuilder
	instanceVariableNames: 'compositePanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Project'!

SqProjectBuilder defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" toGet="compositePanel" toSet="compositePanel:" color="FFFF00">compositePanel</field>
</fields>'!

!SqProjectBuilder class methodsFor: 'examples' stamp: 'minami 1/20/2006 12:33'!
exOpen
"
	SqProjectBuilder exOpen
"
	SqProjectMorph open: SqProjectBuilder.! !

!SqProjectBuilder methodsFor: 'accessing' stamp: 'mu 4/20/2006 16:11'!
compositePanel
	"Answer the compositePanel of the receiver"
	compositePanel ifNil: [self openCompositePanel].
	^compositePanel! !

!SqProjectBuilder methodsFor: 'accessing' stamp: 'mu 4/20/2006 15:56'!
compositePanel: aValue
	"Modify the receiver's compositePanel"
	compositePanel := aValue! !

!SqProjectBuilder methodsFor: 'private-opening' stamp: 'minami 5/26/2006 17:08'!
openCompositePanel
	compositePanel _ projectShell myIsland new: SqBoardCompositePanel.
	"tricky... need to create text in project's island"
	self waitTick.
	compositePanel sticky: true.
	compositePanel extent: self world extent - 10.
	compositePanel openAt: 0@0.
! !

!SqProjectBuilder methodsFor: 'initializing' stamp: 'minami 1/20/2006 12:25'!
projectShellClass
	^ SqProjectShell! !

!SqProjectBuilder methodsFor: 'opening' stamp: 'mu 4/21/2006 17:18'!
setUpBoardCompositePanel
	self compositePanel loginAndSelectBoard.
	self uiBuilder projectBuilder: self! !

!SqProjectBuilder methodsFor: 'opening' stamp: 'mu 4/20/2006 15:55'!
showInitialStuff
	super showInitialStuff.

	self setUpBoardCompositePanel! !

!SqProjectBuilder methodsFor: 'accessing' stamp: 'mu 4/19/2006 17:13'!
uiBuilder
	^SqUIBuilder default! !

!CPrimitiveCostume class methodsFor: '*SqSquare-Core-serialization' stamp: 'mu 3/2/2006 12:01'!
readSnapshotByteArray: bytes

	^SqProjectSerializer deserialize: bytes! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-controlling' stamp: 'minami 2/14/2006 13:20'!
detachBoardProperties
	contents size to: 1 by: -1 do:[:i |
		| cos p |
		cos := contents at: i.
		p :=cos player.
		p detachBoardProperties.
		p hasPlayer ifTrue: [p player detachBoardProperties].
	].
! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-geometry-parent' stamp: 'minami 2/20/2006 16:27'!
direction: aPoint
	"Indicate the new direction for the receiver"
	| oldDirection newDirection sin cos angle |
	oldDirection := self direction.
	"Compute the delta angle between current and new heading"
	newDirection := [aPoint normalized] on: ZeroDivide do:[:ex| ex return: nil].
	newDirection ifNil:[^oldDirection].

	sin := oldDirection crossProduct: newDirection.
	cos := oldDirection dotProduct: newDirection.

	(sin closeTo: 1.0) ifTrue: [sin := 1.0].
	(cos closeTo: 1.0) ifTrue: [cos := 1.0].

	angle := cos arcCos radiansToDegrees.
	sin < 0.0 ifTrue:[angle := angle negated].
	self rotateBy: angle.
	^aPoint! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-finding' stamp: 'minami 10/26/2005 11:01'!
findPlayerAt: aPoint but: rejectBlockWithOneArg
	"Search the receiver to find the first player located at the given position."
	| aCostume |
	(self containsPoint: aPoint) ifFalse:[^ nil].
	contents size to: 1 by: -1 do:[:i |
		aCostume := contents at: i.
		((aCostume fullContainsPoint: aPoint) 
			and: [(rejectBlockWithOneArg value: aCostume player) not])
			ifTrue: [^ aCostume player].
	].
	^nil! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-finding' stamp: 'minami 5/23/2006 14:28'!
findPlayerByUid: squid
	contents size to: 1 by: -1 do:[:i |
		| cos p |
		cos := contents at: i.
		p :=cos player.
		(p playerId) = squid ifTrue: [^ p].
		p hasPlayerOrElements ifTrue: [(p rootPlayer findPlayerByUid: squid) ifNotNilDo: [:pp | ^ pp]].
	].
	^nil! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-finding' stamp: 'minami 4/14/2006 16:54'!
findPlayerOf: clazz at: aPoint 

	| aCostume root |
	(self containsPoint: aPoint) ifFalse:[^nil].

	contents size to: 1 by: -1 do:[:i|
		aCostume := contents at: i.
		((aCostume fullContainsPoint: aPoint) and: [(root := aCostume rootPlayer) isKindOf: clazz]) ifTrue: [^ root].
	].
	^nil! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-testing' stamp: 'minami 12/19/2005 15:24'!
hasPlayer
	^ self player notNil! !

!CPrimitiveCostume methodsFor: '*SqSquare-Core-accessing' stamp: 'minami 4/14/2006 16:49'!
rootPlayer
	| current |
	current := self player.
	current ifNil: [^ nil].

	[current hasPlayer] whileTrue: [
		current := current player.
	].
	^ current

! !

!Form methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/15/2006 17:46'!
forSend
	^SqPackedBytes fromObject: self! !

!CCostumeFill methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
readMementoFieldsFrom: deSerializer
	self readFieldsFrom: deSerializer! !

!CCostumeFill methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

!CScriptorTile methodsFor: '*SqSquare-Core-actions' stamp: 'mu 6/2/2006 12:00'!
attachToBoardFlap

	self receiver eventRecordBoard ifNotNilDo: [:bo |
		bo openFlapWithScriptor: self.
	]! !

!CScriptorTile methodsFor: '*SqSquare-Core-actions' stamp: 'mu 6/2/2006 11:18'!
open: aPlayer in: aContainer at: aPoint

	self receiver isOnAnyBoard ifTrue: [^self attachToBoardFlap].

	super open: aPlayer in: aContainer at: aPoint
	
	! !

!CScriptorTile methodsFor: '*SqSquare-Core-accessing' stamp: 'mu 5/16/2006 14:50'!
playerIds
	^self asParseNode encoder playerIds! !

ODFDocument subclass: #SqDummyDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Common'!

!SqDummyDocument class methodsFor: 'instance creation' stamp: 'mu 5/18/2006 16:29'!
on: lookupScopeDict
	| inst |
	inst _ self new.
	inst loadLookupScope: lookupScopeDict.
	^inst ! !

!SqDummyDocument methodsFor: 'initialization' stamp: 'mu 5/18/2006 16:24'!
initialize
	super initialize.
	references := SqEtoysReferences new.
	references parent: self.
	! !

!SqDummyDocument methodsFor: 'actions' stamp: 'mu 6/2/2006 11:41'!
loadLookupScope: scopeDic 
	scopeDic ifNil: [^self].
	scopeDic array ifNil: [^self].
	scopeDic
		keysAndValuesDo: [:k :v | self references objectAt: k put: v]! !

!SqDummyDocument methodsFor: 'accessing' stamp: 'mu 5/18/2006 16:25'!
references
	^references! !

!ArrayedCollection methodsFor: '*SqSquare-Core-copying' stamp: 'MU 2/16/2006 12:42'!
copyWithAll: col
	^self copyReplaceFrom: self size + 1
		  to: self size
		  with: col! !

!ArrayedCollection methodsFor: '*SqSquare-Core-testing' stamp: 'MU 2/27/2006 17:35'!
isAssociationCollection
	^self allSatisfy: [:each | each isAssociation]! !

!ArrayedCollection methodsFor: '*SqSquare-Core-copying' stamp: 'MU 2/16/2006 13:28'!
union: col
	^(super union: col) asArray! !

!TickMessageSend methodsFor: '*SqSquare-Core-accessing-override' stamp: 'minami 5/23/2006 16:59'!
isTickMessageSend
	^ true! !

!TickMessageSend methodsFor: '*SqSquare-Core-accessing-override' stamp: 'minami 5/9/2006 16:37'!
resumeScript
	super resumeScript.
	myProcess ifNil:[
		myProcess := receiver startScript: #runTicking:at: withArguments:{self. frequency}.
		myProcess := myProcess message.
	].
	receiver signal: #scriptStatusChanged with: selector with: #resumed.! !

!TickMessageSend methodsFor: '*SqSquare-Core-TweakPatch' stamp: 'mu 6/1/2006 12:14'!
trigger
	^myTrigger! !

!TickMessageSend methodsFor: '*SqSquare-Core-TweakPatch' stamp: 'mu 6/1/2006 12:14'!
trigger: aTrigger
	myTrigger := aTrigger.! !

!AsyncScriptMessageSend methodsFor: '*SqSquare-Core-serialization' stamp: 'MU 2/13/2006 14:38'!
storeDataOn: aDataStream 
	myIsland := nil.
	super storeDataOn: aDataStream! !

!AsyncScriptMessageSend methodsFor: '*SqSquare-Core-TweakPatch' stamp: 'mu 6/1/2006 12:11'!
trigger
	^myTrigger! !

!AsyncScriptMessageSend methodsFor: '*SqSquare-Core-TweakPatch' stamp: 'mu 6/1/2006 12:11'!
trigger: aTrigger
	myTrigger := aTrigger.! !

!Rectangle methodsFor: '*SqSquare-Core-connector' stamp: 'minami 11/1/2005 12:56'!
intersectionWithLineSegmentFromCenterTo: aPoint 
	"Answer the point, if any, along my border that intersects the  
	line segment between my center and aPoint. Return aPoint if  
	aPoint is inside me or is on my border, else a computed point  
	somewhere along my border."

	| seg |
	(self containsPoint: aPoint)
		ifTrue: [^ aPoint].
	"Answer the set of intersections, if any"
	seg _ LineSegment from: self center to: aPoint.
	self lineSegmentsDo: [ :p1 :p2 | | side int |
		side _ LineSegment from: p1 to: p2.
		int _ side intersectionWith: seg.
		int ifNotNil: [ ^int ].
	].

	^(self center + aPoint) // 2
! !

!Rectangle methodsFor: '*SqSquare-Core-connector' stamp: 'minami 11/1/2005 13:01'!
lineSegmentsDo: aBlock
	"Evaluate aBlock with the receiver's line segments"
	| p |
	aBlock value: origin value: (p _ self topRight).
	aBlock value: p value: corner.
	aBlock value: corner value: (p _ self bottomLeft).
	aBlock value: p value: origin.! !

!LineSegment methodsFor: '*SqSquare-Core-connector' stamp: 'minami 11/1/2005 12:56'!
intersectionWith: anotherSegment
	"Copied from LineIntersections>>intersectFrom:to:with:to:"
	| det deltaPt alpha beta pt1Dir pt2Dir |
	pt1Dir _ end - start.
	pt2Dir _ anotherSegment end - anotherSegment start.
	det _ (pt1Dir x * pt2Dir y) - (pt1Dir y * pt2Dir x).
	deltaPt _ anotherSegment start - start.
	alpha _ (deltaPt x * pt2Dir y) - (deltaPt y * pt2Dir x).
	beta _ (deltaPt x * pt1Dir y) - (deltaPt y * pt1Dir x).
	det = 0 ifTrue:[^nil]. "no intersection"
	alpha * det < 0 ifTrue:[^nil].
	beta * det < 0 ifTrue:[^nil].
	det > 0 
		ifTrue:[(alpha > det or:[beta > det]) ifTrue:[^nil]]
		ifFalse:[(alpha < det or:[beta < det]) ifTrue:[^nil]].
	"And compute intersection"
	^start + (alpha * pt1Dir / (det@det))! !

!CDropShadowHighlight methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:54'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CDropShadowHighlight methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:54'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

CObjectMakerDeserializer subclass: #SqPlayerDeserializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Serializer'!

!SqPlayerDeserializer methodsFor: 'reading' stamp: 'mu 3/2/2006 16:13'!
readContentsOf: anObject
	^anObject readMementoFieldsFrom: self! !

TdTimer subclass: #SqConnectionKeeper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqConnectionKeeper class methodsFor: 'constants' stamp: 'minami 1/13/2006 11:07'!
defaultIntervalSeconds
	^ 10! !

!SqConnectionKeeper class methodsFor: 'constants' stamp: 'minami 1/13/2006 11:07'!
defaultPriority
	^ Processor userBackgroundPriority! !

!SqConnectionKeeper methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:34'!
boardClients
	boardClients ifNil: [boardClients _ Set new].
	^boardClients! !

!SqConnectionKeeper methodsFor: 'actions' stamp: 'mu 4/7/2006 16:13'!
keepConnections
	SqClient clients do: [:c | c keepConnections]! !

!SqConnectionKeeper methodsFor: 'actions' stamp: 'mu 3/8/2006 11:37'!
perform
	self keepConnections! !

TdTimer subclass: #SqConnectionTrimmer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Core-Network-Connections'!

!SqConnectionTrimmer class methodsFor: 'constants' stamp: 'minami 1/13/2006 14:42'!
defaultIntervalSeconds
	^ 10! !

!SqConnectionTrimmer class methodsFor: 'constants' stamp: 'minami 1/13/2006 14:42'!
defaultPriority
	^ Processor userBackgroundPriority! !

!SqConnectionTrimmer methodsFor: 'actions' stamp: 'mu 3/8/2006 11:36'!
perform
	self trimConnections! !

!SqConnectionTrimmer methodsFor: 'actions' stamp: 'MU 1/20/2006 17:14'!
trimConnections
	SqPassiveConnection closeUnconnected! !

!UUID methodsFor: '*SqSquare-Core-converting' stamp: 'MU 2/8/2006 14:58'!
asUUID
	^self! !

!EToysWorld methodsFor: '*SqSquare-Core-experimental' stamp: 'minami 4/7/2006 14:10'!
onRedButtonDown: evt
	| draggee |	

	<on: redButtonDown>
	evt shiftPressed ifFalse: [^ self].
	draggee := self findDraggablePlayerAt: self cursorPoint.
draggee ifNotNil: [draggee inspect].
	draggee ifNotNil: [^ self].

	self mouseCursor: Cursor normal.
	^ self startSelection: evt.
! !

!EToysWorld methodsFor: '*SqSquare-Core-experimental' stamp: 'minami 4/6/2006 14:33'!
startSelection: evt 
	| sp |
	sp := SqSelectionPlayer new
		addResizeHandle;
		extent: 10@10;
		center: evt position;
		yourself.
	self add: sp.
	self waitTick.

	self hand attach: sp resizeHandle
! !

!CCostumeGraphic methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostumeGraphic methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:51'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !

!CCostumeBorder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:50'!
readMementoFieldsFrom: aSerializer
	self readFieldsFrom: aSerializer! !

!CCostumeBorder methodsFor: '*SqSquare-Core-maker' stamp: 'mu 3/7/2006 11:50'!
writeMementoFieldsOn: aSerializer
	self writeFieldsOn: aSerializer! !
SqPassiveConnection initialize!
SqImageId initialize!
SqPlayerEventFactory initialize!
SqUidMaker initialize!
SqSheetPlayer initialize!
SqLineConnector initialize!
SqToolBar initialize!
SqEventDecoder initialize!
SqMessage initialize!
SqUtil initialize!
SqSettings initialize!
SqEtoysReferences initialize!
SqEventEncoder initialize!
